function returnMembers() {
  return {
    canLoadMore: true,
    members: [
      {
        'id': 'john.doe@wickes.co.uk',
        'name': 'John Doe',
        'email': 'john.doe@wickes.co.uk',
        'date': '24/02/2022',
        'order-history-url': 'page_tradePro_order-history.html',
        'status': 'PENDING',
        'label': 'Pending'
      },
      {
        'id': 'john.doe2@wickes.co.uk',
        'name': 'John Doe2',
        'email': 'john.doe2@wickes.co.uk',
        'date': '24/02/2022',
        'order-history-url': 'page_tradePro_order-history.html',
        'label': 'Other label'
      },
      {
        'id': 'john.doe3@wickes.co.uk',
        'name': 'John Doe3',
        'email': 'john.doe3@wickes.co.uk',
        'date': '24/02/2022',
        'order-history-url': 'page_tradePro_order-history.html',
      }
    ],
  };
}

function initAccountHubFunctionality() {
  Wick.AccountHub.initAccountHub();
  Wick.AccountHub.initAccountHubRemove();

  $(window).on(Wick.AccountHub.LOAD_MORE_EVENT, function (e) {
    setTimeout(() => {
      e.detail.resolve(returnMembers());
    }, 1000);
  });
}

$(document).ready(function () {
  if (!$('.account-hub').length) {
    return;
  }

  initAccountHubFunctionality();
});

const ALREADY_EXIST_EMAIL = 'fe@wickes.co.uk';
const ALREADY_EXIST_EMAIL_IN_ANOTHER_ACCOUNT = 'mad.fe@wickes.co.uk';
const MEMBERS_LIMIT = 10;

function returnExistEmailError() {
  return {
    message: 'Member already exists'
  };
}

function returnExistEmailInAnotherAccountError() {
  return {
    message: 'Member already exists in another Business Account'
  };
}

function initAccountMembersFunctionality() {
  if (!$('.add-members').length) {
    return;
  }

  Wick.AccountMembers.init({membersLimit: MEMBERS_LIMIT});

  $(window).on(Wick.AccountMembers.VERIFY_EMAIL_EVENT, function (e) {
    setTimeout(() => {
      if (e.detail.payload.email === ALREADY_EXIST_EMAIL) {
        e.detail.reject(returnExistEmailError());
      } else if (e.detail.payload.email === ALREADY_EXIST_EMAIL_IN_ANOTHER_ACCOUNT) {
        e.detail.reject(returnExistEmailInAnotherAccountError());
      } else {
        e.detail.resolve();
      }
    }, 1000);
  });
}

$(document).ready(function () {
  initAccountMembersFunctionality();
});

const validProjectListId = ['45d94c37-06b1-4961-9fae-89d9082bc97b', 'AAA123456', 'AA123456'];
function initAddProjectListId () {
  if (!Wick?.AddProjectListId?.ADD_PROJECT_LIST_EVENT) {
    return;
  }

  $(window).on(Wick.AddProjectListId.ADD_PROJECT_LIST_EVENT, function ({ detail: { resolve, reject, payload }}) {
    setTimeout(() => {
      if (validProjectListId.includes(payload.projectEntryId)) {
        resolve({redirectUrl: parseUrl('page_checkout_merge-basket-with-energy.html')});
      } else {
        reject({errorMessage: 'Project list not found'})
      }
    }, 500);
  });
};

function parseUrl (url) {
  const currentPath = window.location.pathname;
  return currentPath.substring(0, currentPath.lastIndexOf("/")) + `/${url}`;
}

$(document).ready(function () {
  initAddProjectListId();
});

var Wick = Wick || {};

Wick.addToAnyCustomisation = {
  init: function () {
    const a2a_config = window.a2a_config || {};
    a2a_config.callbacks = a2a_config.callbacks || [];
    a2a_config.callbacks.push({
      share: this.addToAnyOnShare
    });
    window.a2a_config = a2a_config;
  },

  addToAnyOnShare: function (data) {
    if (data.service === 'Pinterest' && !!Wick.addToAnyCustomisation.getCurrentImage()) {
      window.open(Wick.addToAnyCustomisation.buildPinUrl(), '_blank');
      return {
        stop: true
      };
    }
    if (data.service === 'X' || data.service === 'Facebook' || data.service === 'WhatsApp') {
      window.open(data.node.href, '_blank');
      return {
        stop: true
      };
    }
  },

  buildPinUrl: function () {
    var pinImage = Wick.addToAnyCustomisation.getCurrentImage();
    var productName = Wick.addToAnyCustomisation.getProductName();
    return 'https://www.pinterest.com/pin/create/button/?url=' + window.location + '&media=' + encodeURIComponent(pinImage) + '&description=' + encodeURIComponent(productName);
  },

  getCurrentImage: function () {
    let url = Wick.addToAnyCustomisation.imageUrl || '';
    if (url.startsWith('/medias/')) {
      url = window.location.origin + url;
    }
    return url;
  },

  getProductName: function () {
    return $('.pdp__heading').text();
  }

};

Wick.addToAnyCustomisation.init();

var Wick = Wick || {};
Wick.Autocomplete = (function(){
  var $search = $('.autocomplete input');

  var init = function () {
    var substringMatcher = function(strs, by) {
      return function findMatches(q, cb) {
        var matches, substringRegex;
        matches = [];
        substrRegex = new RegExp(q, 'i');
        $.each(strs, function(i, str) {
          if (substrRegex.test(str[by])) {
            matches.push(str);
          }
        });
        cb(matches);
      };
    };

    var suggestions = [
      {'term':'cooker hoods with extractor'},
      {'term':'cookers'},
      {'term':'cooker hoods 600mm'},
      {'term':'cooker switch'},
      {'term':'cooker cable'},
      {'term':'cooker hood filter'},
      {'term':'cooker socket'},
      {'term':'cooling fans'},
      {'term':'cooker hose'},
      {'term':'cooker hood venting kit'},
      {'term':'makita 18v'},
      {'term':'makita drill'},
      {'term':'makita combi drill'},
      {'term':'makita radio'},
      {'term':'makita battery'},
      {'term':'makita impact driver'},
      {'term':'makita'},
      {'term':'makita circular saw'},
      {'term':'makita cordless drills'}
    ];

    var products = [
      {'name': 'AEG Surround Cook Double Tower Stainless Steel Electric Oven DCK731110M'},
      {'name': 'AEG Single Multifunction SenseCook Pyrolytic Stainless Steel Electric Oven BPK842720M'},
      {'name': 'AEG Surround Cook Double Multifunction Stainless Steel Electric Oven DUK731110M'},
      {'name': 'AEG Built-In Compact Sense Cook Multifunction Stainless Steel Electric Oven KPK742220M'}
    ]

    $search.typeahead({
      hint: false,
      highlight: false,
      minLength: 2,
      classNames: {
        menu: 'autocomplete__menu',
        dataset: 'autocomplete__dataset',
        suggestion: 'autocomplete__suggestion',
        cursor: 'autocomplete__cursor'
      }
    },
    {
      name: 'suggestions',
      display: 'term',
      source: substringMatcher(suggestions, 'term'),
      templates: {
        suggestion: function(obj){
          return [
            '<a class="_autocomplete__suggestion-link" href="/page_search-results.html">',
              obj.term,
            '</a>',
          ].join('\n')
        }
      }
    },
    {
      name: 'products',
      display: 'name',
      source: substringMatcher(products, 'name'),
      templates: {
        header: [
          '<div class="autocomplete__dataset-header">',
            'Products',
          '</div>'
        ].join('\n'),
        suggestion: function(obj){
          return [
            '<div>',
              '<a class="autocomplete__suggestion-link" href="/page_product-details.html">',
                '<div class="autocomplete__suggestion-img-outer">',
                  '<img class="autocomplete__suggestion-img" src="/img/placeholders/[e-img-4to3].jpg">',
                '</div>',
                '<div class="autocomplete__suggestion-info">',
                  '<span class="autocomplete__suggestion-title">',
                    obj.name,
                  '</span>',
                  '<div class="autocomplete__suggestion-price">£2,099.00</div>',
                '</div>',
              '</a>',
            '</div>'
          ].join('\n')
        }
      }
    })
    .bind('typeahead:select', function(e, suggestion) {
      if (suggestion.term) {
        window.location.href = './page_search-results.html';
      } else if (suggestion.name){
        window.location.href = './page_product-details.html';
      }
    })
    .bind('typeahead:render', function() {
      $('.autocomplete__suggestion-title').each(function (index, value) {
        $clamp(value, {clamp: 2});
      });
    });
  }

  if (!$search.length) {
    return;
  }

  init();
})();

var Wick = Wick || {};
Wick.BasketData = (function () {
  return {
    validPostCodes: function () {
      return [
        'RT_01',
        'RT_02',
        'RT_03',
        'RT_04',
        'RT_05',
        'RT_051',
      ]
    },
    successVoucherData: {
      "subTotal": "£85.00",
      "deliveryCost": "£4.00",
      "freeDelivery": false,
      "clickAndCollectCost": "FREE",
      "totalForDelivery": "£69.00",
      "totalForClickAndCollect": "FREE",
      "total": "£67.00",
      "vat": "£11.17",
      "deliveryOrder": true,
      "clickAndCollectOrder": false,
      "discountTotal": "£2.00",
      "discounts": [
        "Spend over £10 and get £2 fixed discount"
      ],
      "promotionsInfo": [
        {
          "description": "Spend over £10 and get £2 fixed discount",
          "usedCouponCode": "RT_02"
        }
      ],
      "subTotalWithDeliveryCost": "£69.00",
      "net": false,
      "subtotalWithDeliveryAndDiscounts": "£67.00",
      "discountAmounts": [],
      "goodsTotalWithoutDiscount": "£65.00",
      "charityPrice": ""
    },
    failVoucherData: {
      "status": 400,
      "responseJSON": {
        "globalMessage": {
          "message": "Delivery is already free. Coupon can’t be applied",
        }
      }
    },
    updateQuantity: {
      "statusCode": "lowStock",
      "quantityAdded": 71,
      "quantity": 0,
      "entry": {
        "entryNumber": 2,
        "quantity": 74,
        "basePrice": {
          "currencyIso": "GBP",
          "value": 5.0,
          "priceType": "BUY",
          "formattedValue": "£5.00",
          "minQuantity": null,
          "maxQuantity": null,
          "currencySymbol": "£",
          "wasPrice": null,
          "infoUom": null,
          "infoUomPrice": null,
          "singleVolumePrice": null,
          "vatRatePercentage": null,
          "sellingUomDescription": null,
          "formattedPriceWithoutCurrencySymbol": "5.00",
          "pricing": null
        },
        "totalPrice": {
          "currencyIso": "GBP",
          "value": 3700.0,
          "priceType": "BUY",
          "formattedValue": "£3700.00",
          "minQuantity": null,
          "maxQuantity": null,
          "currencySymbol": "£",
          "wasPrice": null,
          "infoUom": null,
          "infoUomPrice": null,
          "singleVolumePrice": null,
          "vatRatePercentage": null,
          "sellingUomDescription": null,
          "formattedPriceWithoutCurrencySymbol": "3700.00",
          "pricing": null
        },
        "product": {
          "code": "221100",
          "name": "Blue Circle Ready To Use Postcrete - 20kg",
          "url": "/Blue-Circle-Ready-To-Use-Postcrete---20kg/p/221100",
          "purchasable": true,
          "stock": {
            "stockLevelStatus": {
              "code": "outOfStock",
              "type": "StockLevelStatus"
            },
            "stockLevel": 0,
            "stockThreshold": null,
            "makeUnavailable": false,
            "originalStockLevelStatus": {
              "code": "outOfStock",
              "type": "StockLevelStatus"
            },
            "exists": false,
            "stockMessage": null
          },
          "availableForPickup": true,
          "price": {
            "currencyIso": "GBP",
            "value": 5.0,
            "priceType": "BUY",
            "formattedValue": "£5.00",
            "minQuantity": null,
            "maxQuantity": null,
            "currencySymbol": "£",
            "wasPrice": null,
            "infoUom": "KG",
            "infoUomPrice": 0.25,
            "singleVolumePrice": null,
            "vatRatePercentage": 20.0,
            "sellingUomDescription": null,
            "formattedPriceWithoutCurrencySymbol": "5.00",
            "pricing": null
          },
          "images": [
            {
              "imageType": "PRIMARY",
              "format": "zoom",
              "url": "//media.wickes.co.uk/is/image/wickes/largeNormal/Cement-Blue-Circle-Ready-To-Use-Postcrete-20kg~B3182_221100_00",
              "altText": "Blue Circle Ready To Use Postcrete - 20kg",
              "galleryIndex": null,
              "width": null
            },
            {
              "imageType": "PRIMARY",
              "format": "product",
              "url": "//media.wickes.co.uk/is/image/wickes/normal/Cement-Blue-Circle-Ready-To-Use-Postcrete-20kg~B3182_221100_00",
              "altText": "Blue Circle Ready To Use Postcrete - 20kg",
              "galleryIndex": null,
              "width": null
            },
            {
              "imageType": "PRIMARY",
              "format": "thumbnail",
              "url": "//media.wickes.co.uk/is/image/wickes/thumbnail/Cement-Blue-Circle-Ready-To-Use-Postcrete-20kg~B3182_221100_00",
              "altText": "Blue Circle Ready To Use Postcrete - 20kg",
              "galleryIndex": null,
              "width": null
            },
            {
              "imageType": "PRIMARY",
              "format": "cartIcon",
              "url": "//media.wickes.co.uk/is/image/wickes/smallThumbnail/Cement-Blue-Circle-Ready-To-Use-Postcrete-20kg~B3182_221100_00",
              "altText": "Blue Circle Ready To Use Postcrete - 20kg",
              "galleryIndex": null,
              "width": null
            }
          ],
          "categories": [
            {
              "code": "1000208",
              "name": "Cement",
              "url": "/Products/Building-Materials/Cement+Aggregates/Cement/c/1000208",
              "description": null,
              "image": null,
              "parentCategoryName": null,
              "sequence": 0
            },
            {
              "code": "1000211",
              "name": "Concrete",
              "url": "/Products/Building-Materials/Cement+Aggregates/Concrete/c/1000211",
              "description": null,
              "image": null,
              "parentCategoryName": null,
              "sequence": 0
            }
          ],
          "baseOptions": [],
          "volumePrices": [],
          "configurable": false,
          "imageSetId": "B3182_221100_IS",
          "fulfilmentType": "STANDARD",
          "noScriptProductImageUrl": "//media.wickes.co.uk/is/image/wickes/largeNormal/Cement-Blue-Circle-Ready-To-Use-Postcrete-20kg~B3182_221100_00?defaultImage=wickes/2018-Wickes-Missing-Product-650x650",
          "sellOnly": false,
          "externalAverageRating": 4.9,
          "externalReviewCount": 4680,
          "coshhSheetUrl": "//media.wickes.co.uk/documents/wickes/B3182_221100_COSHH_0",
          "techSheetUrl": "//media.wickes.co.uk/documents/wickes/B3182_221100_TECH_0",
          "priceInclusiveVat": {
            "currencyIso": "GBP",
            "value": 5.0,
            "priceType": "BUY",
            "formattedValue": "£5.00",
            "minQuantity": null,
            "maxQuantity": null,
            "currencySymbol": "£",
            "wasPrice": null,
            "infoUom": "KG",
            "infoUomPrice": 0.25,
            "singleVolumePrice": null,
            "vatRatePercentage": 20.0,
            "sellingUomDescription": null,
            "formattedPriceWithoutCurrencySymbol": "5.00",
            "pricing": null
          },
          "priceExclusiveVat": {
            "currencyIso": "GBP",
            "value": 4.17,
            "priceType": "BUY",
            "formattedValue": "£4.17",
            "minQuantity": null,
            "maxQuantity": null,
            "currencySymbol": "£",
            "wasPrice": null,
            "infoUom": null,
            "infoUomPrice": null,
            "singleVolumePrice": null,
            "vatRatePercentage": null,
            "sellingUomDescription": null,
            "formattedPriceWithoutCurrencySymbol": "4.17",
            "pricing": null
          },
          "downStreamData": {
            "description": "Blue Circle Ready To Use Postcrete - 20kg",
            "fulfillmentType": "STANDARD",
            "swapCode": "",
            "productRanking": null,
            "order": null
          },
          "categoryPath": "Products/Building Materials/Cement & Aggregates/Cement",
          "hasDataSheets": true,
          "coshhSheetList": [
            {
              "code": "B3182_221100_COSHH_0",
              "description": null,
              "altText": null,
              "url": "//media.wickes.co.uk/documents/wickes/Cement-Blue-Circle-Ready-To-Use-Postcrete-20kg~B3182_221100_COSHH_0",
              "downloadUrl": "//media.wickes.co.uk/documents/wickes/Cement-Blue-Circle-Ready-To-Use-Postcrete-20kg~B3182_221100_COSHH_0",
              "size": null
            }
          ],
          "dopSheetList": [],
          "epdSheetList": [],
          "gilSheetList": [
            {
              "code": "B3182_221100_GIL_0",
              "description": null,
              "altText": null,
              "url": "//media.wickes.co.uk/documents/wickes/Cement-Blue-Circle-Ready-To-Use-Postcrete-20kg~B3182_221100_GIL_0",
              "downloadUrl": "//media.wickes.co.uk/documents/wickes/Cement-Blue-Circle-Ready-To-Use-Postcrete-20kg~B3182_221100_GIL_0",
              "size": null
            }
          ],
          "techSheetList": [
            {
              "code": "B3182_221100_TECH_0",
              "description": null,
              "altText": null,
              "url": "//media.wickes.co.uk/documents/wickes/Cement-Blue-Circle-Ready-To-Use-Postcrete-20kg~B3182_221100_TECH_0",
              "downloadUrl": "//media.wickes.co.uk/documents/wickes/Cement-Blue-Circle-Ready-To-Use-Postcrete-20kg~B3182_221100_TECH_0",
              "size": null
            }
          ],
          "fulfillmentAttributes": {
            "type": "STANDARD",
            "leadTimeDays": 1,
            "bigAndBulky": false,
            "supplierDelivered": false,
            "vision": false,
            "assumedAlwaysInStock": false,
            "webOnly": false,
            "treatAsFulfillmentTypeOnCheckout": null
          },
          "minOrderQuantity": 1,
          "gpid": "1000492390",
          "ean": "5018719100152",
          "isBaseProduct": false,
          "brandName": "Blue Circle",
          "scene7FlyoutViewerISCommand": "",
          "availableForShoppingList": false,
          "installationDetails": {
            "packCoverage": 0.0,
            "pricePerPack": 5.0,
            "pricePerPackInPence": 500,
            "pricePerSQM": 0.0,
            "width": 0.0,
            "length": 0.0,
            "material": "",
            "packQuantity": 0,
            "doesNotContainRequiredAttributes": null
          },
          "tileInstallationAvailable": false,
          "tileCalculationAvailable": false,
          "flooringInstallationAvailable": false,
          "flooringCalculationAvailable": false,
          "installationProduct": false,
          "availabilityRestriction": "NO_RESTRICTIONS",
          "availableForBigWinsCncOnly": false,
          "availableForBigWinsStockOnly": false
        },
        "updateable": true,
        "deliveryMode": null,
        "deliveryPointOfService": {
          "name": "8973",
          "displayName": null,
          "url": null,
          "description": "NDS Wickes Chadwell Heath",
          "openingHours": null,
          "storeContent": null,
          "features": {},
          "geoPoint": {
            "latitude": 51.566937,
            "longitude": 0.117506
          },
          "formattedDistance": null,
          "distanceKm": null,
          "mapIcon": null,
          "address": {
            "id": "10089029042199",
            "title": null,
            "titleCode": null,
            "firstName": null,
            "lastName": null,
            "companyName": "Wickes",
            "line1": "WICKES, 850 HIGH ROAD",
            "line2": "CHADWELL HEATH",
            "town": "ROMFORD",
            "region": null,
            "postalCode": "RM6 4HX",
            "phone": "020 8590 1116",
            "email": "",
            "country": {
              "isocode": "GB",
              "name": "United Kingdom"
            },
            "shippingAddress": false,
            "billingAddress": false,
            "defaultAddress": false,
            "visibleInAddressBook": true,
            "formattedAddress": "WICKES, 850 HIGH ROAD, CHADWELL HEATH, ROMFORD, RM6 4HX, United Kingdom",
            "contactAddress": false,
            "mobile": null,
            "fax": "123456",
            "regionString": null,
            "cardHolderName": null,
            "businessAddress": false,
            "createdTimestamp": null
          },
          "storeImages": [],
          "brand": "Wickes",
          "buyAndCollect": null,
          "loadingRestriction": null,
          "specificInfo": "",
          "satNavPostcode": null,
          "seoText": null,
          "productRanges": [],
          "metaTitle": null,
          "metaDescription": null,
          "h1": null
        },
        "entries": null,
        "configurationInfos": [],
        "statusSummaryMap": {},
        "entryGroupNumbers": [],
        "comments": [],
        "supportedActions": [
          "REMOVE"
        ],
        "taxValues": [
          {
            "code": "uk-vat-full",
            "value": 20.0,
            "appliedValue": 61.67,
            "absolute": false,
            "currencyIsoCode": "GBP"
          }
        ],
        "deliveryModeType": "PICKUP",
        "fulfilmentRouting": null,
        "collection": true,
        "charity": false,
        "leadTime": null,
        "leadTimeExtended": null,
        "itemTotalWithoutDiscount": {
          "currencyIso": "GBP",
          "value": 3700.0,
          "priceType": "BUY",
          "formattedValue": "£3700.00",
          "minQuantity": null,
          "maxQuantity": null,
          "currencySymbol": "£",
          "wasPrice": null,
          "infoUom": null,
          "infoUomPrice": null,
          "singleVolumePrice": null,
          "vatRatePercentage": null,
          "sellingUomDescription": null,
          "formattedPriceWithoutCurrencySymbol": "3700.00",
          "pricing": null
        },
        "appliedPromotions": null,
        "tilingInstallationData": null,
        "flooringInstallationData": null,
        "alerts": null,
        "orderFulfilmentControls": {
          "availableForCollection": true,
          "availableForDelivery": true,
          "availableForWickesFulfilment": false
        },
      },
      "deliveryModeChanged": null,
      "cartCode": "663467017",
      "statusMessage": "accConfirmedMsgs",
      "entryGroupNumbers": null,
      "message": "The Basket quantity of <a href=\"/Blue-Circle-Ready-To-Use-Postcrete---20kg/p/221100\" style=\"text-decoration: underline\">Blue Circle Ready To Use Postcrete - 20kg</a> has been reduced to 74 from 100 due to insufficient stock."
    },
    updateCart: {
      "code": "696252000",
      "subTotal": {"value": 19.0, "formattedValue": "£19.00", "currencyIso": "GBP", "formattedPriceWithoutCurrencySymbol": "19.00"},
      "totalTax": {"value": 3.17, "formattedValue": "£3.17", "currencyIso": "GBP", "formattedPriceWithoutCurrencySymbol": "3.17"},
      "deliveryCost": {"value": 0.0, "formattedValue": "£0.00", "currencyIso": "GBP", "formattedPriceWithoutCurrencySymbol": "0.00"},
      "charityPrice": {"value": 0.0, "formattedValue": "£0.00", "currencyIso": "GBP", "formattedPriceWithoutCurrencySymbol": "0.00"},
      "totalDiscounts": {"value": 0.0, "formattedValue": "£0.00", "currencyIso": "GBP", "formattedPriceWithoutCurrencySymbol": "0.00"},
      "totalPrice": {"value": 19.0, "formattedValue": "£19.00", "currencyIso": "GBP", "formattedPriceWithoutCurrencySymbol": "19.00"},
      "potentialProductPromotions": [],
      "appliedProductPromotions": [],
      "appliedOrderPromotions": [],
      "promotionsInfo": null,
      "clickAndCollectOnly": true,
      "deliveryItemsQuantity": 0,
      "pickupItemsQuantity": 2,
      "freeDelivery": false,
      "subtotalWithoutCharity": {"value": 19.0, "formattedValue": "£19.00", "currencyIso": "GBP", "formattedPriceWithoutCurrencySymbol": "19.00"},
      "messageForFreeDelivery": null,
      "pickupOrderGroups": [
        {
          "entries": [
            {
              "entryNumber": 2,
              "quantity": 1,
              "basePrice": {
                "value": 100.0,
                "formattedValue": "£100",
                "currencyIso": "GBP",
                "formattedPriceWithoutCurrencySymbol": "100"
              },
              "product": {
                "code": "221100",
                "name": "Blue Circle Ready To Use Postcrete - 20kg",
                "url": "/Blue-Circle-Ready-To-Use-Postcrete---20kg/p/221100",
                "minOrderQuantity": 0,
                "maxOrderQuantity": null,
                "fulfillmentAttributes": {
                  "type": "STANDARD_STORE_DELIVERED",
                  "leadTimeDays": 1,
                  "supplierDelivered": false
                },
                "price": {
                  "value": 100.0,
                  "formattedValue": "£100",
                  "currencyIso": "GBP",
                  "formattedPriceWithoutCurrencySymbol": "100"
                },
                "categoryPath": "Products/Building Materials/Cement & Aggregates/Cement",
                "brandName": "Blue Circle",
                "categories": [
                  {
                    "code": "1000208",
                    "name": "Cement"
                  },
                  {
                    "code": "1000211",
                    "name": "Concrete"
                  }
                ],
                "image": {
                  "url": "//media.dev.wickes.co.uk/is/image/wickes/B3182_221100_00?$normal$",
                  "altText": "Blue Circle Ready To Use Postcrete - 20kg"
                },
                "pricePerSqm": 0.0,
                "installationProduct": false
              },
              "updateable": true,
              "deliveryPointOfService": {
                "name": "8901",
                "description": "WX Test Store 12"
              },
              "charity": false,
              "itemTotalWithoutDiscount": {
                "value": 100.0,
                "formattedValue": "£100",
                "currencyIso": "GBP",
                "formattedPriceWithoutCurrencySymbol": "100"
              },
              "orderFulfilmentControls": {
                "availableForDelivery": true,
                "availableForCollection": true,
                "availableForWickesFulfilment": false
              }
            }
          ],
          "quantity": 1,
          "totalPrice": {
            "value": 100.0,
            "formattedValue": "£100.00",
            "currencyIso": "GBP",
            "formattedPriceWithoutCurrencySymbol": "100.00"
          }
        },
        {
          "entries": [
            {
              "entryNumber": 1,
              "quantity": 1,
              "basePrice": {
                "value": 24.0,
                "formattedValue": "£24",
                "currencyIso": "GBP",
                "formattedPriceWithoutCurrencySymbol": "24"
              },
              "product": {
                "code": "109450",
                "name": "Knauf Insulation Space Standard Top Up 170mm Loft Roll - 6.47m²",
                "url": "/Knauf-Insulation-Space-Standard-Top-Up-170mm-Loft-Roll---6-47m%C2%B2/p/109450",
                "minOrderQuantity": 0,
                "maxOrderQuantity": null,
                "fulfillmentAttributes": {
                  "type": "HOURLY_STANDARD",
                  "leadTimeDays": 1,
                  "supplierDelivered": false
                },
                "price": {
                  "value": 24.0,
                  "formattedValue": "£24",
                  "currencyIso": "GBP",
                  "formattedPriceWithoutCurrencySymbol": "24"
                },
                "categoryPath": "Products/Building Materials/Insulation/Loft Insulation",
                "brandName": "Knauf Insulation",
                "categories": [
                  {
                    "code": "1000270",
                    "name": "Loft Insulation"
                  }
                ],
                "image": {
                  "url": "//media.wickes.co.uk/is/image/wickes/O0032_109450_00?$normal$",
                  "altText": "Knauf Insulation Space Standard Top Up 170mm Loft Roll - 6.47m²"
                },
                "pricePerSqm": 0.0,
                "installationProduct": false
              },
              "updateable": true,
              "deliveryPointOfService": {
                "name": "8397",
                "description": "WATFORD"
              },
              "charity": false,
              "itemTotalWithoutDiscount": {
                "value": 24.0,
                "formattedValue": "£24",
                "currencyIso": "GBP",
                "formattedPriceWithoutCurrencySymbol": "24"
              },
              "orderFulfilmentControls": {
                "availableForDelivery": true,
                "availableForCollection": true,
                "availableForWickesFulfilment": false
              }
            },
            {
              "entryNumber": 1,
              "quantity": 1,
              "basePrice": {
                "value": 0.0,
                "formattedValue": "£0",
                "currencyIso": "GBP",
                "formattedPriceWithoutCurrencySymbol": "0"
              },
              "product": {
                "code": "103123",
                "name": "Wickes Passage Door Knob Set - Brass 1 Pair",
                "url": "/Wickes-Passage-Door-Knob-Set---Brass-1-Pair/p/103123",
                "minOrderQuantity": 0,
                "maxOrderQuantity": null,
                "fulfillmentAttributes": {
                  "type": "STANDARD",
                  "leadTimeDays": 1,
                  "supplierDelivered": false
                },
                "price": {
                  "value": 9.5,
                  "formattedValue": "£9.50",
                  "currencyIso": "GBP",
                  "formattedPriceWithoutCurrencySymbol": "9.50"
                },
                "categoryPath": "Products/Clearance",
                "brandName": "Wickes",
                "categories": [
                  {
                    "code": "1072000",
                    "name": "Clearance"
                  },
                  {
                    "code": "1065002",
                    "name": "Security & Hardware Clearance"
                  },
                  {
                    "code": "1022012",
                    "name": "Doors & Windows Clearance"
                  },
                  {
                    "code": "1008007",
                    "name": "Door Handles"
                  }
                ],
                "image": {
                  "url": "//media.wickes.co.uk/is/image/wickes/T3274_103123_00?$normal$",
                  "altText": "Wickes Passage Door Knob Set - Brass 1 Pair"
                },
                "pricePerSqm": 0.0,
                "installationProduct": false
              },
              "updateable": false,
              "deliveryPointOfService": null,
              "charity": false,
              "itemTotalWithoutDiscount": {
                "value": 0.0,
                "formattedValue": "£0",
                "currencyIso": "GBP",
                "formattedPriceWithoutCurrencySymbol": "0"
              },
              "orderFulfilmentControls": {
                "availableForDelivery": true,
                "availableForCollection": true,
                "availableForWickesFulfilment": false
              }
            }
          ],
          "quantity": 2,
          "totalPrice": {
            "value": 40.5,
            "formattedValue": "£40.50",
            "currencyIso": "GBP",
            "formattedPriceWithoutCurrencySymbol": "40.50"
          }
        }
      ],
      "deliveryOrderGroups": [
        {
          "entries": [
            {
              "entryNumber": 3,
              "quantity": 1,
              "basePrice": {
                "value": 25.0,
                "formattedValue": "£25",
                "currencyIso": "GBP",
                "formattedPriceWithoutCurrencySymbol": "25"
              },
              "product": {
                "code": "109451",
                "name": "Knauf Insulation Super Top Up 200mm Loft Roll - 5.61m²",
                "url": "/Knauf-Insulation-Super-Top-Up-200mm-Loft-Roll---5-61m%C2%B2/p/109451",
                "minOrderQuantity": 0,
                "maxOrderQuantity": null,
                "fulfillmentAttributes": {
                  "type": "STANDARD",
                  "leadTimeDays": 1,
                  "supplierDelivered": false
                },
                "price": {
                  "value": 25.0,
                  "formattedValue": "£25",
                  "currencyIso": "GBP",
                  "formattedPriceWithoutCurrencySymbol": "25"
                },
                "categoryPath": "Products/Building Materials/Insulation/Loft Insulation",
                "brandName": "Knauf Insulation",
                "categories": [
                  {
                    "code": "1000270",
                    "name": "Loft Insulation"
                  }
                ],
                "image": {
                  "url": "//media.wickes.co.uk/is/image/wickes/O0032_109451_00?$normal$",
                  "altText": "Knauf Insulation Super Top Up 200mm Loft Roll - 5.61m²"
                },
                "pricePerSqm": 0.0,
                "installationProduct": false
              },
              "updateable": true,
              "deliveryPointOfService": null,
              "charity": false,
              "itemTotalWithoutDiscount": {
                "value": 25.0,
                "formattedValue": "£25",
                "currencyIso": "GBP",
                "formattedPriceWithoutCurrencySymbol": "25"
              },
              "orderFulfilmentControls": {
                "availableForDelivery": true,
                "availableForCollection": true,
                "availableForWickesFulfilment": false
              }
            }
          ],
          "quantity": null,
          "totalPrice": {
            "value": 25.0,
            "formattedValue": "£25.00",
            "currencyIso": "GBP",
            "formattedPriceWithoutCurrencySymbol": "25.00"
          }
        }
      ],
      "paymentInfos": {"payPalEnabled": true, "payPalPaymentInfo": {"id": 123, "payer": "John.doe123@gmail.com"}},
      "payPalEnabled": true,
      "deliveryAddress": null,
      "pickupUniqueItemsNumber": 3,
      "deliveryUniqueItemsNumber": 1,
      "totalUnitCount": 2,
      "orderType": "CC"
    },
    changeMethod: {
      "statusCode": "pickUpInStoreSuccess",
      "quantityAdded": 0,
      "quantity": 2,
      "entry": {
        "entryNumber": 0,
        "quantity": 2,
        "basePrice": {
          "currencyIso": "GBP",
          "value": 18.0,
          "priceType": "BUY",
          "formattedValue": "£18.00",
          "minQuantity": null,
          "maxQuantity": null,
          "formattedPriceWithoutCurrencySymbol": "18.00",
          "currencySymbol": "£",
          "wasPrice": null,
          "infoUom": null,
          "infoUomPrice": null,
          "singleVolumePrice": null,
          "vatRatePercentage": null,
          "sellingUomDescription": null,
          "pricing": null
        },
        "totalPrice": {
          "currencyIso": "GBP",
          "value": 36.0,
          "priceType": "BUY",
          "formattedValue": "£36.00",
          "minQuantity": null,
          "maxQuantity": null,
          "formattedPriceWithoutCurrencySymbol": "36.00",
          "currencySymbol": "£",
          "wasPrice": null,
          "infoUom": null,
          "infoUomPrice": null,
          "singleVolumePrice": null,
          "vatRatePercentage": null,
          "sellingUomDescription": null,
          "pricing": null
        },
        "product": {
          "code": "191018",
          "name": "Aqua Flush Bathroom Ceiling Light",
          "url": "/Aqua-Flush-Bathroom-Ceiling-Light/p/191018",
          "purchasable": true,
          "stock": {
            "stockLevelStatus": {
              "code": "inStock",
              "type": "StockLevelStatus"
            },
            "stockLevel": null,
            "stockThreshold": null,
            "makeUnavailable": false,
            "originalStockLevelStatus": {
              "code": "inStock",
              "type": "StockLevelStatus"
            },
            "exists": false,
            "stockMessage": null
          },
          "availableForPickup": true,
          "price": {
            "currencyIso": "GBP",
            "value": 18.0,
            "priceType": "BUY",
            "formattedValue": "£18.00",
            "minQuantity": null,
            "maxQuantity": null,
            "formattedPriceWithoutCurrencySymbol": "18.00",
            "currencySymbol": "£",
            "wasPrice": null,
            "infoUom": "length",
            "infoUomPrice": 10.0,
            "singleVolumePrice": null,
            "vatRatePercentage": 20.0,
            "sellingUomDescription": null,
            "pricing": null
          },
          "images": [
            {
              "imageType": "PRIMARY",
              "format": "zoom",
              "url": "/medias/P2876-191018-00-PP-515Wx515H?context=bWFzdGVyfHBpbU1lZGlhfDExMTIzfGltYWdlL2pwZWd8cGltTWVkaWEvaDk0L2gzYy84Nzk2Mzk1ODk2ODYyLmpwZ3w4ZWE3MjQ3OGQyYzk1MWMxMjQyMGY3ODczMTJiMjZjMWQ1ZTNlN2FlNDRmMzYxMWUwYzU2MWMxZTMyYTM4OTE3",
              "altText": "Aqua Flush Bathroom Ceiling Light",
              "galleryIndex": null,
              "width": null
            },
            {
              "imageType": "PRIMARY",
              "format": "product",
              "url": "/medias/P2876-191018-00-PP-300Wx300H?context=bWFzdGVyfHBpbU1lZGlhfDUxNDV8aW1hZ2UvanBlZ3xwaW1NZWRpYS9oYTAvaGUzLzg3OTYzOTU4MzEzMjYuanBnfGU0MWYxOWIwYjA3OTQwYmI1ZDM0MmNmZDZlZmUxZDYzM2UxZjYxYmQ3YzNkN2Q5N2I1ZWM3YzdiNDgzYzMxZGM",
              "altText": "Aqua Flush Bathroom Ceiling Light",
              "galleryIndex": null,
              "width": null
            },
            {
              "imageType": "PRIMARY",
              "format": "thumbnail",
              "url": "/medias/P2876-191018-00-PP-96Wx96H?context=bWFzdGVyfHBpbU1lZGlhfDE0MDN8aW1hZ2UvanBlZ3xwaW1NZWRpYS9oYTcvaDhhLzg3OTYzOTU3MDAyNTQuanBnfDk5ZmFlZGRlOWM3YmNlMTZlOGYzYTllYzlhYWQ0ODZhMzVhZGE0NDIwMjU5MjAwNTJhNmMxMzA1ZTBjYzc2MGQ",
              "altText": "Aqua Flush Bathroom Ceiling Light",
              "galleryIndex": null,
              "width": null
            },
            {
              "imageType": "PRIMARY",
              "format": "cartIcon",
              "url": "/medias/P2876-191018-00-PP-65Wx65H?context=bWFzdGVyfHBpbU1lZGlhfDk1N3xpbWFnZS9qcGVnfHBpbU1lZGlhL2g3Zi9oYTEvODc5NjM5NTYzNDcxOC5qcGd8MmQ3N2RkNTkxMjFmZmMwYjY2YThhMjEyYzc5NTU2ZDM0Mzc4MDVkNTBkZTNmMmYwNWJhNmY1MzJkYzY5M2RhNg",
              "altText": "Aqua Flush Bathroom Ceiling Light",
              "galleryIndex": null,
              "width": null
            }
          ],
          "categories": [
            {
              "code": "1000071",
              "name": "Flush Lights",
              "url": "/Products/Electrical+Lighting/Interior-Lights/Flush-Lights/c/1000071",
              "description": null,
              "image": null,
              "parentCategoryName": null,
              "sequence": 0
            },
            {
              "code": "1000072",
              "name": "Ceiling Lights",
              "url": "/Products/Electrical+Lighting/Interior-Lights/Ceiling-Lights/c/1000072",
              "description": null,
              "image": null,
              "parentCategoryName": null,
              "sequence": 0
            },
            {
              "code": "1000077",
              "name": "Bathroom Lights",
              "url": "/Products/Electrical+Lighting/Interior-Lights/Bathroom-Lights/c/1000077",
              "description": null,
              "image": null,
              "parentCategoryName": null,
              "sequence": 0
            },
            {
              "code": "1001070",
              "name": "Bathroom Lighting",
              "url": "/Products/Bathrooms/Bathroom-Decor/Bathroom-Lighting/c/1001070",
              "description": null,
              "image": null,
              "parentCategoryName": null,
              "sequence": 0
            },
            {
              "code": "qa-test-category-4",
              "name": "Listing",
              "url": "/Products/Test-Product-Category/Sub-Category-Drills/Listing/c/qa-test-category-4",
              "description": null,
              "image": null,
              "parentCategoryName": null,
              "sequence": 0
            }
          ],
          "baseOptions": [],
          "volumePrices": [],
          "configurable": false,
          "imageSetId": "P2876_191018_IS",
          "fulfilmentType": "STANDARD",
          "noScriptProductImageUrl": "/medias/P2876-191018-00-PP-515Wx515H?context=bWFzdGVyfHBpbU1lZGlhfDExMTIzfGltYWdlL2pwZWd8cGltTWVkaWEvaDk0L2gzYy84Nzk2Mzk1ODk2ODYyLmpwZ3w4ZWE3MjQ3OGQyYzk1MWMxMjQyMGY3ODczMTJiMjZjMWQ1ZTNlN2FlNDRmMzYxMWUwYzU2MWMxZTMyYTM4OTE3&defaultImage=wickesstage/2018-Wickes-Missing-Product-650x650",
          "sellOnly": false,
          "externalAverageRating": 5.0,
          "externalReviewCount": 80,
          "priceInclusiveVat": {
            "currencyIso": "GBP",
            "value": 18.0,
            "priceType": "BUY",
            "formattedValue": "£18.00",
            "minQuantity": null,
            "maxQuantity": null,
            "formattedPriceWithoutCurrencySymbol": "18.00",
            "currencySymbol": "£",
            "wasPrice": null,
            "infoUom": "length",
            "infoUomPrice": 10.0,
            "singleVolumePrice": null,
            "vatRatePercentage": 20.0,
            "sellingUomDescription": null,
            "pricing": null
          },
          "priceExclusiveVat": {
            "currencyIso": "GBP",
            "value": 15.00,
            "priceType": "BUY",
            "formattedValue": "£15.00",
            "minQuantity": null,
            "maxQuantity": null,
            "formattedPriceWithoutCurrencySymbol": "15.00",
            "currencySymbol": "£",
            "wasPrice": null,
            "infoUom": null,
            "infoUomPrice": null,
            "singleVolumePrice": null,
            "vatRatePercentage": null,
            "sellingUomDescription": null,
            "pricing": null
          },
          "downStreamData": {
            "description": null,
            "fulfillmentType": "STANDARD",
            "swapCode": null,
            "productRanking": null,
            "order": null
          },
          "categoryPath": "Products/Electrical & Lighting/Interior Lights/Flush Lights",
          "hasDataSheets": false,
          "coshhSheetList": [],
          "dopSheetList": [],
          "epdSheetList": [],
          "gilSheetList": [],
          "techSheetList": [],
          "fulfillmentAttributes": {
            "type": "STANDARD",
            "leadTimeDays": 1,
            "bigAndBulky": false,
            "supplierDelivered": false,
            "vision": false,
            "assumedAlwaysInStock": false,
            "webOnly": false,
            "treatAsFulfillmentTypeOnCheckout": null
          },
          "minOrderQuantity": 2,
          "maxOrderQuantity": 5,
          "gpid": "1000477958",
          "isBaseProduct": false,
          "scene7FlyoutViewerISCommand": "",
          "availableForShoppingList": false,
          "installationDetails": {
            "packCoverage": 0.0,
            "pricePerPack": 18.0,
            "pricePerPackInPence": 1800,
            "pricePerSQM": 0.0,
            "width": 0.0,
            "length": 0.0,
            "material": "",
            "packQuantity": 1,
            "doesNotContainRequiredAttributes": null
          },
          "tileInstallationAvailable": false,
          "tileCalculationAvailable": false,
          "flooringInstallationAvailable": false,
          "flooringCalculationAvailable": false,
          "installationProduct": false,
          "availabilityRestriction": "NO_RESTRICTIONS",
          "availableForBigWinsCncOnly": false,
          "availableForBigWinsStockOnly": false
        },
        "updateable": true,
        "deliveryMode": null,
        "deliveryPointOfService": {
          "name": "8264",
          "displayName": null,
          "url": null,
          "description": "BEDFORD",
          "openingHours": {
            "name": "Test Opening Hours",
            "code": "qa-std-opening-hours",
            "weekDayOpeningList": [
              {
                "openingTime": {
                  "hour": 10,
                  "minute": 0,
                  "formattedHour": "10:00"
                },
                "closingTime": {
                  "hour": 8,
                  "minute": 0,
                  "formattedHour": "20:00"
                },
                "weekDay": "Mon",
                "closed": false,
                "fullWeekDay": "Monday"
              },
              {
                "openingTime": {
                  "hour": 10,
                  "minute": 0,
                  "formattedHour": "10:00"
                },
                "closingTime": {
                  "hour": 8,
                  "minute": 0,
                  "formattedHour": "20:00"
                },
                "weekDay": "Tue",
                "closed": false,
                "fullWeekDay": "Tuesday"
              },
              {
                "openingTime": {
                  "hour": 10,
                  "minute": 0,
                  "formattedHour": "10:00"
                },
                "closingTime": {
                  "hour": 8,
                  "minute": 0,
                  "formattedHour": "20:00"
                },
                "weekDay": "Wed",
                "closed": false,
                "fullWeekDay": "Wednesday"
              },
              {
                "openingTime": {
                  "hour": 10,
                  "minute": 0,
                  "formattedHour": "10:00"
                },
                "closingTime": {
                  "hour": 8,
                  "minute": 0,
                  "formattedHour": "20:00"
                },
                "weekDay": "Thu",
                "closed": false,
                "fullWeekDay": "Thursday"
              },
              {
                "openingTime": {
                  "hour": 10,
                  "minute": 0,
                  "formattedHour": "10:00"
                },
                "closingTime": {
                  "hour": 8,
                  "minute": 0,
                  "formattedHour": "20:00"
                },
                "weekDay": "Fri",
                "closed": false,
                "fullWeekDay": "Friday"
              },
              {
                "openingTime": {
                  "hour": 10,
                  "minute": 0,
                  "formattedHour": "10:00"
                },
                "closingTime": {
                  "hour": 4,
                  "minute": 0,
                  "formattedHour": "16:00"
                },
                "weekDay": "Sat",
                "closed": false,
                "fullWeekDay": "Saturday"
              },
              {
                "openingTime": {
                  "hour": 10,
                  "minute": 0,
                  "formattedHour": "10:00"
                },
                "closingTime": {
                  "hour": 4,
                  "minute": 0,
                  "formattedHour": "16:00"
                },
                "weekDay": "Sun",
                "closed": false,
                "fullWeekDay": "Sunday"
              }
            ],
            "specialDayOpeningList": []
          },
          "storeContent": null,
          "features": {
            "qaSundayWorkshop": "Sunday Workshop",
            "testingKey": "Default feature",
            "CardOnly": "Card only payments",
            "VirtualDCAppointment": "Virtual Design Consultant appointments",
            "VirtualAndFace2FaceDCAppointment": "Virtual and face 2 face Design Consultant appointment",
            "BurgerVan": "Burger van on site",
            "CardAndCash": "Card and cash payments",
            "Unknown": "Unknown feature",
            "PaintMixingService": "Paint mixing service",
            "FlooringTileDisplays": "Flooring & Tiles display",
            "KitchenBathroomDisplays": "Kitchen & Bathroom displays",
            "InstallationService": "Installation service",
            "KitchenBathroomDisplaysDesignServices": "Kitchen & Bathroom displays design service",
            "ClearanceStore": "Clearence store"
          },
          "geoPoint": {
            "latitude": 52.1427,
            "longitude": -0.421591
          },
          "formattedDistance": null,
          "distanceKm": null,
          "mapIcon": null,
          "address": {
            "id": "8796094824471",
            "title": null,
            "titleCode": null,
            "firstName": null,
            "lastName": null,
            "companyName": null,
            "line1": "PERKINS ROAD, BEDFORD",
            "line2": "WICKES RIVERFIELD DRIVE",
            "town": "BEDFORDSHIRE",
            "region": null,
            "postalCode": "MK41 0UE",
            "phone": "01234 271569",
            "email": null,
            "country": {
              "isocode": "GB",
              "name": "United Kingdom"
            },
            "shippingAddress": false,
            "billingAddress": false,
            "defaultAddress": false,
            "visibleInAddressBook": true,
            "formattedAddress": "PERKINS ROAD, BEDFORD, WICKES RIVERFIELD DRIVE, BEDFORDSHIRE, MK41 0UE, United Kingdom",
            "contactAddress": false,
            "mobile": null,
            "fax": "01234 342675",
            "regionString": null,
            "cardHolderName": null,
            "businessAddress": false,
            "createdTimestamp": null
          },
          "storeImages": [],
          "brand": null,
          "buyAndCollect": null,
          "loadingRestriction": false,
          "specificInfo": "",
          "satNavPostcode": null,
          "seoText": "Some SEO text for testing",
          "productRanges": [
            {
              "name": "good fixing",
              "description": "fixtures"
            },
            {
              "name": "good installation",
              "description": "installations"
            },
            {
              "name": "good helping",
              "description": "helpings"
            },
            {
              "name": "good resolving",
              "description": "resolvings"
            }
          ],
          "metaTitle": null,
          "metaDescription": null,
          "h1": null
        },
        "entries": null,
        "configurationInfos": [],
        "statusSummaryMap": {},
        "entryGroupNumbers": [],
        "comments": [],
        "supportedActions": [
          "REMOVE"
        ],
        "taxValues": [
          {
            "code": "uk-vat-full",
            "value": 20.0,
            "appliedValue": 6.0,
            "absolute": false,
            "currencyIsoCode": "GBP"
          }
        ],
        "deliveryModeType": "PICKUP",
        "fulfilmentRouting": null,
        "collection": true,
        "charity": false,
        "leadTime": null,
        "leadTimeExtended": null,
        "itemTotalWithoutDiscount": {
          "currencyIso": "GBP",
          "value": 36.0,
          "priceType": "BUY",
          "formattedValue": "£36.00",
          "minQuantity": null,
          "maxQuantity": null,
          "formattedPriceWithoutCurrencySymbol": "36.00",
          "currencySymbol": "£",
          "wasPrice": null,
          "infoUom": null,
          "infoUomPrice": null,
          "singleVolumePrice": null,
          "vatRatePercentage": null,
          "sellingUomDescription": null,
          "pricing": null
        },
        "appliedPromotions": null,
        "tilingInstallationData": null,
        "flooringInstallationData": null,
        "orderFulfilmentControls": {
          "availableForCollection": true,
          "availableForDelivery": true,
          "availableForWickesFulfilment": false
        },
        "alerts": null
      },
      "deliveryModeChanged": null,
      "cartCode": "001006000",
      "statusMessage": "accConfirmedMsgs",
      "entryGroupNumbers": null,
      "message": "Pickup in store item was updated."
    },
    checkStockBasketResponse: {
      "availableArea": true,
      "availableQuantity": 10
    },
    wisdomAddForDelivery: {
      "statusCode": "success",
      "quantityAdded": 0,
      "quantity": 6,
      "entry": {
        "entryNumber": 0,
        "quantity": 6,
        "basePrice": {
          "currencyIso": "GBP",
          "value": 4.0,
          "priceType": "BUY",
          "formattedValue": "£4.00",
          "minQuantity": null,
          "maxQuantity": null,
          "formattedPriceWithoutCurrencySymbol": "4.00",
          "currencySymbol": "£",
          "wasPrice": null,
          "infoUom": null,
          "infoUomPrice": null,
          "singleVolumePrice": null,
          "vatRatePercentage": null,
          "sellingUomDescription": null,
          "pricing": null
        },
        "totalPrice": {
          "currencyIso": "GBP",
          "value": 24.0,
          "priceType": "BUY",
          "formattedValue": "£24.00",
          "minQuantity": null,
          "maxQuantity": null,
          "formattedPriceWithoutCurrencySymbol": "24.00",
          "currencySymbol": "£",
          "wasPrice": null,
          "infoUom": null,
          "infoUomPrice": null,
          "singleVolumePrice": null,
          "vatRatePercentage": null,
          "sellingUomDescription": null,
          "pricing": null
        },
        "product": {
          "code": "300000",
          "name": "Wickes Fulfilment Product 1",
          "url": "/Wickes-Fulfilment-Product-1/p/300000",
          "purchasable": true,
          "stock": {
            "stockLevelStatus": {
              "code": "outOfStock",
              "type": "StockLevelStatus"
            },
            "stockLevel": 0,
            "stockThreshold": null,
            "makeUnavailable": false,
            "originalStockLevelStatus": {
              "code": "outOfStock",
              "type": "StockLevelStatus"
            },
            "exists": false,
            "stockMessage": null
          },
          "availableForPickup": true,
          "price": {
            "currencyIso": "GBP",
            "value": 4.0,
            "priceType": "BUY",
            "formattedValue": "£4.00",
            "minQuantity": null,
            "maxQuantity": null,
            "formattedPriceWithoutCurrencySymbol": "4.00",
            "currencySymbol": "£",
            "wasPrice": null,
            "infoUom": null,
            "infoUomPrice": null,
            "singleVolumePrice": null,
            "vatRatePercentage": 20.0,
            "sellingUomDescription": null,
            "pricing": null
          },
          "categories": [
            {
              "code": "1003000",
              "name": "Wickes Fulfilment Products",
              "url": "/Products/Wickes-Fulfilment-Products/c/1003000",
              "description": null,
              "image": null,
              "parentCategoryName": null,
              "sequence": 0
            }
          ],
          "baseOptions": [],
          "volumePrices": [],
          "configurable": false,
          "imageSetId": "missing-product",
          "fulfilmentType": "STANDARD",
          "noScriptProductImageUrl": "https://media.wickes.co.uk/is/image/wickes/2018-Wickes-Missing-Product-650x650",
          "sellOnly": false,
          "externalAverageRating": 0.0,
          "externalReviewCount": 0,
          "priceInclusiveVat": {
            "currencyIso": "GBP",
            "value": 4.0,
            "priceType": "BUY",
            "formattedValue": "£4.00",
            "minQuantity": null,
            "maxQuantity": null,
            "formattedPriceWithoutCurrencySymbol": "4.00",
            "currencySymbol": "£",
            "wasPrice": null,
            "infoUom": null,
            "infoUomPrice": null,
            "singleVolumePrice": null,
            "vatRatePercentage": 20.0,
            "sellingUomDescription": null,
            "pricing": null
          },
          "priceExclusiveVat": {
            "currencyIso": "GBP",
            "value": 3.33,
            "priceType": "BUY",
            "formattedValue": "£3.33",
            "minQuantity": null,
            "maxQuantity": null,
            "formattedPriceWithoutCurrencySymbol": "3.33",
            "currencySymbol": "£",
            "wasPrice": null,
            "infoUom": null,
            "infoUomPrice": null,
            "singleVolumePrice": null,
            "vatRatePercentage": null,
            "sellingUomDescription": null,
            "pricing": null
          },
          "downStreamData": {
            "description": null,
            "fulfillmentType": "STANDARD",
            "swapCode": null,
            "productRanking": null,
            "order": null
          },
          "categoryPath": "Products/Wickes Fulfilment Products",
          "hasDataSheets": false,
          "coshhSheetList": [],
          "dopSheetList": [],
          "epdSheetList": [],
          "gilSheetList": [],
          "techSheetList": [],
          "fulfillmentAttributes": {
            "type": "STANDARD",
            "leadTimeDays": 1,
            "bigAndBulky": false,
            "supplierDelivered": false,
            "vision": false,
            "assumedAlwaysInStock": false,
            "webOnly": false,
            "treatAsFulfillmentTypeOnCheckout": null
          },
          "gpid": "1111300000",
          "isBaseProduct": false,
          "scene7FlyoutViewerISCommand": "",
          "availableForShoppingList": false,
          "installationDetails": {
            "packCoverage": 0.0,
            "pricePerPack": 4.0,
            "pricePerPackInPence": 400,
            "pricePerSQM": 0.0,
            "width": 0.0,
            "length": 0.0,
            "material": "",
            "packQuantity": 0,
            "doesNotContainRequiredAttributes": null
          },
          "tileInstallationAvailable": false,
          "tileCalculationAvailable": false,
          "flooringInstallationAvailable": false,
          "flooringCalculationAvailable": false,
          "installationProduct": false,
          "availabilityRestriction": "NO_RESTRICTIONS",
          "availableForBigWinsCncOnly": false,
          "availableForBigWinsStockOnly": false
        },
        "updateable": true,
        "deliveryMode": null,
        "deliveryPointOfService": null,
        "entries": null,
        "configurationInfos": [],
        "statusSummaryMap": {},
        "entryGroupNumbers": [],
        "comments": [],
        "supportedActions": [
          "REMOVE"
        ],
        "taxValues": [
          {
            "code": "uk-vat-full",
            "value": 20.0,
            "appliedValue": 4.0,
            "absolute": false,
            "currencyIsoCode": "GBP"
          }
        ],
        "deliveryModeType": "SHIP",
        "fulfilmentRouting": null,
        "collection": false,
        "charity": false,
        "leadTime": null,
        "leadTimeExtended": null,
        "itemTotalWithoutDiscount": {
          "currencyIso": "GBP",
          "value": 24.0,
          "priceType": "BUY",
          "formattedValue": "£24.00",
          "minQuantity": null,
          "maxQuantity": null,
          "formattedPriceWithoutCurrencySymbol": "24.00",
          "currencySymbol": "£",
          "wasPrice": null,
          "infoUom": null,
          "infoUomPrice": null,
          "singleVolumePrice": null,
          "vatRatePercentage": null,
          "sellingUomDescription": null,
          "pricing": null
        },
        "appliedPromotions": null,
        "tilingInstallationData": null,
        "flooringInstallationData": null,
        "orderFulfilmentControls": {
          "availableForCollection": true,
          "availableForDelivery": true,
          "availableForWickesFulfilment": false
        },
        "alerts": null
      },
      "deliveryModeChanged": true,
      "cartCode": "001013000",
      "statusMessage": "accConfirmedMsgs",
      "entryGroupNumbers": null,
      "message": "Pickup in store item was updated to shipping."
    }
  }
})();

var Wick = Wick || {};
Wick.BasketPage = (function () {
  var $page = $('.page_basket');

  function bindEvents () {
    var note;

    $page.find('.btn-checkout').on('click', function (e) {
      e.preventDefault();

      var deliveryError = false;

      $('.order-line__delivery-rbn input[type=radio]:checked').each(function(index, radio){
        var $line = $(radio).parents('.order-line');
        if (radio.value === 'collect'){
          if (!$line.data('store-selected')){
            $line.addClass('order-line_delivery-error');
            deliveryError = true;
          }
        } else {
          $line.removeClass('order-line_delivery-error');
          note && note.hide();
        }
      });

      if (deliveryError){
        note = Wick.Notification.show({
          text: 'Please select stores for the entries highlighted in red',
          container: '.notification-area',
          type: 'error'
        });
      } else {
        if (Wick.User.isLoggedIn()){
          window.location.href = './page_checkout_delivery-address.html';
        } else {
          window.location.href = './page_checkout_sign-in.html';
        }
      }

      return false;
    });

    $('.order-line__delivery-action').on('click', function(){
      $line = $(this).parents('.order-line');
      $line.data('store-selected', !$line.data('store-selected'));
      $line.removeClass('order-line_delivery-error');
      note && note.hide();
    });

    $('.order-line__delivery-rbn input[type=radio]')
    .each(function(index, radio){
      radio.checked && radio.value === 'collect' && $(radio).parents('.order-line').data('store-selected', true);
    });
  }

  if (!$page.length){
    return;
  }

  bindEvents();
})();

var Wick = Wick || {};
Wick.BigWinsProto = function () {

  var bwVar = {
    $body: $('body'),
    $bigWins: $('.bw'),
    $bwActions: $('.bw_act'),
    $bwChosen: $('.bw__chosen'),
    $pdpPrice: $('.pdp-price'),
    $defStoreWrap: $('.my-account_default_store'),
    $tiTotal: $('.ti__total'),
    $stock: $('.stock'),
    $stockTabs: $('.stock__tabs'),
    $stockTab: $('.stock__tab'),
    $defStockTab: $('.def-stock__tab'),
    $stockInfo: $('.stock__info'),
    $stockAccordion: $('.stock__accordion'),
    $stockContent: $('.stock__content'),
    $stockMore: $('.stock-more'),
    $stockResult: $('.stock__result'),
    $stockFind: $('.stock__find'),
    $stockFindBtn: $('.stock__find_btn'),
    $stockEditBtn: $('.stock__edit_btn'),
    $stockQuestions: $('.stock__quest'),
    $stockRadio: $('.stock__radio label'),
    $stockQuantity: $('.tbx_quantity'),
    $stockPostcode: $('.stock__postcode input'),
    $stockPostcodeEl: $('.stock__postcode'),
    $stockAmount: $('.stock__amount-val'),
    $stockDescr: $('.stock__descr'),
    $stockPost: $('.stock__descr_post'),
    $stockClose: $('.stock__close '),
    $stockCancel: $('.stock__cancel-text'),
    $storeMoreLink: $('.store__more a'),
    $sDetails: $('.s-details'),
    $sDetailsClose: $('.s-details__close'),
    $sDetailsToggleMap: $('.s-details__tgl-map'),
    $sDetailsToggleMapText: $('.s-details__tgl-map_text'),
    $sDetailsMap: $('.s-details__map'),
    $sDetailsCopy: $('.s-details__copy'),
    $sDetailsAddress: $('.s-details__address'),
    $chosen: $('.chosen'),
    $protoOnlyPopulated: $('.proto-only-populated'),
    $storeState: $('.store-state'),
    $makeDefault: $('.default-store__make'),
    $nameDefault: $('.default-store__name'),
    $defaultCurrent: $('.default-store__default'),
    $defaultInfo: $('.default-store__det'),
    $store: $('.store'),
    $chosenItem: $('.chosen__item'),
    $storeAct: $('.store__act'),
    $storeCount: $('.store__count'),
    $stockList: $('.stock__list'),
    $stockTarget: $('.stock__target'),
    $storeSearch: $('.store-search'),
    $storeChange: $('.store-change'),
    $addStore: $('.my-account_add-store'),
    $addForDelivery: $('.btn-add-to-basket'),
    $addClickAndCollect: $('.nearest-store-purchasable'),
    $cancelStore: $('.my-account_cancel-store'),
    $toDefaultIcon: $('.store__tick'),
    $isDefaultIcon: $('.store__marker'),
    $currentDefault: $('.default-store__det__current'),
    $findStore: $('.my-account_find-store'),
    $postCodeErrorMsg: $('.stock__postcode_invalid-msg'),
    $ccOrder: $('.cc-order'),
    storeAct: 'store__act',
    storeState: 'store__state',
    storeCount: '.store__count',
    ccBtn: '.bw__cc-btn',
    pdpPriceBW: 'pdp-price_bw',
    tiTotalBW: 'ti__total_bw',
    stockTab: '.stock__tab',
    active: 'active',
    stockMore: 'stock-more',
    stockItem: '.stock__item',
    stockContentNearest: 'stock__content_nearest',
    stockContentMore: 'stock__content_more',
    stockResultHide: 'stock__result_hide',
    stockResultSuccess: 'stock__result_success',
    stockTabsHide: 'stock__tabs_hide',
    stockFindHide: 'stock__find_hide',
    stockFindBtn: '.stock__find_btn',
    stockQuestionInvalid: 'stock__quest_invalid',
    stockDescrC: 'stock__descr_c',
    stockDescrS: 'stock__descr_s',
    stockPostcodeInvalid: 'stock__postcode_invalid',
    stockDetailsOpen: 'stock__det-open',
    stockBot: 'stock__bot',
    pdpPriceDetailsOpen: 'pdp-price__det-open',
    sDetailsHide: 's-details_hide',
    sDetails: '.s-details',
    sDetailsStoreName: '.s-details__s-name',
    sDetailsInfo: '.s-details__info',
    sDetailsMapHide: 's-details__map_hide',
    sDetailsAddress: '.s-details__address',
    chosenHide: 'chosen_hide',
    chosenNearest: 'chosen__nearest',
    chosenSuccess: 'chosen__success',
    chosenError: 'chosen__error',
    store: '.store',
    storeName: '.store__name-text',
    defaultStoreName: '.default-store__name-txt',
    collapsed: 'collapsed',
    show: 'show',
    scrollDisable: 'scroll-disable',
    bwMinHeight: 'bw_min-h',
    copyLinkHovered: 'copy-link_hovered',
    protoOnlyPopulated: 'proto-only-populated',
    moreStoresPresent: 'more-stores-present',
    defStoresPresent: 'def-stores-present',
    CLICK_AND_COLLECT: 'FREE Click & Collect within 30 minutes',
    CLICK_AND_COLLECT_NOT_AVAILABLE: 'Click & Collect not available',
  };

  function init() {
    Wick.SnackBar.init();
    bwVar.$stockTabs.on('click', bwVar.stockTab, function () {
      if ($(bwVar.ccBtn).attr('disabled') && $(bwVar.ccBtn).hasClass('nearest-store-purchasable')) {
        $(bwVar.ccBtn).removeAttr('disabled');
        $(bwVar.ccBtn).find('.btn__text').text(bwVar.CLICK_AND_COLLECT);
      }

      if (!$(this).hasClass(bwVar.active)) {
        //toggle tabs
        $(this).closest(bwVar.$bigWins).find(bwVar.$stockTab).removeClass(bwVar.active);
        $(this).addClass(bwVar.active);

        $(this).closest(bwVar.$bigWins).find(bwVar.$stockFindBtn).unbind();

        //show/close modal with more stores
        if ($(this).attr('data-stores') === 'more') {

          //open block
          $(this).closest(bwVar.$bigWins).find(bwVar.$stock).addClass(bwVar.stockBot);
          $(this).closest(bwVar.$bigWins).addClass(bwVar.bwMinHeight);

          if ($(window).width() < 767) {
            $(this).closest(bwVar.$bigWins).find(bwVar.$stock).addClass(bwVar.stockMore);
          } else {
            var self = this;
            setTimeout(function () {
              $(self).closest(bwVar.$bigWins).find(bwVar.$stock).addClass(bwVar.stockMore);
            }, 1);
          }

          // remove ability collapse block
          $(this).closest(bwVar.$bigWins).find(bwVar.$stockAccordion).removeAttr('data-toggle');

          //event to show results
          $(this).closest(bwVar.$bigWins).find(bwVar.$stockFindBtn).on('click', function (e) {
            showSearchResultMore(e, this);
            showSearchResultMoreProto(this);
          });

          //delete error validation
          $(this).closest(bwVar.$bigWins).find(bwVar.$stockPostcodeEl).removeClass(bwVar.stockPostcodeInvalid);

          if ($(window).width() < 767) {
            //disable scroll for modal
            bwVar.$body.addClass(bwVar.scrollDisable);
          }

          $(this).closest(bwVar.$bigWins).find(bwVar.stockItem).each(function () {
            var attr = $(this).find('.stock__radio input').attr('checked');
            if (typeof attr !== 'undefined' && attr !== false) {
              var value = $(this).closest(bwVar.stockItem).find('.store__stock_val').text();
              if (value.match(/^out$/)) {
                $(this).closest(bwVar.stockItem).find('.stock__valid').addClass('stock__valid_show');
                $(bwVar.ccBtn).attr('disabled', 'disabled');
                $(bwVar.ccBtn).find('.btn__text').text(bwVar.CLICK_AND_COLLECT_NOT_AVAILABLE);
              }
            }

          })

        } else if ($(this).attr('data-stores') === 'nearest') {
          //close more block
          $(this).closest(bwVar.$bigWins).find(bwVar.$stock).removeClass(bwVar.stockMore);

          if ($(window).width() < 767) {
            $(this).closest(bwVar.$bigWins).find(bwVar.$stock).removeClass(bwVar.stockBot);
            $(this).closest(bwVar.$bigWins).removeClass(bwVar.bwMinHeight);
          } else {
            var self = this;
            setTimeout(function () {
              $(self).closest(bwVar.$bigWins).find(bwVar.$stock).removeClass(bwVar.stockBot);
              $(self).closest(bwVar.$bigWins).removeClass(bwVar.bwMinHeight);
            }, 600);
          }

          // add ability collapse block
          $(this).closest(bwVar.$bigWins).find(bwVar.$stockAccordion).attr('data-toggle', 'collapse');
          //event to show results
          $(this).closest(bwVar.$bigWins).find(bwVar.$stockFindBtn).on('click', showSearchResultNearest);
          //unlock scroll for modal
          bwVar.$body.removeClass(bwVar.scrollDisable);
          //delete error validation
          $(this).closest(bwVar.$bigWins).find(bwVar.$stockPostcodeEl).removeClass(bwVar.stockPostcodeInvalid);

          scrollToBlockMobile(this);
        }
      }
      closeStoreDetails(this);
    });

    bwVar.$stockFindBtn.on('click', function () {
      showSearchResultNearest(this);
    });

    bwVar.$defStockTab.on('click', function (e) {
      e.preventDefault();

      bwVar.$stockResult.removeClass('stock__result_hide')
      $(this).closest(bwVar.$bigWins).find(bwVar.$stock).addClass(bwVar.stockBot);
      $(this).closest(bwVar.$bigWins).addClass(bwVar.bwMinHeight);

      if ($(window).width() < 767) {
        $(this).closest(bwVar.$bigWins).find(bwVar.$stock).addClass(bwVar.stockMore);
      } else {
        var self = this;
        setTimeout(function () {
          $(self).closest(bwVar.$bigWins).find(bwVar.$stock).addClass(bwVar.stockMore);
        }, 1);
      }
    });

    //choose default store in more stores section
    bwVar.$storeState.on('click', function (e) {
      let defVal = $(this).text().trim(),
          toDefault = 'Make this your default store',
          isDefault = 'Default store',
          selectedStore = $(this).closest(bwVar.$store).html();

      e.preventDefault();

      if (defVal === toDefault) {
        bwVar.$storeState.text(toDefault)
        $(this).text(isDefault)
        bwVar.$bwChosen.find(bwVar.$store).html(selectedStore);
        bwVar.$storeState.parent().find(bwVar.$toDefaultIcon).hide()
        bwVar.$storeState.parent().find(bwVar.$isDefaultIcon).show()

        $(this).parent().find(bwVar.$isDefaultIcon).hide()
        $(this).parent().find(bwVar.$toDefaultIcon).show()
      }
      else {
        $(this).click(false)
      }
    });

    //make store default from main page
    bwVar.$nameDefault.on('click', function (e) {
      e.preventDefault();
      let makeDefValue = $(this).find(bwVar.defaultStoreName).text();

      bwVar.$stockList.find(bwVar.storeName).each(function () {
          if ($(this).text() === makeDefValue) {
            $(this).closest(bwVar.$store).find('.store-state').click()
          }
      })

      bwVar.$makeDefault.hide();
      bwVar.$defaultInfo.hide();
      bwVar.$defaultCurrent.show();

    });

    bwVar.$currentDefault.on('click', function (e) {
      e.preventDefault();
      let makeDefValue = $(this).find(bwVar.defaultStoreName).text();

      bwVar.$stockList.find(bwVar.storeName).each(function () {
        if ($(this).text() === makeDefValue) {
          $(this).closest(bwVar.$store).find('.store-state').click()
        }
      })

      bwVar.$makeDefault.hide();
      bwVar.$defaultInfo.hide();
      bwVar.$defaultCurrent.show();

    });

    //my-acc default store component logic
    bwVar.$storeSearch.on('click', function (e) {
      e.preventDefault();
      bwVar.$storeSearch.hide();
      bwVar.$stockPostcodeEl.show();
    })

    //my-acc scroll to default store component logic
    $(".scrollToDefault").on('click', function(e) {
      e.preventDefault();
      var target = $(this).attr('href');
      $('html, body').animate({
        scrollTop: ($(target).offset().top)
      }, 'slow');
    });

    bwVar.$findStore.on('click', function (e) {
      e.preventDefault();

      if($('.stock__input').val().length !== 0) {
        bwVar.$stockPostcodeEl.removeClass(bwVar.stockPostcodeInvalid);
        bwVar.$postCodeErrorMsg.hide();
        bwVar.$bigWins.show();

        if(bwVar.$bigWins.css('display') === 'block') {
          bwVar.$bwActions.css('display', 'flex')
        } else {
          bwVar.$bwActions.hide()
        }
      } else {
        bwVar.$stockPostcodeEl.addClass(bwVar.stockPostcodeInvalid);
        bwVar.$postCodeErrorMsg.css('display', 'inherit');
      }
    })

    bwVar.$addStore.on('click', function (e) {
      e.preventDefault();
      bwVar.$bigWins.hide();
      bwVar.$stockPostcodeEl.hide();
      bwVar.$storeChange.css('display', 'block');
      bwVar.$bwActions.hide();
      bwVar.$addStore.text('Update Default Store')
    })

    bwVar.$cancelStore.on('click', function (e) {
      e.preventDefault();
      bwVar.$bigWins.hide();
      bwVar.$bwActions.hide();
      bwVar.$stockPostcodeEl.hide();
      bwVar.$storeSearch.show();
    })

    bwVar.$storeChange.on('click', function (e) {
      e.preventDefault();
      bwVar.$bigWins.show();
      bwVar.$stockPostcodeEl.show();
      bwVar.$bwActions.show();
      bwVar.$storeChange.hide();
    })

    bwVar.$defStoreWrap.find(bwVar.$addStore).on('click', function (e) {
      if($("input:radio[name='store']").is(":checked")) {
        let currentInp = $("input:radio[name='store'][checked='checked']"),
            selectedVal = currentInp.closest(bwVar.stockItem).find(bwVar.sDetailsAddress).text();

        bwVar.$defStoreWrap.find('.table__content-address').text(selectedVal)
      }
    })

    //show store details
    bwVar.$storeMoreLink.on('click', function (e) {
      e.preventDefault();

      console.log($(this).closest('.basket').length);
      if(!$(this).closest('.basket').length) {
        var storeName = $(this)
            .closest('.store')
            .find(bwVar.storeName)
            .text()
            .trim()
            .toLowerCase();

        if ($(this).text().trim() === 'Store Info') {
          closeStoreDetails(this);
          $(this).closest(bwVar.$bigWins).find(bwVar.$stockRadio).find('input').removeAttr('checked');
          $(this).closest(bwVar.stockItem).find(bwVar.$stockRadio).trigger('click');
          $(this).closest(bwVar.stockItem).find(bwVar.$stockRadio).attr('checked', 'checked');

          $(this).text('Hide Info');

          //show pseudoclass
          $(this).closest(bwVar.$bigWins).find(bwVar.$stock).addClass(bwVar.stockDetailsOpen);

          //classes only for Price
          console.log($(this).closest(bwVar.$pdpPrice).length);

          if ($(this).closest(bwVar.$pdpPrice).length) {
            $(this).closest(bwVar.$pdpPrice)
                .addClass(bwVar.stockDetailsOpen);
            $(this).closest(bwVar.$pdpPrice)
                .addClass(bwVar.pdpPriceBW);
          } else if ($(this).closest(bwVar.$tiTotal).length) {
            $(this).closest(bwVar.$tiTotal)
                .addClass(bwVar.stockDetailsOpen);
            $(this).closest(bwVar.$tiTotal)
                .addClass(bwVar.tiTotalBW);
          }

          $(this).closest(bwVar.$bigWins).find(bwVar.$sDetails).addClass(bwVar.sDetailsHide);
          //open tab with current store
          $(this).closest(bwVar.$bigWins).find(bwVar.$sDetails).each(function () {
            if ($(this)
                .find(bwVar.sDetailsStoreName)
                .text()
                .trim()
                .toLowerCase() === storeName) {
              $(this).removeClass(bwVar.sDetailsHide);
            }
          });

          if (!bwVar.$ccOrder.length) {
            if ($(window).width() < 767) {
              //disable scroll for modal
              bwVar.$body.addClass(bwVar.scrollDisable);
            }
          }

        } else if ($(this).text().trim() === 'Hide Info') {
          closeStoreDetails(this);
        }
      }
    });

    //hide store details
    bwVar.$sDetailsClose.on('click', function (e) {
      e.preventDefault();
      closeStoreDetails(this);
    });

    // show store via radio buttons
    bwVar.$stockRadio.on('change', function () {
      $(this).closest(bwVar.$bigWins).find('.stock__valid')
          .removeClass('stock__valid_show');
      if ( $(this).closest(bwVar.$bigWins).find(bwVar.ccBtn)
          .attr('disabled')) {
        $(this).closest(bwVar.$bigWins).find(bwVar.ccBtn)
            .removeAttr('disabled');
        $(this).closest(bwVar.$bigWins).find(bwVar.ccBtn)
            .find('.btn__text').text(bwVar.CLICK_AND_COLLECT);
      }

      var openedInfo = false;
      $(this).closest(bwVar.$bigWins).find('.s-details').each(function () {
        if (!$(this).hasClass('s-details_hide')) {
          openedInfo = true
        }
      });

      if (openedInfo) {
        var storeName = $(this)
            .closest('.stock__item')
            .find(bwVar.storeName)
            .text()
            .trim()
            .toLowerCase();
        $(this).closest(bwVar.$bigWins).find(bwVar.$storeMoreLink).text('Store Info');
        $(this).closest('.stock__item').find(bwVar.$storeMoreLink).text('Hide Info');

        //show pseudoclass
        $(this).closest(bwVar.$bigWins).find(bwVar.$stock).addClass(bwVar.stockDetailsOpen);
        $(this).closest(bwVar.$bigWins).find(bwVar.$pdpPrice).addClass(bwVar.stockDetailsOpen);

        $(this).closest(bwVar.$pdpPrice).addClass(bwVar.pdpPriceBW);

        $(this).closest(bwVar.$bigWins).find(bwVar.$sDetails)
            .addClass(bwVar.sDetailsHide);

        //open tab with current store
        $(this).closest(bwVar.$bigWins).find(bwVar.$sDetails)
          .each(function () {
            if ($(this)
              .find(bwVar.sDetailsStoreName)
              .text()
              .trim()
              .toLowerCase() === storeName) {
                $(this).removeClass(bwVar.sDetailsHide);
          }
        });

        if ($(window).width() < 767) {
          //disable scroll for modal
          bwVar.$body.addClass(bwVar.scrollDisable);
        }

      } else {
        closeStoreDetails(this)
      }

      $(this).trigger('click');
      $(this).closest(bwVar.$bigWins).find(bwVar.$stockRadio).find('input').removeAttr('checked');
      $(this).find('input').attr('checked', 'checked');

      var attr = $(this).find('input').attr('checked');
      if (typeof attr !== 'undefined' && attr !== false) {
        var value = $(this).closest('.stock__item').find('.store__stock_val').text();
        if (!value.match(/^-{0,1}\d+$/)) {
          $(this).closest('.stock__item').find('.stock__valid').addClass('stock__valid_show');
          $(bwVar.ccBtn).attr('disabled', 'disabled');
          $(bwVar.ccBtn).find('.btn__text').text(bwVar.CLICK_AND_COLLECT_NOT_AVAILABLE);
        }
      }
    });

    //toggle map
    bwVar.$sDetailsToggleMap.on('click', function (e) {
      e.preventDefault();
      $(this).closest(bwVar.$bigWins).find(bwVar.$pdpPrice).removeClass(bwVar.pdpPriceBW);

      if ($(this)
          .closest(bwVar.sDetailsInfo)
          .find(bwVar.$sDetailsToggleMapText)
          .text()
          .trim() === 'Hide Map'
      ) {
        $(this)
            .closest(bwVar.sDetailsInfo)
            .find(bwVar.$sDetailsToggleMapText)
            .text('Show Map');
        $(this)
            .closest(bwVar.sDetailsInfo)
            .find(bwVar.$sDetailsMap)
            .addClass(bwVar.sDetailsMapHide);
      } else if ($(this)
          .closest(bwVar.sDetailsInfo)
          .find(bwVar.$sDetailsToggleMapText)
          .text()
          .trim() === 'Show Map'
      ) {
        $(this)
            .closest(bwVar.sDetailsInfo)
            .find(bwVar.$sDetailsToggleMapText)
            .text('Hide Map');
        $(this)
            .closest(bwVar.sDetailsInfo)
            .find(bwVar.$sDetailsMap)
            .removeClass(bwVar.sDetailsMapHide);
      }
    });

    bwVar.$stockQuestions.find('input').on('click', function () {
      if ($(this).attr('checked') === 'checked') {
        $(this).removeAttr('checked')
      } else {
        $(this).attr('checked', 'checked');
      }
    });

    bwVar.$stockClose.on('click', function (e) {
      closeMoreStorestModal(e, this);
      closeStoreDetails(this);
    });

    //come back to search tab
    bwVar.$stockEditBtn.on('click', function () {
      closeStoreDetails(this);
      $(this).closest(bwVar.$bigWins).find(bwVar.$stockResult)
          .addClass(bwVar.stockResultHide);
      $(this).closest(bwVar.$bigWins).find(bwVar.$stockTabs)
          .removeClass(bwVar.stockTabsHide);
      $(this).closest(bwVar.$bigWins).find(bwVar.$stockFind)
          .removeClass(bwVar.stockFindHide);
    });

    bwVar.$stockCancel.on('click', function (e) {
      closeMoreStorestModal(e, this);
    });

    //C&C btn
    bwVar.$bigWins.on('click', bwVar.ccBtn, function (e) {
      closeMoreStorestModal(e, this);

      //hide store info
      $(this).closest(bwVar.$bigWins).find(bwVar.$sDetails)
          .addClass(bwVar.sDetailsHide);
      $(this).closest(bwVar.$pdpPrice).removeClass(bwVar.pdpPriceBW);

      //show store info
      $(this).closest(bwVar.$bigWins).find(bwVar.$chosen).removeClass(bwVar.chosenHide);

      if ($(this).closest(bwVar.$bigWins).hasClass('bw_unhappy')) {
        $(this).closest(bwVar.$bigWins).find(bwVar.$chosen).addClass(bwVar.chosenError);
      } else {
        $(this).closest(bwVar.$bigWins).find(bwVar.$chosen).addClass(bwVar.chosenSuccess);
      }


      //hide pseudoclass
      $(this).closest(bwVar.$bigWins).find(bwVar.$stock).removeClass(bwVar.stockDetailsOpen);

      //unlock scroll for modal
      bwVar.$body.removeClass(bwVar.scrollDisable);

      scrollToBlockMobile(this);
    });

    bwVar.$sDetailsCopy.on('click', function (e) {
      e.preventDefault();
      var $temp = $('<input>');
      $(this.parentElement).append($temp);//workaround for iPad scrolling
      var text = $(this).closest(bwVar.sDetails).find(bwVar.$sDetailsAddress).text().trim();
      var str = text.replace(/(^\w|\s\w)/g, function (m) {
        return m.toUpperCase()
      });
      var textFiltered = str.split(' ').filter(function (value) {
        return value !== ''
      });
      var textTrimmed = textFiltered.join(' ');
      $temp.val(textTrimmed);
      if (navigator.userAgent.match(/TradeProMobile_iOS|DIYMobile_iOS/i)) {
        iosCopyToClipboard($temp);
      } else if (navigator.userAgent.match(/ipad|ipod|iphone/i)) {
        $temp.select();
        $temp.setSelectionRange(0, 999999);
      } else {
        $temp.select();
      }

      document.execCommand("copy");
      $(this).addClass(bwVar.copyLinkHovered);
      $temp.remove();
    });

    bwVar.$addForDelivery.on('click', function () {
      Wick.SnackBar.show(
          {
            text: 'Notification success message for Delivery with Close Btn',
            type: Wick.SnackBar.types.SUCCESS
          }
      );
      Wick.SnackBar.show(
          {
            text: 'Notification warning message for Delivery with Close Btn',
            type: Wick.SnackBar.types.WARNING
          }
      );
      Wick.SnackBar.show(
          {
            text: 'Notification error message for Delivery with Close Btn',
            type: Wick.SnackBar.types.ERROR
          }
      );
      Wick.SnackBar.show(
          {
            text: 'Notification success message for Delivery with Autoclose',
            type: Wick.SnackBar.types.SUCCESS,
            withCloseButton: false,
            autoClose: true,
            delayBeforeClose: 3000
          }
      );
    });

    bwVar.$addClickAndCollect.on('click', function (e) {
      e.stopPropagation();
      Wick.SnackBar.show(
          {
            text: 'Notification success message for Click & Collect with Close Btn',
            type: Wick.SnackBar.types.SUCCESS,
            withCloseButton: true,
          }
      );
      Wick.SnackBar.show(
          {
            text: 'Notification warning message for Click & Collect with Close Btn',
            type: Wick.SnackBar.types.WARNING,
            withCloseButton: true,
          }
      );
      Wick.SnackBar.show(
          {
            text: 'Notification error message for Click & Collect with Close Btn',
            type: Wick.SnackBar.types.ERROR,
            withCloseButton: true,
          }
      );
      Wick.SnackBar.show(
          {
            text: 'Notification success message for Click & Collect with Autoclose',
            type: Wick.SnackBar.types.SUCCESS,
            withCloseButton: false,
            autoClose: true,
            delayBeforeClose: 3000
          }
      );
    })

    //func to show results
    function showSearchResultMore(e, context) {
      e.preventDefault();
      var postcodeLength = $(context).closest(bwVar.$bigWins).find(bwVar.$stockPostcode).val().length;

      $(context).closest(bwVar.$bigWins).find(bwVar.$stockPostcodeEl).removeClass(bwVar.stockPostcodeInvalid);

      if (postcodeLength >= 5) {
        if ($(window).width() < 767) {
          bwVar.$body.addClass(bwVar.scrollDisable);
        }
        //open new section
        if (!$(context).closest(bwVar.$bigWins).find(bwVar.$stockTabs).hasClass('more-stores-present')) {
          $(context).closest(bwVar.$bigWins).find(bwVar.$stockResult).removeClass(bwVar.stockResultHide);
        } else {
          $(context).closest(bwVar.$bigWins).find(bwVar.$stockTabs).addClass(bwVar.stockTabsHide);
          $(context).closest(bwVar.$bigWins).find(bwVar.$stockFind).addClass(bwVar.stockFindHide);
        }

        //clean classes for descr
        $(context).closest(bwVar.$bigWins).find(bwVar.$stockDescr).removeClass(bwVar.stockDescrS);
        $(context).closest(bwVar.$bigWins).find(bwVar.$stockDescr).removeClass(bwVar.stockDescrC);

        var quantity = $(context).closest(bwVar.$bigWins).find(bwVar.$stockQuantity).val(),
            postcode = $(context).closest(bwVar.$bigWins).find(bwVar.$stockPostcode).val(),
            onlyStock = $(context).closest(bwVar.$bigWins)
                .find(bwVar.$stockQuestions)
                .find('input[name="stock-only"]')
                .attr('checked') === 'checked',
            onlyCC = $(context).closest(bwVar.$bigWins)
                .find(bwVar.$stockQuestions)
                .find('input[name="cc-only"]')
                .attr('checked') === 'checked';

        //amend text in info block
        $(context).closest(bwVar.$bigWins).find(bwVar.$stockAmount).text(quantity);
        $(context).closest(bwVar.$bigWins).find(bwVar.$stockPost).text(postcode);

        if (onlyCC !== onlyStock) {
          if (onlyStock) {
            $(context).closest(bwVar.$bigWins).find(bwVar.$stockDescr).addClass(bwVar.stockDescrS)
          } else if (onlyCC) {
            $(context).closest(bwVar.$bigWins).find(bwVar.$stockDescr).addClass(bwVar.stockDescrC)
          }
        } else if (onlyStock === false && onlyCC === false) {
          $(context).closest(bwVar.$bigWins).find(bwVar.$stockDescr).addClass(bwVar.stockDescrS)
        }
      } else {
        $(context).closest(bwVar.$bigWins).find(bwVar.$stockPostcodeEl).addClass(bwVar.stockPostcodeInvalid);
      }
    }

    function showSearchResultNearest(context) {
      var postcodeLength = $(context).closest(bwVar.$bigWins).find(bwVar.$stockPostcode).val().length;

      if (postcodeLength >= 5) {
        closeStoreDetails(context);
        $(context).closest(bwVar.$bigWins).find(bwVar.$stockPostcodeEl)
            .removeClass(bwVar.stockPostcodeInvalid);
        $(context).closest(bwVar.$bigWins).find(bwVar.$chosen)
            .removeClass(bwVar.chosenHide);
        $(context).closest(bwVar.$bigWins).find(bwVar.$chosen)
            .addClass(bwVar.chosenNearest);

        scrollToBlockMobile(context);

        var value = $(context).closest(bwVar.$bigWins).find('.chosen__nearest')
            .find('.store__stock_val').text();
        if (value.match(/^out$/)) {
          $(context).closest(bwVar.$bigWins).find('.chosen__nearest')
              .find('.stock__valid').addClass('stock__valid_show');
          $(context).closest(bwVar.$bigWins).find(bwVar.ccBtn)
              .attr('disabled', 'disabled');
          $(context).closest(bwVar.$bigWins).find(bwVar.ccBtn)
              .find('.btn__text').text(bwVar.CLICK_AND_COLLECT_NOT_AVAILABLE);
        } else {
          if ($(context).closest(bwVar.$bigWins)
              .find('#isCnCForProductAndStoreDisabled').val() === "true") {
            $(context).closest(bwVar.$bigWins).find('.chosen__nearest')
                .find('.stock__valid').addClass('stock__valid_show');
            $(context).closest(bwVar.$bigWins).find(bwVar.ccBtn)
                .attr('disabled', 'disabled');
            $(context).closest(bwVar.$bigWins).find(bwVar.ccBtn)
                .find('.btn__text').text(bwVar.CLICK_AND_COLLECT_NOT_AVAILABLE);
          } else {
            $(context).closest(bwVar.$bigWins).find('.chosen__nearest')
                .find('.stock__valid').removeClass('stock__valid_show');
            if ($(context).closest(bwVar.$bigWins).find(bwVar.ccBtn)
                .attr('disabled')) {
              $(context).closest(bwVar.$bigWins).find(bwVar.ccBtn)
                  .removeAttr('disabled');
              $(context).closest(bwVar.$bigWins).find(bwVar.ccBtn)
                  .find('.btn__text').text(bwVar.CLICK_AND_COLLECT);
            }
          }
        }
      } else {
        $(context).closest(bwVar.$bigWins).find(bwVar.$stockPostcodeEl)
            .addClass(bwVar.stockPostcodeInvalid);
      }
    }

    function closeMoreStorestModal(e, context) {
      e.preventDefault();
      //close more block
      $(context).closest(bwVar.$bigWins).find(bwVar.$stock)
          .removeClass(bwVar.stockMore);

      if ($(window).width() < 767) {
        $(context).closest(bwVar.$bigWins).find(bwVar.$stock)
            .removeClass(bwVar.stockBot);
        $(context).closest(bwVar.$bigWins).removeClass(bwVar.bwMinHeight);
      } else {
        setTimeout(function () {
          $(context).closest(bwVar.$bigWins).find(bwVar.$stock)
              .removeClass(bwVar.stockBot);
          $(context).closest(bwVar.$bigWins)
              .removeClass(bwVar.bwMinHeight);
        }, 600);
      }

      //bind nearestStore event
      $(context).closest(bwVar.$bigWins).find(bwVar.$stockFindBtn)
          .unbind();
      $(context).closest(bwVar.$bigWins).find(bwVar.$stockFindBtn)
          .on('click', showSearchResultNearest);

      //toggle tabs to nearest
      $(context).closest(bwVar.$bigWins).find(bwVar.$stock)
          .removeClass(bwVar.stockMore);
      $(context).closest(bwVar.$bigWins).find(bwVar.$stockTab)
          .removeClass(bwVar.active);
      $(context).closest(bwVar.$bigWins).find(bwVar.$stockTab)
          .first().addClass(bwVar.active);

      $(context).closest(bwVar.$bigWins).find(bwVar.$stockResult)
          .addClass(bwVar.stockResultHide);
      $(context).closest(bwVar.$bigWins).find(bwVar.$stockTabs)
          .removeClass(bwVar.stockTabsHide);
      $(context).closest(bwVar.$bigWins).find(bwVar.$stockFind)
          .removeClass(bwVar.stockFindHide);

      bwVar.$body.removeClass(bwVar.scrollDisable);

      scrollToBlockMobile(context);
    }

    function closeStoreDetails(context) {
      bwVar.$storeMoreLink.text('Store Info');
      //hide pseudoclass
      $(context).closest(bwVar.$bigWins).find(bwVar.$stock)
          .removeClass(bwVar.stockDetailsOpen);
      $(context).closest(bwVar.$bigWins).find(bwVar.$sDetails)
          .addClass(bwVar.sDetailsHide);
      bwVar.$pdpPrice.removeClass(bwVar.pdpPriceBW);
      bwVar.$tiTotal.removeClass(bwVar.tiTotalBW);
      bwVar.$body.removeClass(bwVar.scrollDisable);

      scrollToBlockMobile(context);
    }

    function showSearchResultMoreProto(context) {
      if ($(context).closest(bwVar.$bigWins).find('.stock__tab.active').attr('data-stores') === 'more') {
        var postcodeLength;

        if ($(context).closest(bwVar.$bigWins).find(bwVar.$bwChosen).hasClass(bwVar.protoOnlyPopulated)) {
          postcodeLength = $(context).closest(bwVar.$bigWins)
              .find(bwVar.$protoOnlyPopulated)
              .find(bwVar.storeName)
              .text().length;
        } else {
          postcodeLength = $(context).closest(bwVar.$bigWins).find(bwVar.$stockPostcode).val().length;
        }

        if (postcodeLength >= 5) {
          if ($(context).closest(bwVar.$bigWins).find(bwVar.$stockTabs).hasClass(bwVar.moreStoresPresent || bwVar.defStoresPresent)) {
            $(context).closest(bwVar.$bigWins).find(bwVar.$stockResult).removeClass(bwVar.stockResultHide);
          }
        }
      }
    }

    function iosCopyToClipboard($input) {
      var el = $input.get(0);
      var editable = el.contentEditable;
      var readOnly = el.readOnly;

      el.contentEditable = true;
      el.readOnly = false;
      var range = document.createRange();
      range.selectNodeContents(el);
      var sel = window.getSelection();
      sel.removeAllRanges();
      sel.addRange(range);
      el.setSelectionRange(0, 999999);
      el.contentEditable = editable;
      el.readOnly = readOnly;
    }

    function scrollToBlockMobile (context) {
      if ($(window).width() < 767) {
        if($(context).closest(bwVar.$tiTotal).length) {
          window.scroll(0, bwVar.$tiTotal.offset().top - 60);
        } else if ($(context).closest(bwVar.$pdpPrice).length) {
          window.scroll(0, bwVar.$bigWins.offset().top - 60);
        }
      }
    }

    (function checkStoreProductsNearest() {
      var value = $('.chosen__item').find('.store__stock_val').text();
      if (value.match(/^out$/)) {
        $('.chosen').find('.stock__valid').addClass('stock__valid_show');
        $(bwVar.ccBtn).attr('disabled', 'disabled');
        $(bwVar.ccBtn).find('.btn__text').text(bwVar.CLICK_AND_COLLECT_NOT_AVAILABLE);
      } else {
        if ($('#isCnCForProductAndStoreDisabled').val() === "true") {
          $('.chosen__nearest').find('.stock__valid').addClass('stock__valid_show')
          $(bwVar.ccBtn).attr('disabled', 'disabled');
          $(bwVar.ccBtn).find('.btn__text').text(bwVar.CLICK_AND_COLLECT_NOT_AVAILABLE);
        } else {
          $('.chosen__nearest').find('.stock__valid').removeClass('stock__valid_show');
          if ($(bwVar.ccBtn).attr('disabled')) {
            $(bwVar.ccBtn).removeAttr('disabled');
            $(bwVar.ccBtn).find('.btn__text').text(bwVar.CLICK_AND_COLLECT);
          }
        }
      }
    })();

    (function getCorrectIdToCheckbox() {
      bwVar.$stockQuestions.each(function (index) {
        $(this).find("label[for='stock-only']").attr('for', 'stock-only' + index);
        $(this).find("label[for='cc-only']").attr('for', 'cc-only' + index);

        $(this).find('#stock-only').attr('id', 'stock-only' + index);
        $(this).find('#cc-only').attr('id', 'cc-only' + index);

      });

      bwVar.$stockRadio.each(function (index) {
        var currentName = $(this).attr('for');
        $(this).attr('for', currentName + index);
        $(this).find('input').attr('id', currentName + index);

      })

    })()
  }

  if (!bwVar.$bigWins.length) {
    return;
  }

  init();
}();


var Wick = Wick || {};
Wick.checkLocalEnv = (function () {
    return {
        isEnvLocal: function () {
            let current = window.location.hostname;
            const localEnvs = [
                'localhost',
                'html-prototype-core-preview.s3-website-eu-west-1.amazonaws.com'
            ]

            return localEnvs.some((el) => {
                return el.indexOf(current) >= 0;
            });
        }
    }
})();

var Wick = Wick || {};
Wick.DeliveryDetails = (function () {
  var $page = $('.page_checkout-delivery-details');

  function bindEvents () {
    var dateAlert;

    $page.find('.btn-payment-details, .delivery-details__payment-details, .delivery-details__payment-details_mobile').on('click', function () {

      if (navigator.userAgent.match(/TradeProMobile_Android|DIYMobile_Android/i)) {
        document.body.scrollTop = 0;
        document.documentElement.scrollTop = 0;
      }

      if (!Wick.DateSelection.isDateSelected()){
        dateAlert = Wick.Notification.show({
          text: 'Sorry, please select a delivery date and/or time',
          container: '.checkout-heading',
          type: 'error'
        });
        return false;
      }
    });

    $('.date-selection').on('selected', function(){
      dateAlert && dateAlert.hide();
    });
  }

  if (!$page.length){
    return;
  }

  bindEvents();
})();

var Wick = Wick || {};

Wick.PaymentDetails = (function () {
  var $btnEnterDetails = $('.btn-enter-details'),
    $form = $btnEnterDetails.parents('form'),
    isGuestPage = $('.page_checkout-payment-details_guest').length;

  function bindEvents () {
    $btnEnterDetails.on('click', function(){
      if ($form.find('#card-name').val().length &&
        $form.find('#first-line-address').val().length &&
        $form.find('#address-line-1').val().length &&
        $form.find('#town-city').val().length &&
        $form.find('#postcode_additional').val().length){
        $('.checkout-payment-details__card-details').removeClass('checkout-payment-details__card-details_hidden');
        $('html, body').animate({
          scrollTop: $('.checkout-payment-details__card-details').offset().top - 15
        }, 700);
        return false;
      }
      Wick.Forms.showValidationErrors($form[0]);
      return false;
    });

    $('.checkout-payment-details__card-details').on('submit', function(){
      var $form = $(this);
      if ($form.find('#card-type').val() &&
        $form.find('#card-name1').val().length &&
        $form.find('#card-number').val().length &&
        $form.find('#month').val() &&
        $form.find('#year').val() &&
        $form.find('#security-code').val()){
        window.location.href = isGuestPage
          ? './page_checkout_confirmation_guest.html'
          : './page_checkout_confirmation.html';
        return false;
      }
      Wick.Forms.showValidationErrors(this);
      return false;
    });
  }

  bindEvents();
})();

var Wick = Wick || {};

Wick.CheckoutSignInEmulation = (function () {
  var checkoutEmail = $('#checkout-email');

  function validateEmail (argElementValue) {
    var emailPattern = /^[a-zA-Z0-9._-]+@[a-zA-Z0-9.-]+\.[a-zA-Z]{2,4}$/;
    return emailPattern.test(argElementValue);
  }

  function clearFormValidation (form) {
    if ($(form).hasClass('form_invalid')) {
      $(form).removeClass('form_invalid')
        .find('.form-row[data-row-required]').removeClass('form-row_validation-error')
        .find('.form-row__error').remove();
    }
  }

  function bindEvents () {
    $('#checkout-sign-in-submit').click(function () {
      var isGuestFlow = $('[name=sign-in-password]:checked').val() === 'guest';
      if (validateEmail(checkoutEmail.val())) {
        event.preventDefault();
        if (isGuestFlow){
          window.location.href = './page_checkout_delivery-address_guest.html';
          return false;
        } else if ($('#password').val().length) {
          window.location.href = './page_checkout_delivery-address.html';
          return false;
        }
      }
      Wick.Forms.showValidationErrors($(this).closest('form')[0]);
    });

    $('#modal-request-pass').on('hide.bs.modal', function () {
        var form = $(this).find('form');
        form[0].reset();
        clearFormValidation(form);
    });
  }

  bindEvents();
})();

var Wick = Wick || {};
Wick.YourDetails = (function(){
    var $self = $('.checkout-your-details');
    let closeBlock = $('.close-block'),
        $firstLineAddrRow = closeBlock.find("#first-line-address").parents(".form-row"),
        $firstLineAddrLable = closeBlock.find("#first-line-address").closest(".form-row__label"),
        $firstLineAddrField = closeBlock.find("#first-line-address").parents(".form-row__field"),
        formError = ".form-row__error",
        listElement = $('.close-block').find('li'),
        firstLineAddress = $('.close-block #first-line-address');

    var bindEvents = function () {
        $(document).on('click', '.btn-edit-manually', function(){
            $('[data-finder]').toggle();
            $('[data-manually]').toggle();
            return false;
        });
    };

    //start -> fix for ONLINE-2615
    firstLineAddress.bind("change paste keyup", function() {
        if ($(this).val() == '') {
            $('.close-block [data-manually]').removeClass('d-block');
            $('.close-block [data-manually]').addClass('d-none');
        }
    });

    listElement.on('click', function() {
        $('.close-block [data-manually]').removeClass('d-none');
        $('.close-block [data-manually]').addClass('d-block');
    });
    //end -> fix for ONLINE-2615

    //start -> fix for ONLINE-2616
    $('.btn-enter-details').on('click', function() {
        if(!($("#chb-payment-details-card").is(":checked"))) {
            $firstLineAddrRow.addClass("form-row_validation-error")
            $firstLineAddrLable.addClass("form-row__label_required")
        }
        else {
            $firstLineAddrRow.removeClass("form-row_validation-error")
            $firstLineAddrRow.removeAttr("data-row-required")
            $firstLineAddrField.siblings(".form-row__label").removeClass("form-row__label_required")
        }

        if (firstLineAddress.val() !== '') {
            $('.close-block [data-manually]').removeClass('d-none');
            $('.close-block [data-manually]').addClass('d-block');
            $firstLineAddrRow.removeClass("form-row_validation-error")
            $firstLineAddrRow.removeAttr("data-row-required")
        }
    })

    $('#chb-payment-details-card').on('click', function() {
        if($("#chb-payment-details-card").is(":checked")) {
            $firstLineAddrRow.removeClass("form-row_validation-error")
            $firstLineAddrField.siblings(".form-row__label").removeClass("form-row__label_required")
            $firstLineAddrLable.removeClass("form-row__label_required")
            closeBlock.find(formError).hide()
        }

        else {
            $firstLineAddrField.siblings(".form-row__label").addClass("form-row__label_required")
            $firstLineAddrLable.addClass("form-row__label_required")
        }
    })
    //end -> fix for ONLINE-2616

  $(document).on('blur', '.close-block #first-line-address', function() {
    if( $(this).val() ) {
      $('.close-block [data-manually]').removeClass('d-none');
      $('.close-block [data-manually]').addClass('d-block');
    } else {
      $('.close-block [data-manually]').removeClass('d-block');
      $('.close-block [data-manually]').addClass('d-none');
    }

    return false;
  });

  var init = function () {
    if (!$self.length){
      return;
    }

        bindEvents();
    };

    init();
})();

var Wick = Wick || {}; 

Wick.ClickAndCollectModal = (function () {

  var mapToggler = $('.click-and-collect-toggler'),
      googleMap = $('#google-map'),
      mapTogglerText = $('.click-and-collect-toggler span');

  $('#modal-click-and-collect').on('hide.bs.modal', function () {
    var form = $(this).find('form')[0];
    form.reset();
    Wick.Forms.clearValidationErrors(form);
  });

  mapToggler.on('click', function () {
    googleMap.toggle();
    mapToggler.blur();
    if (mapTogglerText.text() === 'Hide map') {
      mapTogglerText.text('Show map')
    } else {
      mapTogglerText.text('Hide map')
    }
  })

})();

var Wick = Wick || {};
Wick.DateSelection = (function(){
  var $self = $('.date-selection'),
    cell = '.calendar__cell_cnt',
    selectedCell = 'calendar__cell_selected',
    isSelected = 'date-selection_selected',
    backToCalendar = '.delivery-time__show-calendar-link',
    isDateSelected = false;

  var selectTimeSlot = function(e){
    $(cell).removeClass(selectedCell);
    $(e.target).addClass(selectedCell);
    $self.addClass(isSelected);
    $self.trigger('selected');
    isDateSelected = true;
  };

  var mobileView = function(){
    var isTimeSlotsVisible = 'date-selection_time-visible';

    $self
    .off('.time')
    .removeClass(isTimeSlotsVisible)
    .on('click.time', cell, function(){
      $self.addClass(isTimeSlotsVisible);
    })
    .on('click.time', backToCalendar, function(){
      $self.removeClass(isTimeSlotsVisible);
    });
  };

  var init = function () {
    if (!$self.length) {
      return;
    }

    $self.on('click', cell, selectTimeSlot);
    new SimpleBar($self.find('.delivery-types__inner')[0]);

    if (Wick.Responsive.getCurrentBreakpoint() === 'down-sm') {
      mobileView();
    }
    Wick.Responsive.onBreakpoint(mobileView, 'down-sm');
  }

  init();

  return {
    isDateSelected: function(){
      return isDateSelected;
    }
  }
})();

const errorPoductId = '321312'

const message =  {
  SUCCESS_ADDED_MESSAGE: 'Added to favourites',
  SUCCESS_REMOVE_MESSAGE: 'Removed from favourites',
  ERROR_MESSAGE: 'Cannot add to favourites. You have reached the max. number allowed'
}

function initLocalFavouriteProductEvent() {
  if (!Wick?.FavouriteProduct?.TOGGLE_FAVOURITE_PRODUCT_EVENT) {
    return;
  }
  $(window).on(Wick.FavouriteProduct.TOGGLE_FAVOURITE_PRODUCT_EVENT, function ({ detail: { resolve, reject, payload }}) {
    setTimeout(() => {
      if (payload.productId === errorPoductId) {
        reject({
          message: message.ERROR_MESSAGE
        })
      } else {
        if (payload.isChecked) {
          resolve({
            message: message.SUCCESS_ADDED_MESSAGE
          })
        } else {
          resolve({
            message: message.SUCCESS_REMOVE_MESSAGE
          })
        }
      }
    }, 500);
  });
}

$(document).ready(function () {
  initLocalFavouriteProductEvent();
});


var Wick = Wick || {};
Wick.DeliveryDetails = (function () {
  var $formRow = $('.js-row-postcode');

  function bindEvents () {
    $('.btn-checkout-find-address').on('click', function () {
      event.preventDefault();
      var $form = $(this).parents('form'),
        $row = $form.find('.js-row-postcode');

      if ($row.find('#postcode').val().length) {
        $row.removeClass('form-row_validation-error').find('.form-row__error').remove();

        $form.find('[data-finder]').toggle();
        $form.find('[data-auto-find]').toggle();

      } else {
        $row.addClass('form-row_validation-error');
        if (!$row.find('.form-row__error')[0]) {
          $row.append('<div class="form-row__error">Error message here</div>');
        }
      }
    });

    $('.checkout-address-select').on('change', function () {
      var $form = $(this).parents('form');

      $form.find('[data-finded-address]').toggle();
      $form.find('[data-auto-find]').toggle();
    });

    $('.finded-address-edit').on('click', function () {
      var $form = $(this).parents('form');

      $form.find('[data-finder]').toggle();
      $form.find('[data-finded-address]').toggle();
    });
  }

  if (!$formRow.length){
    return;
  }

  bindEvents();
})();

var Wick = Wick || {};
Wick.FooterСurrentYear = (function () {
    const $footerCopyrights = $('.footer-checkout__copyright');
    const $footerCopyrightsYear = $('.footer-checkout__copyright .current-year');
    const init = function () {
        const currentYear = new Date().getFullYear();
        $footerCopyrightsYear.text(currentYear);
    }

    if (!$footerCopyrights.length && !$footerCopyrightsYear.length) {
        return;
    }

    init();
})();

var Wick = Wick || {};
Wick.Forms = (function(){
  var fieldRow = '.form-row[data-row-required]',
    field = '.form-row__field',
    fieldError = '.form-row__error',
    formInvalid = 'form_invalid',
    rowValidationError = 'form-row_validation-error',
    // validationError = '<div class="form-row__error">Error message here</div>',
    $forgotPassword = $('.link-forgot-password'),
    scenarios = [{
        condition: function(){
          // fill in the valid returning customer's details
          // Email: responsive@test.com; Password: 123456
          return $('#login-email').val() === 'responsive@test.com' && $('#password').val() === '123456';
        },
        action: function(){
          // redirected to the homepage
          Wick.User.login();
          window.location.href = './';
        }
      },
      {
        condition: function(){
          // continue as a new user with "test+random@user.com"
          return $('#registration-email').val().length;
          // return $('#registration-email').val() === 'test+random@user.com';
        },
        action: function(){
          // redirected to the register form
          window.location.href = './page_registration.html';
        }
      },
      {
        condition: function(){
          // When I click forgotten password link
        },
        action: function(){
          // redirected on the "Forgotten Password" page
          window.location.href = './page_forgotten-password.html';
        }
      }
    ];

  validationError = function (errorMsg) {
    return `<div class="form-row__error"> ${errorMsg || 'Error message here'}</div>`
  }
  function isElementInViewport (el) {
    if (typeof jQuery === 'function' && el instanceof jQuery) {
      el = el[0];
    }
    var rect = el.getBoundingClientRect();
    return (
      rect.top >= 0 &&
      rect.left >= 0 &&
      rect.bottom <= (window.innerHeight || document.documentElement.clientHeight) &&
      rect.right <= (window.innerWidth || document.documentElement.clientWidth)
    );
  }

  var showValidationErrors = function (form, errorMsg) {
    var $form = $(form);
    if (!$form.hasClass(formInvalid)) {
      $form.find('.form-row__error').remove();
      $form.addClass(formInvalid).find(fieldRow).append(validationError(errorMsg)).addClass(rowValidationError);
    }

    var $firstMsg = $form.find(fieldRow).first();
    if($firstMsg.length && !isElementInViewport($firstMsg)){
      var inModal = $firstMsg.closest('.modal').length,
        $scrollableEl = inModal ? $firstMsg.closest('.modal') : $('html, body'),
        y = inModal ? 0 : $firstMsg.offset().top - 30;

      $scrollableEl.animate({ scrollTop: y }, 300);
    }
  };

  var clearValidationErrors = function (form) {
    var $form = $(form);
    if ($form.hasClass(formInvalid)) {
      $form.removeClass(formInvalid)
        .find(fieldRow).removeClass(rowValidationError)
        .find(fieldError).remove();
    }
  };

  var handleSmoothScroll = function () {
    $('html, body').animate({
      scrollTop: $('.cards-store-list').offset().top - 60
    }, 300);
  };

  var handleFormSubmit = function () {
    var form = this;

    if ($(form).is('#form-login') || $(form).is('#form-register')) {
      for (var i = 0; i < scenarios.length; i++) {
        var scenario = scenarios[i];
        if (scenario.condition()) {
          scenario.action(this);
          return false;
        }
      }
    }

    if ($(form).is('#form-forgotten-password')) {
      if ($(form).find('#email').val().length){
        window.location.href = './page_upd-pass.html';
        return false;
      }
    }

    if ($(form).is('#form-forgotten-password-popup')) {
      if ($(form).find('#email').val().length){
        window.location.href = './page_checkout_sign-in.html';
        return false;
      }
    }

    if ($(form).is('#checkout-form-forgotten-password-popup')) {
      if ($(form).find('#email').val().length){
        $('.modal-reset-wrap').addClass('d-block');
        $('.request-pass').addClass('d-none');
        $('.modal-title').text('Password Reset');
        return false;
      }
    }

    if ($(form).is('.update-pass')) {
      if ($(form).find('#new-password').val().length && $(form).find('#confirmed-password').val().length){
        window.location.href = './page_login.html';
        return false;
      }
    }

    if ($(form).is('.change-email')) {
      if ($(form).find('#new-email').val().length &&
        $(form).find('#confirm-new-email').val().length &&
        $(form).find('#password').val().length){
        window.location.href = './page_my-account.html';
        return false;
      }
    }

    if ($(form).is('.form-change-password')) {
      if ($(form).find('#current-password').val().length &&
        $(form).find('#new-password').val().length &&
        $(form).find('#confirm-password').val().length){
        window.location.href = './page_my-account.html';
        return false;
      }
    }

    if ($(form).is('.form-register')) {
      if ($(form).find('#first-name').val().length &&
        $(form).find('#last-name').val().length &&
        $(form).find('#postcode').val().length &&
        $(form).find('#email').val().length &&
        $(form).find('#password').val().length &&
        $(form).find('#confirm-password').val().length){
        window.location.href = './page_my-account.html';
        return false;
      }
    }

    if ($(form).is('.form-personal-details')) {
      if ($(form).find('#first-name').val().length && $(form).find('#surname').val().length){
        window.location.href = './page_my-account.html';
        return false;
      }
    }

    if ($(form).is('.form-address-details')) {
      if ($(form).find('#first-name').val().length &&
          $(form).find('#second-name').val().length &&
          $(form).find('#address1').val().length &&
          $(form).find('#town-city').val().length &&
          $(form).find('#mobile-telephone').val().length) {
        window.location.href = './page_my-account_address-book.html';
        return false;
      }
    }

    if ($(form).is('.form-locator')) {
      if ($(form).find('#store-id').val()){
        window.location.href = './page_store-locator-details.html';
        return false;
      }
    }

    if ($(form).is('.form-locator-list')) {
      if ($(form).find('#postcode-town').val().length){
        var actionAfterSubmit = $(form).attr('data-action');
        if (actionAfterSubmit === 'scroll-to-list'){
          clearValidationErrors(this);
          handleSmoothScroll();
        } else {
          window.location.href = actionAfterSubmit;
        }
        return false;
      }
    }

    if ($(form).is('#form-mini-basket')) {
      if (Wick.User.isLoggedIn()){
        window.location.href = './page_checkout_delivery-address.html';
      } else {
        window.location.href = './page_checkout_sign-in.html';
      }
      return false;
    }

    function isNotEmpty(field){
      return !!$(field).val();
    }

    if ($(form).is('#form-checkout-your-details')) {
      var requiredFields = $(form).find('[data-row-required]:visible :input');
      if (_.every(requiredFields, isNotEmpty)){
        window.location.href = $(form).attr('data-action');
        return false;
      }
    }

    if ($(form).is('#checkout-your-details-modal')) {
      var requiredFields = $(form).find('[data-row-required]:visible :input');
      if (_.every(requiredFields, isNotEmpty)){
        $('#modalDeliveryEdit').modal('hide');
        return false;
      }
    }

    if ($(form).is('#edit-delivery-address')) {
      var requiredFields = $(form).find('[data-row-required]:visible :input');
      if (_.every(requiredFields, isNotEmpty)) {
        $('#modalDeliveryGuest').modal('hide');
        return false;
      }
    }

    if ($(form).is('.checkout-register')){
      if ($(form).find('#password').val().length &&
          $(form).find('#confirm-password').val().length) {
        window.location.href = './page_my-account.html';
        return false;
      }
    }

    if ($(form).is('#form-checkout-voucher')){
      if ($(form).find('#voucher-code').val().length) {
        return false;
      }
    }

    if ($(form).is('.add-list-id__form')) {
      if ($(form).find('#project-id').val().length) {
        return false;
      }
    }

    if ($(form).is('.header-search')){
      window.location.href = './page_search-results.html';
    }

    if ($(form).is('.click-and-collect__locator-form')){
      var $form = $(form);
      if ($form.find('#click-and-collect-town').val().length) {
        clearValidationErrors(this);
      } else if (!$form.hasClass(formInvalid)) {
        // Validation for inline form
        $form.addClass(formInvalid)
          .find(fieldRow).addClass(rowValidationError)
          .find(field).append(validationError);
      }
      return false;
    }

    if($(form).is('.form-track-order')) {
        var $form = $(form);

        if ($form.find('#order').val().length &&
            $form.find('#tel').val().length &&
            $form.find('#email').val().length &&
            $form.find('#postcode').val().length) {
            clearValidationErrors(this);
        } else if (!$form.hasClass(formInvalid)) {
          $form.addClass(formInvalid);

          $(fieldRow).each(function() {
            $(this).addClass(rowValidationError)
              .append('<div class="form-row__error">' + $(this).data('message') + '</div>');
          });
        }

        return false;
    }

    if ($(form).is('#edit-billing-address')) {
      var requiredFields = $(form).find('[data-row-required]:visible :input');
      if (_.every(requiredFields, isNotEmpty)) {
        $('#modalEditBilling').modal('hide');
        return false;
      }
    }

    showValidationErrors(this);
    return false;
  };

  var scrollLocatorListPage = function() {
      var isLocatorListPage = $('.cards-store-list').length;
      var isScrollNeeded = window.location.hash === "#stores-list";
      if (isLocatorListPage && isScrollNeeded) {
          handleSmoothScroll();
      }
  };

  var bindEvents = function () {
    $(document).on('submit', 'form:not([class^="header"])', handleFormSubmit);
    $forgotPassword.on('click', scenarios[2].action);
    $('.btn-cancel').on('click', function(){
      window.location.href = './page_my-account.html';
    });
    $('.btn-previous').on('click', function(){
      window.location.href = './page_login.html';
    });
  };

  var init = function () {
    bindEvents();
    scrollLocatorListPage();
  };

  init();

  return {
    showValidationErrors: showValidationErrors,
    clearValidationErrors: clearValidationErrors
  }
})();

var Wick = Wick || {};
Wick.GenerateProjectIdLocal = {
  GENERATE_PROJECT_ID_EVENT: 'generateProjectId',
  isErrorTriggered: false,
  projectId: 'DEF123102',
  errorMessage: 'Test error message, please click again',
  el: {
    generateBtn: '.generate-project-id__btn',
  },
  init() {
    $(window).on(Wick.GenerateProjectIdLocal.GENERATE_PROJECT_ID_EVENT, function ({ detail: { resolve, reject }}) {
      setTimeout(() => {
        if (!Wick.GenerateProjectIdLocal.isErrorTriggered) {
          Wick.GenerateProjectIdLocal.isErrorTriggered = true;
          reject({errorMessage: Wick.GenerateProjectIdLocal.errorMessage});
          return;
        }

        resolve({ projectId: Wick.GenerateProjectIdLocal.projectId });
      }, 1500);
    });
  },
};

$(document).ready(function () {
  if (!Wick.GenerateProjectIdLocal.el.generateBtn.length) {
    return;
  }

  Wick.GenerateProjectIdLocal.init();
});

const suggestions = [
  {
    value: 'lintel',
    url: '/'
  },
  {
    value: 'lining paper',
    url: '/'
  },
  {
    value: 'line',
    url: '/'
  },
  {
    value: 'light',
    url: '/'
  },
  {
    value: 'lime',
    url: '/'
  }
]
const products = [
  {
    value: 'angemaster Classic Deluxe 90 Ceramic Range Cooker',
    image: 'https://media.wickes.co.uk/is/image/wickes/O0032_109451_00?$thumbnail$',
    url: '/'
  },
  {
    value: 'Rangemaster',
    image: 'https://media.wickes.co.uk/is/image/wickes/G0116_121330_00?$thumbnail$',
    url: '/',
  },
  {
    value: 'Rangemaster Classic Deluxe 90 Ceramic Range Cooker - Black with Chrome Trim Rangemaster Classic Deluxe 90 Ceramic Range Cooker - Black with Chrome Trim',
    image: 'https://media.wickes.co.uk/is/image/wickes/normal/Footwear-Tough-Grit-Larch-Wellington-Size-8~GPID_1100568113_00',
    url: '/',
  },
  {
    value: 'Rangemaster Classic Deluxe 90 Ceramic Range Cooker',
    image: 'https://media.wickes.co.uk/is/image/wickes/normal/Footwear-Tough-Grit-Oak-Boot-7~GPID_1100568107_00',
    url: '/',
  }
];
const contentPages = [
  {
    value: 'Rangemaster',
    image: 'https://media.wickes.co.uk/is/image/wickes/O0032_109451_00?$thumbnail$',
    url: '/'
  },
  {
    value: 'Rangemaster Classic Deluxe 90 Ceramic Range Cooker',
    image: 'https://media.wickes.co.uk/is/image/wickes/G0116_121330_00?$thumbnail$',
    url: '/'
  },
  {
    value: 'Rangemaster Classic Deluxe 90 Ceramic Range Cooker',
    image: 'https://media.wickes.co.uk/is/image/wickes/normal/Footwear-Tough-Grit-Oak-Boot-7~GPID_1100568107_00',
    url: '/'
  },
  {
    value: 'Rangemaster',
    image: 'https://media.wickes.co.uk/is/image/wickes/normal/Footwear-Tough-Grit-Alder-Trainer-7~GPID_1100568095_00',
    url: '/'
  }
];

function initLocalSearchBar () {
  if (!Wick?.GlobalSearch?.SEARCH_PRODUCTS_EVENT) {
    return;
  }

  $(window).on(Wick.GlobalSearch.SEARCH_PRODUCTS_EVENT, function ({ detail: { resolve, reject, payload }}) {
    setTimeout(() => {
      let searchResults = {};

      switch (payload.value.length) {
        case 2:
          searchResults = {suggestions, products, contentPages};
          break;
        case 3:
          searchResults = {suggestions, products};
          break;
        case 4:
          searchResults = {suggestions, contentPages};
          break;
        case 5:
          searchResults = {suggestions};
          break;
        case 6:
          searchResults = {products};
          break;
        case 7:
          searchResults = {contentPages};
          break;
      }

      resolve(searchResults);
    }, 500);
  });
};

$(document).ready(function () {
  initLocalSearchBar();
});

var Wick = Wick || {};
Wick.GoogleMapsStoreInfo = function () {

  function init() {
    (function callStoreMap() {
      var elements = document.querySelectorAll('.map__google-map');
      var option = {
        zoom: 5,
        center: {lat: 50.4501, lng: 30.5234}
      };
      var myMap;
      var marker;

      // elements.forEach(function (element) {
        // myMap = new google.maps.Map(element, option);

        // marker = new google.maps.Marker({
        //   position: {lat: 50.4501, lng: 30.5234},
        //   icon: "img/enhanced_pin.png",
        //   map: myMap
        // })
      // })
    })();
  }

  if (!$('.bw').length) {
    return;
  }

  init();
}();


var Wick = Wick || {};
Wick.HomeMovers = {
  NOTIFICATION_ERROR: 'Please fill the fields',
  el: {
    $homeMovers: $('.home-movers'),
    $homeMoversForm: $('#home-movers-form'),
    $homeMoversHero: $('.home-movers__hero'),
    $homeMoversThank: $('.home-movers__thank'),
    notification: '.notification',
    notificationContainer: '.globalMessages .container',
  },
  validateForm: function (e) {
    e.preventDefault();

    Wick.HomeMovers.isFormValid()
      ? Wick.HomeMovers.showThankYouState()
      : Wick.Notification.show({
        text: Wick.HomeMovers.NOTIFICATION_ERROR,
        container: Wick.HomeMovers.el.notificationContainer,
        type: 'error',
        closeBtn: true,
        noScrolling: true,
      });
  },
  showThankYouState: function () {
    Wick.HomeMovers.el.$homeMoversHero.hide();
    Wick.HomeMovers.el.$homeMoversThank.show();
    Wick.HomeMovers.scrollToPageTop();
    $(Wick.HomeMovers.el.notification).remove();
  },
  isFormValid: function () {
    let isValid = true;
    Wick.HomeMovers.el.$homeMoversForm.find('[data-row-required] input').each(function () {
      if ($(this).val() === '')
        isValid = false;
    });
    return isValid;
  },
  scrollToPageTop: function () {
    $('html, body').animate({scrollTop: 0}, 300);
  },
  init: function () {
    Wick.HomeMovers.el.$homeMoversForm.on('submit', Wick.HomeMovers.validateForm);
  }
};


$(document).ready(function () {
  function init() {
    if (!Wick.HomeMovers.el.$homeMovers.length) {
      return;
    }

    Wick.HomeMovers.init();
  }

  init();
});

var Wick = Wick || {};

Wick.multipleFiles = {
  valueFiles: [],
  count: 5,
  filesForm: {
    getPreviewTemplate (installerFileName) {
      var previewTemplate = $('.installer_question-file_result_wrapper[data-installer-file-name="' + installerFileName + '"]');
      return $(previewTemplate[Wick.multipleFiles.valueFiles.length])
    },
    setValue: function(installerFileName, value) {
      Wick.multipleFiles.valueFiles.push(value)
    },
    removeValue: function(installerFileName, order) {
      Wick.multipleFiles.valueFiles.splice(order, 1)
    },
    showAddFileTemplate: function (installerFileName) {
      if (Wick.multipleFiles.valueFiles.length < Wick.multipleFiles.count) {
        var addFileTemplate = $('label.installer_question-file_label[data-installer-file-name="' + installerFileName + '"]');
        addFileTemplate.removeClass('hide');
      }
    },
    hideAddFileTemplate: function (installerFileName) {
      if (Wick.multipleFiles.valueFiles.length >= Wick.multipleFiles.count) {
        var addFileTemplate = $('label.installer_question-file_label[data-installer-file-name="' + installerFileName + '"]');
        addFileTemplate.addClass('hide');
      }
    },
    showErrorNotification: function (installerFileName, error) {
      Wick.InstallerValidation.addErrorNotificationToElement(installerFileName, error, true)
    },
    hideErrorNotification: function (installerFileName) {
      Wick.InstallerValidation.removeErrorNotificationFromElement(installerFileName)
    },
    hideDefaultError: function (element) {
      Wick.InstallerValidation.removeErrorNotificationFromElement(element.attr('name'))
    },
    showImagePreviewTemplate: function (installerFileName) {
      var previewTemplate = Wick.multipleFiles.filesForm.getPreviewTemplate(installerFileName)
      previewTemplate.removeClass('hide');
    },
    hideImagePreviewTemplate: function (installerFileName, order) {
      var previewTemplates = $('.installer_question-file_result_wrapper[data-installer-file-name="' + installerFileName + '"]');

      var i = order + 1;
      while (Wick.multipleFiles.count > i) {
        $(previewTemplates[i]).data('file', i-1)
        i++;
      }
 
      $(previewTemplates[order]).addClass('hide');
      $(previewTemplates[order]).data('file', (Wick.multipleFiles.count-1));
      $(previewTemplates[order]).appendTo('.your-details__file-wrapper');
    },
    readFile: function (file, installerFileName) {
      var reader = new FileReader();
      var imagePreviewTemplate = Wick.multipleFiles.filesForm.getPreviewTemplate(installerFileName)

      reader.onload = function(e) {
        var imagePreviewElement = imagePreviewTemplate.find('img');

        imagePreviewElement.attr('src', e.target.result);
      };

      reader.readAsDataURL(file);
    },
    showSpinner: function () {
      var loader = $('.installer__loader');
      loader.addClass('show');
    },
    hideSpinner: function () {
      var loader = $('.installer__loader');
      loader.removeClass('show');
    },
    addFileHandler: function (file, installerFileName) {
      Wick.S3bucketUpload.uploadImage(file, installerFileName);
    },
    onSuccessFileAdd: function (file, installerFileName, fileLink) {
      Wick.multipleFiles.filesForm.hideErrorNotification(installerFileName);
      Wick.multipleFiles.filesForm.showImagePreviewTemplate(installerFileName);
      Wick.multipleFiles.filesForm.readFile(file, installerFileName);
      Wick.multipleFiles.filesForm.setValue(installerFileName, fileLink);
      Wick.multipleFiles.filesForm.hideAddFileTemplate(installerFileName);
    },
    removeFileHandler: function (installerFileName, order) {
      Wick.multipleFiles.filesForm.hideErrorNotification(installerFileName);
      Wick.multipleFiles.filesForm.removeValue(installerFileName, order);
      Wick.multipleFiles.filesForm.hideImagePreviewTemplate(installerFileName, order);
      Wick.multipleFiles.filesForm.showAddFileTemplate(installerFileName);
    }
  },
  bindFileInputs: function () {
    $('body').on('change', '.installer_question-file_input', function() {
      var closestLabel = $(this).closest('.installer_question-file_label');
      var files = $(this).get(0).files
      var delta = Wick.multipleFiles.count - Wick.multipleFiles.valueFiles.length;
      var i = (files.length < delta) 
        ? files.length 
        : delta;
      while(i) {
        i--
        var file = files[i]
        Wick.multipleFiles.filesForm.addFileHandler(file, closestLabel.attr('data-installer-file-name'));
      }
    });
  },
  bindImageTemplate: function() {
    var element = $('.your-details__file-wrapper .installer_question-file_result_wrapper')
    var i = 0;
    element.data('file', i)
    while ((Wick.multipleFiles.count-1) > i) {
      i++
      element
        .clone()
        .data('file', i)
        .appendTo('.your-details__file-wrapper');
    }
  },
  bindDeleteFileButtons: function () {
    $('body').on('click', '.delete_action', function() {
      var closestLabel = $(this).closest('.installer_question-file_result_wrapper');
      Wick.multipleFiles.filesForm.removeFileHandler(closestLabel.attr('data-installer-file-name'), closestLabel.data('file'));
    });
  },

  RECAPTCHA_PUBLIC_KEY: '6LdVZ74ZAAAAABiyCm6Szsv5T9wbrOCegkskM2iR',

  recaptchaDecorate: function (action, f) {
    return function() {
      const context = this
      const args = arguments
      grecaptcha.ready(function () {
        grecaptcha.execute(Wick.multipleFiles.RECAPTCHA_PUBLIC_KEY, {
          action: action
        }).then(function (token) {
          f.call(context, token, ...args)
        })
      })
    }
  }
};

$(document).ready(function () {
  Wick.multipleFiles.bindImageTemplate();
  Wick.multipleFiles.bindFileInputs();
  Wick.multipleFiles.bindDeleteFileButtons();
});

// Polyfills
if (!String.prototype.startsWith) {
  String.prototype.startsWith = function(searchString, position) {
    position = position || 0;
    return this.indexOf(searchString, position) === position;
  };
}

Wick.S3bucketUpload = {
  validExtensionsList: ['jpg', 'jpeg', 'png', 'bmp', 'webp', 'tiff', 'heif', 'heic'],
  isFileExtensionValid: function (file) {
    var fileName = file.name.split('.')
    return Wick.S3bucketUpload.validExtensionsList.includes(fileName[fileName.length - 1].toLowerCase())
  },
  transformXmlError: function (error) {
    var parser = new DOMParser();
    var xmlDoc = parser.parseFromString(error.responseText, "text/xml");
    var errorMessage = xmlDoc.all[2].innerHTML;
    if (errorMessage === 'Your proposed upload exceeds the maximum allowed size') {
      return 'Unfortunately your document could not be uploaded, as the file exceeds the 5MB limit. Please try again with a file no greater than 5MB.';
    }
    return errorMessage;
  },
  transformError: function (error) {
    if (error.responseXML) {
      return Wick.S3bucketUpload.transformXmlError(error);
    }
    return error.statusText;
  },
  uploadImage: function(file, installerFileName) {
    var isExtesionValid = Wick.S3bucketUpload.isFileExtensionValid(file);

    if (!isExtesionValid) {
      Wick.multipleFiles.filesForm.showErrorNotification(installerFileName, [
        'Unable to attach file. Only JPG, JPEG, PNG, BMP, WEBP, TIFF, HEIC and HEIF image files are supported.'
      ]);

      return;
    }

    Wick.multipleFiles.filesForm.showSpinner();

    setTimeout(()=> {
      Wick.multipleFiles.filesForm.hideSpinner();
      Wick.multipleFiles.filesForm.onSuccessFileAdd(file, installerFileName, installerFileName);
    }, 1000)
  }
};


Wick.InstallerValidation = {
  findRequirementsByName: function (elementName) {
    var step = $('[name="'+ elementName +'"]').closest('.installer-block').attr('data-step');
    return Wick.InstallerValidation.steps[step][elementName];
  },
  getValueByName: function (elementName) {
    var element = $('[name="'+ elementName +'"]');
    var type = element.attr("type");

    if (element.prop('tagName') === 'SELECT') {
      return element.val()
    }

    switch (type) {
      case 'radio':
        return $('[name="'+ elementName +'"]:checked').val();
      case 'checkbox':
        return $('[name="'+ elementName +'"]:checked').map(function(){
          return $(this).val();
        }).get();
      case 'file':
        return element.attr('data-value');
      default:
        return element.val().trim();
    }
  },
  isInputValueNotEmpty: function (value) {
    if (typeof value === 'string') return !!value;
    if (Array.isArray(value)) return value.length > 0;

    return false;
  },
  elemDependsCheck: function (dependentValue, requirements) {
    var isValueExist = Wick.InstallerValidation.isInputValueNotEmpty(dependentValue);
    if (isValueExist) {
      if (requirements.dependsOnValue) {
        if (typeof dependentValue === 'string' || Array.isArray(dependentValue)) {
          return Wick.InstallerValidation.elemPossibleValuesCheck(dependentValue, requirements.dependsOnValue);
        } else {
          return false;
        }
      }
    } else {
      return false;
    }

    return true;
  },
  elemRequiredCheck: function (value, requirements) {
    var isValueExist = Wick.InstallerValidation.isInputValueNotEmpty(value);
    if (requirements.required && !isValueExist) {
      return false;
    }

    return true;
  },
  elemPossibleValuesCheck: function (value, possibleValues) {
    if (Array.isArray(possibleValues) && possibleValues.length > 0) {
      if (typeof value === 'string') {
        if (possibleValues && possibleValues.indexOf(value) < 0) {
          return false;
        }
      }
      if (Array.isArray(value) && value.length > 0) {
        if (possibleValues) {
          var isValid = value
            .map(function (arrayValue) { return possibleValues.indexOf(arrayValue) >= 0 })
            .some(function (result) { return !!result });

          if (!isValid) {
            return false;
          }
        }
      }
    }
    return true;
  },
  elemRegexCheck: function (value, requirements) {
    if (requirements.regex && !RegExp(requirements.regex).test(value)) {
      return false;
    }

    return true;
  },
  elemMaxLengthCheck: function (value, requirements) {
    if (typeof value === 'string' && requirements.maxLength) {
      return value.length <= requirements.maxLength;
    }

    return true;
  },
  isElementValid: function (elementName) {
    var requirements = Wick.InstallerValidation.findRequirementsByName(elementName);
    var value = Wick.InstallerValidation.getValueByName(elementName);
    var error = requirements.error;

    if (value && typeof value === 'string') {
      value = value.trim();
    }

    if (requirements.required) {
      if (requirements.dependsOnInput) {
        var dependentValue = Wick.InstallerValidation.getValueByName(requirements.dependsOnInput);
        if (dependentValue) {
          if (requirements.dependsOnValue) {
            var elemDependsCheckResult = Wick.InstallerValidation.elemDependsCheck(dependentValue, requirements);
            if (elemDependsCheckResult) {
              var result = Wick.InstallerValidation.checkElementValidations(value, requirements);
              return { valid: result.valid, errorType: result.errorType, error  };
            }
          } else {
            var result = Wick.InstallerValidation.checkElementValidations(value, requirements);
            return { valid: result.valid, errorType: result.errorType, error  };
          }
        }
      } else {
        var result = Wick.InstallerValidation.checkElementValidations(value, requirements);
        return { valid: result.valid, errorType: result.errorType, error  };
      }
    } else {
      var isValueExist = Wick.InstallerValidation.isInputValueNotEmpty(value);
      if (isValueExist) {
        var result = Wick.InstallerValidation.checkElementValidations(value, requirements);
        return { valid: result.valid, errorType: result.errorType, error  };
      }
    }

    return { valid: true, error };
  },
  checkElementValidations: function (value, requirements) {
    var elemRequiredCheckResult = Wick.InstallerValidation.elemRequiredCheck(value, requirements);
    var elemPossibleValuesCheckResult = Wick.InstallerValidation.elemPossibleValuesCheck(value, requirements.possibleValues);
    var elemRegexCheckResult = Wick.InstallerValidation.elemRegexCheck(value, requirements);
    var elemMaxLengthCheckResult = Wick.InstallerValidation.elemMaxLengthCheck(value, requirements);

    if (!elemRequiredCheckResult) return { valid: false, errorType: 'required' };
    if (!elemPossibleValuesCheckResult || !elemRegexCheckResult || !elemMaxLengthCheckResult) return { valid: false, errorType: 'validation' };

    return { valid: true };
  },
  runElementCallback: function (elementName, changedElemValue) {
    var value = Wick.InstallerValidation.getValueByName(elementName);
    var requirements = Wick.InstallerValidation.findRequirementsByName(elementName);
    if (requirements.callback) {
      requirements.callback(value, changedElemValue);
    }
  },
  checkElement: function (elementName, onChange) {
    var result = Wick.InstallerValidation.isElementValid(elementName);
    if (result.valid) {
      if (onChange) {
        Wick.InstallerValidation.removeErrorNotificationFromElement(elementName);
        Wick.InstallerValidation.removeGlobalErrorNotification();
      }
      return result;
    }

    Wick.InstallerValidation.addErrorNotificationToElement(elementName, result.error, true);

    return result;
  },
  appendErrorMessage: function (wrapper, elementName, error) {
    var notification = '<div' +
      '            data-installer-input-name="' + elementName + '"' +
      '            class="form-row__error"' +
      '          >' + error.map(function (err) { return '<p>' + err + '</p>';}).join('') +
      '          </div>';
    wrapper.append(notification);
  },
  addErrorNotificationToElement: function (elementName, error, removePrevNotification) {
    if (!error) return;
    var element = $('[name="'+ elementName +'"]');
    var wrapper = element.closest('[data-form-field]');
    var prevNotification = wrapper.children('.form-row__error[data-installer-input-name="'+ elementName +'"]');
    if (prevNotification.length === 0) {
      Wick.InstallerValidation.appendErrorMessage(wrapper, elementName, error);
    } else {
      if (removePrevNotification) {
        prevNotification.remove();
        Wick.InstallerValidation.appendErrorMessage(wrapper, elementName, error);
      }
    }
  },
  removeErrorNotificationFromElement: function (elementName) {
    var element = $('[name="'+ elementName +'"]');
    var wrapper = element.closest('[data-form-field]');
    var error = wrapper.children('.installer_question-error_wrapper[data-installer-input-name="'+ elementName +'"]');
    var formError = wrapper.find('.form-row__error[data-installer-input-name="'+ elementName +'"]');
    error.remove();
    formError.remove();
  },
  removeAllErrorsFromStep: function (step) {
    var installerBlock = $('.installer-block[data-step="'+ step +'"]');
    installerBlock.find('.form-row__error').remove();
  },
  addGlobalErrorNotification: function (step, errorTypes) {
    var wrapper = $('.installer-step-errors');
    wrapper.attr('data-step', step);
    wrapper.attr('data-step-error', '');
    errorTypes.forEach(function (type) {
      wrapper.attr(`data-error-${type}`, '');
    });
  },
  removeGlobalErrorNotification: function () {
    var wrapper = $('.installer-step-errors');
    wrapper.removeAttr('data-step-error');
    wrapper.removeAttr('data-error-required');
    wrapper.removeAttr('data-error-validation');
  },
  validateStepForInstallerForm: function (step) {
    Wick.InstallerValidation.removeAllErrorsFromStep(step);

    var inputNames = Object.keys(Wick.InstallerValidation.steps[step]);
    var results = inputNames
      .map(function (elementName) {
        return {
          name: elementName,
          result: Wick.InstallerValidation.checkElement(elementName)
        };
      });
    var isStepInvalid = results.some(function (result) { return !result.result.valid; });
    var errorTypes = results.reduce(function (prev, next) {
      var result = next.result.errorType ? { [next.result.errorType]: true } : {};
      return Object.assign(
        prev,
        result
      )
    }, {});
    errorTypes = Object.keys(errorTypes);

    if (isStepInvalid) {
      var firstErrorField = results.find(function (result) { return !result.result.valid; });
      Wick.InstallerValidation.scrollToField(firstErrorField.name);
      Wick.InstallerValidation.addGlobalErrorNotification(step, errorTypes);
    }

    return !isStepInvalid;
  },
  scrollToField: function (name) {
    var element = $('[name="'+ name +'"]:first');
    var elementHeight = element.height();
    $([document.documentElement, document.body]).animate({
      scrollTop: element.offset().top - elementHeight
    }, 1500);
  },
  validatemultipleFiles: function () {
    var isStepsValid = Wick.multipleFiles.steps
      .map(function (step) { return Wick.InstallerValidation.validateStepFormultipleFiles(step); })
      .every(function (result) { return !!result; });

    return isStepsValid;
  }
};

// Polyfills
if (!Array.prototype.some) {
  Array.prototype.some = function(fun, thisArg) {
    'use strict';

    if (this == null) {
      throw new TypeError('Array.prototype.some called on null or undefined');
    }

    if (typeof fun !== 'function') {
      throw new TypeError();
    }

    var t = Object(this);
    var len = t.length >>> 0;

    for (var i = 0; i < len; i++) {
      if (i in t && fun.call(thisArg, t[i], i, t)) {
        return true;
      }
    }

    return false;
  };
}

if (!Array.isArray) {
  Array.isArray = function(arg) {
    return Object.prototype.toString.call(arg) === '[object Array]';
  };
}

if (!Array.prototype.every) {
  Array.prototype.every = function(callbackfn, thisArg) {
    'use strict';
    var T, k;

    if (this == null) {
      throw new TypeError('this is null or not defined');
    }

    // 1. Let O be the result of calling ToObject passing the this
    //    value as the argument.
    var O = Object(this);

    // 2. Let lenValue be the result of calling the Get internal method
    //    of O with the argument "length".
    // 3. Let len be ToUint32(lenValue).
    var len = O.length >>> 0;

    // 4. If IsCallable(callbackfn) is false, throw a TypeError exception.
    if (typeof callbackfn !== 'function' && Object.prototype.toString.call(callbackfn) !== '[object Function]') {
      throw new TypeError();
    }

    // 5. If thisArg was supplied, let T be thisArg; else let T be undefined.
    if (arguments.length > 1) {
      T = thisArg;
    }

    // 6. Let k be 0.
    k = 0;

    // 7. Repeat, while k < len
    while (k < len) {

      var kValue;

      // a. Let Pk be ToString(k).
      //   This is implicit for LHS operands of the in operator
      // b. Let kPresent be the result of calling the HasProperty internal
      //    method of O with argument Pk.
      //   This step can be combined with c
      // c. If kPresent is true, then
      if (k in O) {
        var testResult;
        // i. Let kValue be the result of calling the Get internal method
        //    of O with argument Pk.
        kValue = O[k];

        // ii. Let testResult be the result of calling the Call internal method
        // of callbackfn with T as the this value if T is not undefined
        // else is the result of calling callbackfn
        // and argument list containing kValue, k, and O.
        if(T) testResult = callbackfn.call(T, kValue, k, O);
        else testResult = callbackfn(kValue,k,O)

        // iii. If ToBoolean(testResult) is false, return false.
        if (!testResult) {
          return false;
        }
      }
      k++;
    }
    return true;
  };
}

if (!Array.prototype.reduce) {
  Object.defineProperty(Array.prototype, 'reduce', {
    value: function(callback /*, initialValue*/) {
      if (this === null) {
        throw new TypeError( 'Array.prototype.reduce ' +
          'called on null or undefined' );
      }
      if (typeof callback !== 'function') {
        throw new TypeError( callback +
          ' is not a function');
      }

      // 1. Let O be ? ToObject(this value).
      var o = Object(this);

      // 2. Let len be ? ToLength(? Get(O, "length")).
      var len = o.length >>> 0;

      // Steps 3, 4, 5, 6, 7
      var k = 0;
      var value;

      if (arguments.length >= 2) {
        value = arguments[1];
      } else {
        while (k < len && !(k in o)) {
          k++;
        }

        // 3. If len is 0 and initialValue is not present,
        //    throw a TypeError exception.
        if (k >= len) {
          throw new TypeError( 'Reduce of empty array ' +
            'with no initial value' );
        }
        value = o[k++];
      }

      // 8. Repeat, while k < len
      while (k < len) {
        // a. Let Pk be ! ToString(k).
        // b. Let kPresent be ? HasProperty(O, Pk).
        // c. If kPresent is true, then
        //    i.  Let kValue be ? Get(O, Pk).
        //    ii. Let accumulator be ? Call(
        //          callbackfn, undefined,
        //          « accumulator, kValue, k, O »).
        if (k in o) {
          value = callback(value, o[k], k, o);
        }

        // d. Increase k by 1.
        k++;
      }

      // 9. Return accumulator.
      return value;
    }
  });
}



var Wick = Wick || {};

Wick.orders = (function () { 
    var currentPage = 0,
    numberOfPages = Number.MAX_VALUE,
    classActiveLoad = 'load-more-wrap--loading',
    loadMoreWrap = $('#loadmorewrap'),
    loadMoreButton = $('#loadmore');

    function triggerLoadMoreResults() {
        loadMoreResults(currentPage + 1);
    }

    function toggleLoad(isLoad) {
        if (isLoad) {
            loadMoreWrap.addClass(classActiveLoad)
        } else {
            setItem()
            loadMoreWrap.removeClass(classActiveLoad)
        }
    }

    function setItem() {
        $('.wismo-hist__table:first').clone().insertBefore(loadMoreWrap)
    }

    function loadMoreResults(page) {
        toggleLoad(true);
        setTimeout(()=>{
            toggleLoad(false);
        }, 1000)
    }

    function initialize() {
        loadMoreButton.click(triggerLoadMoreResults)
    }

    initialize()
})();

var Wick = Wick || {};
Wick.MainNavData = (function () {
    return {
        returnData: function () {
            var data =
                [{
                    "name": "Root",
                    "url": "#",
                    "bold": false,
                    "originalChildrenCount": 17,
                    "children": [{
                        "name": "New in",
                        "url": "/Products/New-In/c/1064000/",
                        "bold": false,
                        "originalChildrenCount": 4,
                        "children": [{
                            "name": "Garden Watering",
                            "url": "/Products/Gardens/Garden-Watering/c/1000694",
                            "bold": false,
                            "originalChildrenCount": 4,
                            "children": [{
                                "name": "GardenHoses And Accessories",
                                "url": "/Gardens/Garden-Watering/Garden-Hoses/c/1000758",
                                "bold": false,
                                "originalChildrenCount": 0
                            }, {
                                "name": "Water Butts And Accessories",
                                "url": "/Gardens/Garden-Watering/Water-Butts/c/1000759",
                                "bold": false,
                                "originalChildrenCount": 0
                            }, {
                                "name": "Garden Pumps And Accessories",
                                "url": "/Gardens/Garden-Watering/Garden-Pumps/c/1000760",
                                "bold": false,
                                "originalChildrenCount": 0
                            }, {
                                "name": "Garden Ponds",
                                "url": "/Gardens/Garden-Watering/Garden-Ponts/c/1000761",
                                "bold": false,
                                "originalChildrenCount": 0
                            }]
                        }, {
                            "name": "Outdoor Heating And BBQs",
                            "url": "/Products/Gardens/Outdoor-Heating+BBQs/c/1000695",
                            "bold": false,
                            "originalChildrenCount": 4,
                            "children": [{
                                "name": "Charcoal BBQs",
                                "url": "/Gardens/Outdoor-Heating-And-BBQs/Charcoal-BBQs/c/1000767",
                                "bold": false,
                                "originalChildrenCount": 0
                            }, {
                                "name": "Gas BBQs",
                                "url": "/Gardens/Outdoor-Heating-And-BBQs/Gas-BBQs/c/1000768",
                                "bold": false,
                                "originalChildrenCount": 0
                            }, {
                                "name": "Masonary BBQs",
                                "url": "/Gardens/Outdoor-Heating-And-BBQs/Masonary-BBQs/c/1000769",
                                "bold": false,
                                "originalChildrenCount": 0
                            }, {
                                "name": "Fire Pits",
                                "url": "/Gardens/Outdoor-Heating-And-BBQs/Fire-Pits/c/1000770",
                                "bold": false,
                                "originalChildrenCount": 0
                            }]
                        }, {
                            "name": "Paving And Walling",
                            "url": "/Products/Gardens/Paving+Walling/c/1000686",
                            "bold": false,
                            "originalChildrenCount": 3,
                            "children": [{
                                "name": "Paving Slabs",
                                "url": "/Gardens/Paving-And-Walling/Paving-Slabs/c/1000715",
                                "bold": false,
                                "originalChildrenCount": 0
                            }, {
                                "name": "Walling",
                                "url": "/Gardens/Paving-And-Walling/Walling/c/1000716",
                                "bold": false,
                                "originalChildrenCount": 0
                            }, {
                                "name": "Driveway Blocks",
                                "url": "/Gardens/Paving-And-Walling/Driveway-Blocks/c/1000717",
                                "bold": false,
                                "originalChildrenCount": 0
                            }]
                        }, {
                            "name": "Decking",
                            "url": "/Products/Gardens/Decking/c/1000685",
                            "bold": false,
                            "originalChildrenCount": 3,
                            "children": [{
                                "name": "Timber Deck Boards",
                                "url": "/Gardens/Decking/TimberDeckBoards/c/1000707",
                                "bold": false,
                                "originalChildrenCount": 0
                            }, {
                                "name": "Railing Kits",
                                "url": "/Gardens/Decking/RailingKits/c/1000709",
                                "bold": false,
                                "originalChildrenCount": 0
                            }, {
                                "name": "Deck Panels",
                                "url": "/Gardens/Decking/DeckPanels/c/1000710",
                                "bold": false,
                                "originalChildrenCount": 0
                            }]
                        }]
                    }, {
                        "name": "Kitchens",
                        "url": "/Kitchens/c/1000916",
                        "bold": false,
                        "originalChildrenCount": 6,
                        "children": [
                            {
                                "name": "TAK",
                                "url": "/Products/Kitchens/c/1000916",
                                "bold": false,
                                "originalChildrenCount": 5,
                                "children": [
                                    {
                                        "name": "Memphis",
                                        "url": "/Kitchens/Take-Away-Kitchen-Cabinets/Memphis/c/1000928",
                                        "bold": false,
                                        "originalChildrenCount": 0
                                    },
                                    {
                                        "name": "Houston",
                                        "url": "/Kitchens/Take-Away-Kitchen-Cabinets/Houston/c/1000929",
                                        "bold": false,
                                        "originalChildrenCount": 0
                                    }, {
                                        "name": "Miami",
                                        "url": "/Kitchens/Take-Away-Kitchen-Cabinets/Miami/c/1000930",
                                        "bold": false,
                                        "originalChildrenCount": 0
                                    }, {
                                        "name": "Galway",
                                        "url": "/Kitchens/Take-Away-Kitchen-Cabinets/Galway/c/1000931",
                                        "bold": false,
                                        "originalChildrenCount": 0
                                    }]
                            }, {
                                "name": "TOK",
                                "url": "/Products/Kitchens/c/1000916",
                                "bold": false,
                                "originalChildrenCount": 5,
                                "children": [{
                                    "name": "Calgary",
                                    "url": "/Kitchens/To-Order-Kitchen-Cabinets/Calgary/c/1000938",
                                    "bold": false,
                                    "originalChildrenCount": 0
                                }, {
                                    "name": "Casablanca",
                                    "url": "/Kitchens/To-Order-Kitchen-Cabinets/Casablanca/c/1000938",
                                    "bold": false,
                                    "originalChildrenCount": 0
                                }, {
                                    "name": "Inverness",
                                    "url": "/Kitchens/To-Order-Kitchen-Cabinets/Inverness/c/1000938",
                                    "bold": false,
                                    "originalChildrenCount": 0
                                }, {
                                    "name": "Marlow",
                                    "url": "/Kitchens/To-Order-Kitchen-Cabinets/Marlow/c/1000938",
                                    "bold": false,
                                    "originalChildrenCount": 0
                                }]
                            }, {
                                "name": "Smart Kitchens",
                                "url": "/Products/Kitchens/c/1000916",
                                "bold": false,
                                "originalChildrenCount": 1,
                                "children": [{
                                    "name": "Smart Kitchens",
                                    "url": "/Kitchens/Smart-Kitchens/c/1000938",
                                    "bold": false,
                                    "originalChildrenCount": 0
                                }]
                            }, {
                                "name": "Kitchen Worktops",
                                "url": "/Products/Kitchens/Kitchen-Worktops/c/1000918",
                                "bold": false,
                                "originalChildrenCount": 5,
                                "children": [{
                                    "name": "Earthstone Worktops",
                                    "url": "/Kitchens/Kitchen-Worktops/Earthstone/c/1000939",
                                    "bold": false,
                                    "originalChildrenCount": 0
                                }, {
                                    "name": "Laminate Worktops",
                                    "url": "/Kitchens/Kitchen-Worktops/Laminate/c/1000940",
                                    "bold": false,
                                    "originalChildrenCount": 0
                                }, {
                                    "name": "Solid Timber Worktops",
                                    "url": "/Kitchens/Kitchen-Worktops/Solid-Timber/c/1000941",
                                    "bold": false,
                                    "originalChildrenCount": 0
                                }, {
                                    "name": "Worktop Trims And Edgings",
                                    "url": "/Kitchens/Kitchen-Worktops/Trims-And-Edgings/c/1000942",
                                    "bold": false,
                                    "originalChildrenCount": 0
                                }]
                            }, {
                                "name": "Kitchen Taps",
                                "url": "/Products/Kitchens/Taps/c/1000923",
                                "bold": false,
                                "originalChildrenCount": 5,
                                "children": [{
                                    "name": "Mono Mixer Taps",
                                    "url": "/Kitchens/Kitchen-Taps/Mono-Mixer/c/1000975",
                                    "bold": false,
                                    "originalChildrenCount": 0
                                }, {
                                    "name": "Water Filter Taps",
                                    "url": "/Kitchens/Kitchen-Taps/Water-Filter/c/1000976",
                                    "bold": false,
                                    "originalChildrenCount": 0
                                }, {
                                    "name": "BridgeTaps",
                                    "url": "/Kitchens/Kitchen-Taps/Bridge/c/1000977",
                                    "bold": false,
                                    "originalChildrenCount": 0
                                }, {
                                    "name": "Kitchen Trade Taps",
                                    "url": "/Kitchens/Kitchen-Taps/Kitchen-Trade/c/1000978",
                                    "bold": false,
                                    "originalChildrenCount": 0
                                }]
                            }, {
                                "name": "Kitched Appliances",
                                "url": "/Products/Kitchens/Kitchen-Appliances/c/1000921",
                                "bold": false,
                                "originalChildrenCount": 5,
                                "children": [{
                                    "name": "Fridges And Freezers",
                                    "url": "/Kitchens/Kitchen-Appliances/Fridges-And-Freezers/c/1000960",
                                    "bold": false,
                                    "originalChildrenCount": 0
                                }, {
                                    "name": "Dishwashers",
                                    "url": "/Kitchens/Kitchen-Appliances/Dishwashers/c/1000961",
                                    "bold": false,
                                    "originalChildrenCount": 0
                                }, {
                                    "name": "Washing Machines",
                                    "url": "/Kitchens/Kitchen-Appliances/Washing-Machines/c/1000962",
                                    "bold": false,
                                    "originalChildrenCount": 0
                                }, {
                                    "name": "Wine Coolers And Beverage Centres",
                                    "url": "/Kitchens/Kitchen-Appliances/Wine-Coolers-And-Beverage-Centres/c/1000963",
                                    "bold": false,
                                    "originalChildrenCount": 0
                                }]
                            }],
                        "banner": "<div class='gg-sitenav-4-reminder'>\r\n    <span>Today's the day – Click &amp; Collect within 30 minutes</span>\r\n</div>"
                    }, {
                        "name": "Bathrooms",
                        "url": "/Bathrooms/c/1000990",
                        "bold": false,
                        "originalChildrenCount": 4,
                        "children": [{
                            "name": "BTOS",
                            "url": "/Products/Bathrooms/Bathroom-Suites/c/1000991",
                            "bold": false,
                            "originalChildrenCount": 5,
                            "children": [{
                                "name": "Rimini",
                                "url": "/Bathrooms/Bathroom-To-Order_suites/Rimini/c/1001013",
                                "bold": false,
                                "originalChildrenCount": 0
                            }, {
                                "name": "Inca",
                                "url": "/Bathrooms/Bathroom-To-Order_suites/Inca/c/1001013",
                                "bold": false,
                                "originalChildrenCount": 0
                            }, {
                                "name": "Phoenix",
                                "url": "/Bathrooms/Bathroom-To-Order_suites/Phoenix/c/1001013",
                                "bold": false,
                                "originalChildrenCount": 0
                            }, {
                                "name": "Belmar",
                                "url": "/Bathrooms/Bathroom-To-Order_suites/Belmar/c/1001013",
                                "bold": false,
                                "originalChildrenCount": 0
                            }]
                        }, {
                            "name": "BTAS",
                            "url": "/Products/Bathrooms/Bathroom-Suites/c/1000991",
                            "bold": false,
                            "originalChildrenCount": 5,
                            "children": [{
                                "name": "Portland",
                                "url": "/Bathrooms/Bathroom-Take-Away_suites/Portland/c/1001002",
                                "bold": false,
                                "originalChildrenCount": 0
                            }, {
                                "name": "Newport",
                                "url": "/Bathrooms/Bathroom-Take-Away_suites/Newport/c/1001003",
                                "bold": false,
                                "originalChildrenCount": 0
                            }, {
                                "name": "Fresno",
                                "url": "/Bathrooms/Bathroom-Take-Away_suites/Fresno/c/1001004",
                                "bold": false,
                                "originalChildrenCount": 0
                            }, {
                                "name": "Bermuda",
                                "url": "/Bathrooms/Bathroom-Take-Away_suites/Bermuda/c/1001005",
                                "bold": false,
                                "originalChildrenCount": 0
                            }]
                        }, {
                            "name": "Bathroom Toilet",
                            "url": "/Products/Bathrooms/Toilets/c/1000992",
                            "bold": false,
                            "originalChildrenCount": 5,
                            "children": [{
                                "name": "Basin And Toilet Packs",
                                "url": "/Bathrooms/Bathroom-Toilets/Basin-And-Toilet-Packs/c/1001015",
                                "bold": false,
                                "originalChildrenCount": 0
                            }, {
                                "name": "Toilets To Go",
                                "url": "/Bathrooms/Bathroom-Toilets/Toilets-To-Go/c/1000992",
                                "bold": false,
                                "originalChildrenCount": 0
                            }, {
                                "name": "Toilet Pan Units",
                                "url": "/Bathrooms/Bathroom-Toilets/Toilet-Pans/c/1001016",
                                "bold": false,
                                "originalChildrenCount": 0
                            }, {
                                "name": "Toilet Cisterns",
                                "url": "/Bathrooms/Bathroom-Toilets/Toilet-Cisterns/c/1001017",
                                "bold": false,
                                "originalChildrenCount": 0
                            }]
                        }, {
                            "name": "Baths Aggregates",
                            "url": "/Products/Bathrooms/Baths/c/1000993",
                            "bold": false,
                            "originalChildrenCount": 5,
                            "children": [{
                                "name": "Bath Accessories",
                                "url": "/Bathrooms/Baths/Accessories/c/1001021",
                                "bold": false,
                                "originalChildrenCount": 0
                            }, {
                                "name": "Bath Panels",
                                "url": "/Bathrooms/Baths/Panels/c/1001022",
                                "bold": false,
                                "originalChildrenCount": 0
                            }, {
                                "name": "Bath Screens",
                                "url": "/Bathrooms/Baths/Screens/c/1001023",
                                "bold": false,
                                "originalChildrenCount": 0
                            }, {
                                "name": "Bath Tub Units",
                                "url": "/Bathrooms/Baths/Tub-Units/c/1001024",
                                "bold": false,
                                "originalChildrenCount": 0
                            }]
                        }]
                    }, {
                        "name": "Building Materials",
                        "url": "/BuildingMaterials/c/1000173",
                        "bold": false,
                        "originalChildrenCount": 1,
                        "children": [{
                            "name": "Cement Mortar And Aggregates",
                            "url": "/Products/Building-Materials/Cement+Aggregates/c/1000176",
                            "bold": false,
                            "originalChildrenCount": 3,
                            "children": [{
                                "name": "Concrete And Cement",
                                "url": "/BuildingMaterials/Concrete-Mortar-And-Aggregates/Concrete-And-Cement/c/1000208",
                                "bold": false,
                                "originalChildrenCount": 0
                            }, {
                                "name": "Aggregates And Sand",
                                "url": "/BuildingMaterials/Concrete-Mortar-And-Aggregates/Aggregates-And-Sand/c/1000209",
                                "bold": false,
                                "originalChildrenCount": 0
                            }, {
                                "name": "Floor Levelling Compound",
                                "url": "/BuildingMaterials/Concrete-Mortar-And-Aggregates/Floor-Levelling-Compound/c/1000210",
                                "bold": false,
                                "originalChildrenCount": 0
                            }]
                        }]
                    }, {
                        "name": "Doors & Windows",
                        "url": "/DoorsAndWindows/c/1000601",
                        "bold": false,
                        "originalChildrenCount": 1,
                        "children": [{
                            "name": "Doors Stab",
                            "url": "/Products/Doors+Windows/c/1000601",
                            "bold": false,
                            "originalChildrenCount": 0,
                            "children": []
                        }]
                    }, {
                        "name": "Gardens",
                        "url": "/Gardens/c/1000683",
                        "bold": false,
                        "originalChildrenCount": 4,
                        "children": [{
                            "name": "Garden Watering",
                            "url": "/Products/Gardens/Garden-Watering/c/1000694",
                            "bold": false,
                            "originalChildrenCount": 4,
                            "children": [{
                                "name": "GardenHoses And Accessories",
                                "url": "/Gardens/Garden-Watering/Garden-Hoses/c/1000758",
                                "bold": false,
                                "originalChildrenCount": 0
                            }, {
                                "name": "Water Butts And Accessories",
                                "url": "/Gardens/Garden-Watering/Water-Butts/c/1000759",
                                "bold": false,
                                "originalChildrenCount": 0
                            }, {
                                "name": "Garden Pumps And Accessories",
                                "url": "/Gardens/Garden-Watering/Garden-Pumps/c/1000760",
                                "bold": false,
                                "originalChildrenCount": 0
                            }, {
                                "name": "Garden Ponds",
                                "url": "/Gardens/Garden-Watering/Garden-Ponts/c/1000761",
                                "bold": false,
                                "originalChildrenCount": 0
                            }]
                        }, {
                            "name": "Outdoor Heating And BBQs",
                            "url": "/Products/Gardens/Outdoor-Heating+BBQs/c/1000695",
                            "bold": false,
                            "originalChildrenCount": 4,
                            "children": [{
                                "name": "Charcoal BBQs",
                                "url": "/Gardens/Outdoor-Heating-And-BBQs/Charcoal-BBQs/c/1000767",
                                "bold": false,
                                "originalChildrenCount": 0
                            }, {
                                "name": "Gas BBQs",
                                "url": "/Gardens/Outdoor-Heating-And-BBQs/Gas-BBQs/c/1000768",
                                "bold": false,
                                "originalChildrenCount": 0
                            }, {
                                "name": "Masonary BBQs",
                                "url": "/Gardens/Outdoor-Heating-And-BBQs/Masonary-BBQs/c/1000769",
                                "bold": false,
                                "originalChildrenCount": 0
                            }, {
                                "name": "Fire Pits",
                                "url": "/Gardens/Outdoor-Heating-And-BBQs/Fire-Pits/c/1000770",
                                "bold": false,
                                "originalChildrenCount": 0
                            }]
                        }, {
                            "name": "Paving And Walling",
                            "url": "/Products/Gardens/Paving+Walling/c/1000686",
                            "bold": false,
                            "originalChildrenCount": 3,
                            "children": [{
                                "name": "Paving Slabs",
                                "url": "/Gardens/Paving-And-Walling/Paving-Slabs/c/1000715",
                                "bold": false,
                                "originalChildrenCount": 0
                            }, {
                                "name": "Walling",
                                "url": "/Gardens/Paving-And-Walling/Walling/c/1000716",
                                "bold": false,
                                "originalChildrenCount": 0
                            }, {
                                "name": "Driveway Blocks",
                                "url": "/Gardens/Paving-And-Walling/Driveway-Blocks/c/1000717",
                                "bold": false,
                                "originalChildrenCount": 0
                            }]
                        }, {
                            "name": "Decking",
                            "url": "/Products/Gardens/Decking/c/1000685",
                            "bold": false,
                            "originalChildrenCount": 3,
                            "children": [{
                                "name": "Timber Deck Boards",
                                "url": "/Gardens/Decking/TimberDeckBoards/c/1000707",
                                "bold": false,
                                "originalChildrenCount": 0
                            }, {
                                "name": "Railing Kits",
                                "url": "/Gardens/Decking/RailingKits/c/1000709",
                                "bold": false,
                                "originalChildrenCount": 0
                            }, {
                                "name": "Deck Panels",
                                "url": "/Gardens/Decking/DeckPanels/c/1000710",
                                "bold": false,
                                "originalChildrenCount": 0
                            }]
                        }]
                    }, {
                        "name": "Flooring",
                        "url": "/Products/Flooring/c/1200003",
                        "offers": {
                            "name": "Tiles Offers",
                            "offers": [{
                                "name": "Tiles Kitched Offers Single one",
                                "url": "/tilesKitchedOffersSingleLink",
                                "bold": false
                            }, {
                                "name": "Tiles Kitched Offers Single two",
                                "url": "/tilesKitchedOffersSingleLink2",
                                "bold": false
                            }, {
                                "name": "Tiles Offers Kitched",
                                "url": "/tilesKitchedOffersMediaLink",
                                "image": "/medias/cloudshop-sample-image-148x300.jpg?context=bWFzdGVyfGltYWdlc3wyNjQ4fGltYWdlL2pwZWd8aW1hZ2VzL2gyNi9oOWUvODc5NjIwNzU0NjM5OC5qcGd8NDBlMTI2Mzg4ODMwOGY3MTBjMTY3ZGE4MGVhOTQ3MWMxNzBjYmQxNTk4NWFhZDE2NmI5MjRhMDhhZjhmMWRlMQ",
                                "bold": false
                            }]
                        },
                        "bold": false,
                        "originalChildrenCount": 3,
                        "children": [{
                            "name": "Tiles Kitched",
                            "url": "/Products/Tiles/Kitchen-Tiles/c/1000802",
                            "bold": false,
                            "originalChildrenCount": 2,
                            "children": [{
                                "url": "/Products/Tiles/Kitchen-Tiles/Kitchen-Wall-Tiles/c/1000813",
                                "bold": false,
                                "originalChildrenCount": 0
                            }, {
                                "url": "/Products/Tiles/Kitchen-Tiles/Kitchen-Floor-Tiles/c/1000812",
                                "bold": false,
                                "originalChildrenCount": 0
                            }]
                        }, {
                            "name": "Tiles Bathroom",
                            "url": "/Products/Tiles/Bathroom-Tiles/c/1000801",
                            "bold": false,
                            "originalChildrenCount": 2,
                            "children": [{
                                "url": "/Products/Tiles/Bathroom-Tiles/Bathroom-Wall-Floor/c/1000811",
                                "bold": false,
                                "originalChildrenCount": 0
                            }, {
                                "url": "/Products/Tiles/Bathroom-Tiles/Bathroom-Floor-Tiles/c/1000810",
                                "bold": false,
                                "originalChildrenCount": 0
                            }]
                        }]
                    }, {
                        "name": "Tiles",
                        "url": "Products/Tiles/c/1000800",
                        "offers": {
                            "name": "Tiles Offers",
                            "offers": [{
                                "name": "Tiles Kitched Offers Single one",
                                "url": "/tilesKitchedOffersSingleLink",
                                "bold": false
                            }, {
                                "name": "Tiles Kitched Offers Single two",
                                "url": "/tilesKitchedOffersSingleLink2",
                                "bold": false
                            }, {
                                "name": "Tiles Offers Kitched",
                                "url": "/tilesKitchedOffersMediaLink",
                                "image": "/medias/cloudshop-sample-image-148x300.jpg?context=bWFzdGVyfGltYWdlc3wyNjQ4fGltYWdlL2pwZWd8aW1hZ2VzL2gyNi9oOWUvODc5NjIwNzU0NjM5OC5qcGd8NDBlMTI2Mzg4ODMwOGY3MTBjMTY3ZGE4MGVhOTQ3MWMxNzBjYmQxNTk4NWFhZDE2NmI5MjRhMDhhZjhmMWRlMQ",
                                "bold": false
                            }]
                        },
                        "bold": false,
                        "originalChildrenCount": 3,
                        "children": [{
                            "name": "Tiles Kitched",
                            "url": "/Products/Tiles/Kitchen-Tiles/c/1000802",
                            "bold": false,
                            "originalChildrenCount": 2,
                            "children": [{
                                "url": "/Products/Tiles/Kitchen-Tiles/Kitchen-Wall-Tiles/c/1000813",
                                "bold": false,
                                "originalChildrenCount": 0
                            }, {
                                "url": "/Products/Tiles/Kitchen-Tiles/Kitchen-Floor-Tiles/c/1000812",
                                "bold": false,
                                "originalChildrenCount": 0
                            }]
                        }, {
                            "name": "Tiles Bathroom",
                            "url": "/Products/Tiles/Bathroom-Tiles/c/1000801",
                            "bold": false,
                            "originalChildrenCount": 2,
                            "children": [{
                                "url": "/Products/Tiles/Bathroom-Tiles/Bathroom-Wall-Floor/c/1000811",
                                "bold": false,
                                "originalChildrenCount": 0
                            }, {
                                "url": "/Products/Tiles/Bathroom-Tiles/Bathroom-Floor-Tiles/c/1000810",
                                "bold": false,
                                "originalChildrenCount": 0
                            }]
                        }]
                    }, {
                        "name": "Decorating & Interiors",
                        "url": "/DecoratingAndInteriors/c/1000554",
                        "bold": false,
                        "originalChildrenCount": 1,
                        "children": [{
                            "name": "Interriors Stab",
                            "url": "/Products/Decorating+Interiors/c/1000554",
                            "bold": false,
                            "originalChildrenCount": 0,
                            "children": []
                        }]
                    }, {
                        "name": "Electrical & Lighting",
                        "url": "/products/Electrical+Lighting/c/1000048",
                        "bold": false,
                        "originalChildrenCount": 3,
                        "children": [{
                            "name": "Hand Tools",
                            "url": "/Products/Tools+Workwear/Hand-Tools/c/1000366",
                            "bold": false,
                            "originalChildrenCount": 2,
                            "children": [{
                                "name": "Hand Saws And Blades",
                                "url": "/Tools-Electrical-And-Plumbing/Hand-Tools/Hand-Saws-And-Blades/c/1000402",
                                "bold": false,
                                "originalChildrenCount": 0
                            }, {
                                "name": "Screwdrivers And Ratchets",
                                "url": "/Tools-Electrical-And-Plumbing/Hand-Tools/Screwdrivers-And-Ratchets/c/1000405",
                                "bold": false,
                                "originalChildrenCount": 0
                            }]
                        }, {
                            "name": "Work Wear",
                            "url": "/Products/Tools+Workwear/Workwear/c/1000367",
                            "bold": false,
                            "originalChildrenCount": 2,
                            "children": [{
                                "name": "Trousers And Shirts",
                                "url": "/Tools-Electrical-And-Plumbing/Workwear/Trousers-And-Shirts/c/1000430",
                                "bold": false,
                                "originalChildrenCount": 0
                            }, {
                                "name": "Footwear",
                                "url": "/Tools-Electrical-And-Plumbing/Workwear/Footwear/c/1000431",
                                "bold": false,
                                "originalChildrenCount": 0
                            }]
                        }, {
                            "name": "Power Tools",
                            "url": "/Products/Tools+Workwear/Power-Tools/c/1000362",
                            "bold": false,
                            "originalChildrenCount": 2,
                            "children": [{
                                "name": "Cordless Drills",
                                "url": "/Tools-Electrical-And-Plumbing/Power-Tools/Cordless-Drills/c/1000371",
                                "bold": false,
                                "originalChildrenCount": 0
                            }, {
                                "name": "Power Saws",
                                "url": "/Tools-Electrical-And-Plumbing/Power-Tools/Power-Saws/c/1000374",
                                "bold": false,
                                "originalChildrenCount": 0
                            }]
                        }]
                    }, {
                        "name": "Heating & Plumbing",
                        "url": "/Heating+Plumbing/c/1000458",
                        "bold": true,
                        "color": "GREEN",
                        "originalChildrenCount": 1,
                        "children": [{
                            "name": "Plumbing Tools & Accessories",
                            "url": "/Heating+Plumbing/Plumbing-Tools+Accessories/c/1000462",
                            "bold": true,
                            "color": "RED",
                            "originalChildrenCount": 1,
                            "children": [{
                                "name": "Clips & Conduit",
                                "url": "/Heating+Plumbing/Plumbing-Tools+Accessories/Clips+Conduit/c/1000480",
                                "bold": false,
                                "originalChildrenCount": 0
                            }]
                        }],
                        "appIcon": "/testIcon"
                    }, {
                        "name": "Nails Screws & Adhesives",
                        "url": "/Products/Nails%2C-Screws+Adhesives/c/1000001",
                        "offers": {
                            "name": "Tiles Offers",
                            "offers": [{
                                "name": "Tiles Kitched Offers Single one",
                                "url": "/tilesKitchedOffersSingleLink",
                                "bold": false
                            }, {
                                "name": "Tiles Kitched Offers Single two",
                                "url": "/tilesKitchedOffersSingleLink2",
                                "bold": false
                            }, {
                                "name": "Tiles Offers Kitched",
                                "url": "/tilesKitchedOffersMediaLink",
                                "image": "/medias/cloudshop-sample-image-148x300.jpg?context=bWFzdGVyfGltYWdlc3wyNjQ4fGltYWdlL2pwZWd8aW1hZ2VzL2gyNi9oOWUvODc5NjIwNzU0NjM5OC5qcGd8NDBlMTI2Mzg4ODMwOGY3MTBjMTY3ZGE4MGVhOTQ3MWMxNzBjYmQxNTk4NWFhZDE2NmI5MjRhMDhhZjhmMWRlMQ",
                                "bold": false
                            }]
                        },
                        "bold": false,
                        "originalChildrenCount": 3,
                        "children": [{
                            "name": "Tiles Kitched",
                            "url": "/Products/Tiles/Kitchen-Tiles/c/1000802",
                            "bold": false,
                            "originalChildrenCount": 2,
                            "children": [{
                                "url": "/Products/Tiles/Kitchen-Tiles/Kitchen-Wall-Tiles/c/1000813",
                                "bold": false,
                                "originalChildrenCount": 0
                            }, {
                                "url": "/Products/Tiles/Kitchen-Tiles/Kitchen-Floor-Tiles/c/1000812",
                                "bold": false,
                                "originalChildrenCount": 0
                            }]
                        }, {
                            "name": "Tiles Bathroom",
                            "url": "/Products/Tiles/Bathroom-Tiles/c/1000801",
                            "bold": false,
                            "originalChildrenCount": 2,
                            "children": [{
                                "url": "/Products/Tiles/Bathroom-Tiles/Bathroom-Wall-Floor/c/1000811",
                                "bold": false,
                                "originalChildrenCount": 0
                            }, {
                                "url": "/Products/Tiles/Bathroom-Tiles/Bathroom-Floor-Tiles/c/1000810",
                                "bold": false,
                                "originalChildrenCount": 0
                            }]
                        }]
                    }, {
                        "name": "Security & Hardware",
                        "url": "/Products/Security+Ironmongery/c/1008006",
                        "bold": false,
                        "originalChildrenCount": 3,
                        "children": [{
                            "name": "Hand Tools",
                            "url": "/Products/Tools+Workwear/Hand-Tools/c/1000366",
                            "bold": false,
                            "originalChildrenCount": 2,
                            "children": [{
                                "name": "Hand Saws And Blades",
                                "url": "/Tools-Electrical-And-Plumbing/Hand-Tools/Hand-Saws-And-Blades/c/1000402",
                                "bold": false,
                                "originalChildrenCount": 0
                            }, {
                                "name": "Screwdrivers And Ratchets",
                                "url": "/Tools-Electrical-And-Plumbing/Hand-Tools/Screwdrivers-And-Ratchets/c/1000405",
                                "bold": false,
                                "originalChildrenCount": 0
                            }]
                        }, {
                            "name": "Work Wear",
                            "url": "/Products/Tools+Workwear/Workwear/c/1000367",
                            "bold": false,
                            "originalChildrenCount": 2,
                            "children": [{
                                "name": "Trousers And Shirts",
                                "url": "/Tools-Electrical-And-Plumbing/Workwear/Trousers-And-Shirts/c/1000430",
                                "bold": false,
                                "originalChildrenCount": 0
                            }, {
                                "name": "Footwear",
                                "url": "/Tools-Electrical-And-Plumbing/Workwear/Footwear/c/1000431",
                                "bold": false,
                                "originalChildrenCount": 0
                            }]
                        }, {
                            "name": "Power Tools",
                            "url": "/Products/Tools+Workwear/Power-Tools/c/1000362",
                            "bold": false,
                            "originalChildrenCount": 2,
                            "children": [{
                                "name": "Cordless Drills",
                                "url": "/Tools-Electrical-And-Plumbing/Power-Tools/Cordless-Drills/c/1000371",
                                "bold": false,
                                "originalChildrenCount": 0
                            }, {
                                "name": "Power Saws",
                                "url": "/Tools-Electrical-And-Plumbing/Power-Tools/Power-Saws/c/1000374",
                                "bold": false,
                                "originalChildrenCount": 0
                            }]
                        }]
                    }, {
                        "name": "Tools & Workwear",
                        "url": "/Products/Tools+Workwear/c/1000361/",
                        "offers": {
                            "name": "Tiles Offers",
                            "offers": [{
                                "name": "Tiles Kitched Offers Single one",
                                "url": "/tilesKitchedOffersSingleLink",
                                "bold": false
                            }, {
                                "name": "Tiles Kitched Offers Single two",
                                "url": "/tilesKitchedOffersSingleLink2",
                                "bold": false
                            }, {
                                "name": "Tiles Offers Kitched",
                                "url": "/tilesKitchedOffersMediaLink",
                                "image": "/medias/cloudshop-sample-image-148x300.jpg?context=bWFzdGVyfGltYWdlc3wyNjQ4fGltYWdlL2pwZWd8aW1hZ2VzL2gyNi9oOWUvODc5NjIwNzU0NjM5OC5qcGd8NDBlMTI2Mzg4ODMwOGY3MTBjMTY3ZGE4MGVhOTQ3MWMxNzBjYmQxNTk4NWFhZDE2NmI5MjRhMDhhZjhmMWRlMQ",
                                "bold": false
                            }]
                        },
                        "bold": false,
                        "originalChildrenCount": 3,
                        "children": [{
                            "name": "Tiles Kitched",
                            "url": "/Products/Tiles/Kitchen-Tiles/c/1000802",
                            "bold": false,
                            "originalChildrenCount": 2,
                            "children": [{
                                "url": "/Products/Tiles/Kitchen-Tiles/Kitchen-Wall-Tiles/c/1000813",
                                "bold": false,
                                "originalChildrenCount": 0
                            }, {
                                "url": "/Products/Tiles/Kitchen-Tiles/Kitchen-Floor-Tiles/c/1000812",
                                "bold": false,
                                "originalChildrenCount": 0
                            }]
                        }, {
                            "name": "Tiles Bathroom",
                            "url": "/Products/Tiles/Bathroom-Tiles/c/1000801",
                            "bold": false,
                            "originalChildrenCount": 2,
                            "children": [{
                                "url": "/Products/Tiles/Bathroom-Tiles/Bathroom-Wall-Floor/c/1000811",
                                "bold": false,
                                "originalChildrenCount": 0
                            }, {
                                "url": "/Products/Tiles/Bathroom-Tiles/Bathroom-Floor-Tiles/c/1000810",
                                "bold": false,
                                "originalChildrenCount": 0
                            }]
                        }],
                        "appIcon": "/takOffers"
                    }]
                }]
            return data;
        }
    }
})();

var Wick = Wick || {};
Wick.MainNavLocal = (function(){
    function init() {
        var localOptions = {
            local: true,
            mockData: Wick.MainNavData.returnData()
        };

        if (!$('#main-nav').length) {
            return;
        }
        
        setTimeout(()=> {
            Wick.MainNav.createMainNav(localOptions);
        }, 2000)
    }

    init();
})();

var Wick = Wick || {};
Wick.ShoppingCart = (function(){
  var $btn = $('.header-minicart__switcher');

  function isEmpty() {
    return localStorage.isEmpty === 'true';
  }

  function clear() {
    localStorage.isEmpty = true;
    $btn.find('.header-minicart__counter').removeClass('_is-visible');
    Wick.MiniBasket.disableRollover();
  }

  function add() {
    localStorage.isEmpty = false;
    $btn.find('.header-minicart__counter').addClass('_is-visible');
  }

  function bindEvents() {
    $('.btn-add-to-basket, .page-product-details .card-store-collect__btn').on('click', add);
  }

  var init = function () {
    bindEvents();

    if(isEmpty()){
      clear();
    } else {
      $btn.find('.header-minicart__counter').addClass('_is-visible');
    }
  };

  $(document).ready(init);

  return {
    clear: clear
  };
})();

$(document).ready(function() {
    var $el = $('.header-minicart__switcher'),
        $expandedEl = $("footer");

    $el.popover().on('shown.bs.popover', function () {
        var $actualHeight = $(".popover").innerHeight();
        if ($actualHeight > 680) {
            $expandedEl.css("padding-top", "100px")
        }
    })
        .on('hidden.bs.popover', function () {
            $expandedEl.css("padding-top", "inherit")
        })
})
const paymentLoader = '.payment-loader';
const paymentLoaderHideClass = 'payment-loader--hidden';
const applePayButton = '.apple__button';
const googlePayButton = '.google__button';

const showPaymentLoader = () => {
  $(paymentLoader).removeClass(paymentLoaderHideClass);
  setTimeout(() => $(paymentLoader).addClass(paymentLoaderHideClass), 1000);
};

$(document).on('click', applePayButton, showPaymentLoader);
$(document).on('click', googlePayButton, showPaymentLoader);

var Wick = Wick || {};

Wick.pdfFileLoader = {
  maximumFileSize: 100000,
  fileSizeErrorText: 'File size exceeds the maximum limit',
  fileTypeErrorText: 'File type must be PDF',
  class: {
    disableButtonsClass: 'pdf-loader__buttons--disable',
  },
  fileInput: Wick.fileLoader('pdf-loader'),
  loader: new Wick.Loader('.pdf-loader-wrapper'),
  elements: {
    buttonsLoader: $('.pdf-loader__buttons'),
    addProjectList: $('#add-to-project-list'),
    convertToCSV: $('#convert-to-csv'),
  },

  enableButton() {
    this.elements.buttonsLoader.removeClass(this.class.disableButtonsClass)
  },
  disableButton() {
    this.elements.buttonsLoader.addClass(this.class.disableButtonsClass)
  },

  validateFile(files) {
    const { name, size } = files[0];

    if (size > Wick.pdfFileLoader.maximumFileSize) {
      Wick.pdfFileLoader.fileInput.showError(Wick.pdfFileLoader.fileSizeErrorText);
      Wick.pdfFileLoader.disableButton();
      return false
    }

    if(!name.endsWith('pdf')) {
      Wick.pdfFileLoader.fileInput.showError(Wick.pdfFileLoader.fileTypeErrorText);
      Wick.pdfFileLoader.disableButton();
      return false
    }

    return true
  },

  bindEvents() {
    Wick.pdfFileLoader.fileInput.getElementInput().change(function() {
      const fileName = this.files[0].name;

      if (this.files.length) {
        if (Wick.pdfFileLoader.validateFile(this.files)) {
          Wick.pdfFileLoader.fileInput.hideError();
          Wick.pdfFileLoader.enableButton();
        }

        Wick.pdfFileLoader.fileInput.setLabelText(fileName);
      } else {
        Wick.pdfFileLoader.fileInput.clearFileLoader()
        Wick.pdfFileLoader.disableButton()
      }
    })

    Wick.pdfFileLoader.elements.addProjectList.click(() => {
      Wick.pdfFileLoader.loader.showLoader();
      setTimeout(() => {
        Wick.pdfFileLoader.loader.hideLoader()
        Wick.pdfFileLoader.fileInput.clearFileLoader();
        Wick.pdfFileLoader.disableButton();
      }, 1000)

    })
    Wick.pdfFileLoader.elements.convertToCSV.click(() => {
      Wick.pdfFileLoader.loader.showLoader();
      setTimeout(() => {
        Wick.pdfFileLoader.loader.hideLoader()
        Wick.pdfFileLoader.fileInput.clearFileLoader();
        Wick.pdfFileLoader.disableButton();
      }, 1000)
    })
  },

  init() {
    Wick.pdfFileLoader.bindEvents();
  }
}

$(document).ready(() => {

  if (!$('.pdf-loader-wrapper').length) {
    return;
  }

  Wick.pdfFileLoader.init();

  if (Wick.pdfFileLoader.fileInput.getElementLabel().length) {
    Wick.Responsive.onBreakpoint(function () {
      $clamp(Wick.pdfFileLoader.fileInput.getElementLabel()[0], {clamp: 1});
    }, 'up-lg');
    Wick.Responsive.onBreakpoint(function () {
      $clamp(Wick.pdfFileLoader.fileInput.getElementLabel()[0], {clamp: 2});
    }, 'down-lg');
  }
})

var Wick = Wick || {};
Wick.MiniBasket = (function() {
  var $el = $('.header-minicart-wrap .header-minicart__switcher');

  if (Wick.Responsive.getCurrentBreakpoint() === 'up-lg') {
    $el = $('.header-right__item .header-minicart__switcher');
  }

  var $rollover = $('#mini-basket-rollover'),
    $popup = $('#mini-basket-popup'),
    $body = $('body'),
    fixContent = 'fixed-content',
    $switcherBtn = $('.header-minicart__btn_switcher'),
    $linkBtn = $('.header-minicart__btn_link');

  if (!$el.length) {
    return;
  }
    //fix for iOS 13
  if (Wick.Responsive.isTouchDevice()) {
    $linkBtn.on('touchstart', function () {
      document.location.href = $linkBtn[0].href;
    });
  }

  var showMiniBasketLink = function () {
    $switcherBtn.hide();
    $linkBtn.show();
    $body.addClass(fixContent);
  };

  var hideMiniBasketLink = function () {
    $switcherBtn.show();
    $linkBtn.hide();
    $body.removeClass(fixContent);
  };

  var removeSwitcherButton = function () {
    $switcherBtn.remove();
    $linkBtn.show();
    $body.removeClass(fixContent);
  };

  var rollover = {
    isExist: false,
    isDisabled: false,
    self: '.popover-mini-basket_permanent',
    productTitle: '.popover-mini-basket_permanent .product-card__title',
    create: function(){
      popup.destory();

      var $popover = $el.popover({
        trigger: 'manual',
        html: true,
        placement: 'bottom',
        fallbackPlacement: 'clockwise',
        offset: '-65%',
        content: $rollover.html()
      });

      $popover.on('inserted.bs.popover', function(){
        $(rollover.productTitle).each(function (index, value) {
          $clamp(value, {clamp: 3});
        });
      });

      if (Wick.Responsive.isTouchDevice()) {
        $popover.on('hidden.bs.popover', hideMiniBasketLink).on('shown.bs.popover', showMiniBasketLink);
      }

      rollover.isExist = true;
    },
    _bindTouchEvents: function(){
      if (!Wick.Responsive.isTouchDevice()){
        return;
      }

      $el
      .on('touchstart', function(){
        if (rollover.isDisabled){
          empty.show();
          return;
        }

        if (!rollover.isExist){
          rollover.create();
        }
        $el.popover('show');
      });

      $(document).off("touchstart.leaveBasket").on("touchstart.leaveBasket", function (e) {
        if (!$('.popover').hasClass('show')
          || $(e.target).parents(rollover.self).length
          || $(e.target).closest('.header-minicart__btn').length) {
          return;
        };

        $el.popover('hide');
        $el.tooltip('hide');
      });
    },
    _bindEvents: function(){
      if (Wick.Responsive.isTouchDevice()){
        return;
      }

      $el
      .on('mouseenter', function() {
        if (rollover.isDisabled){
          return;
        }

        if (!rollover.isExist){
          rollover.create();
        }

        $el.popover('show');
      })
      .on('mouseleave', function() {
        setTimeout(function() {
          if (!$('.popover:hover').length) {
            $el.popover('hide');
          }
        }, 100);
      });

      $(document).on('mouseleave', rollover.self, function(){
        $el.popover('hide');
      });
    },
    bindEvents: function(){
      this._bindEvents();
      this._bindTouchEvents();
    },
    enable: function(){
      rollover.isDisabled = false;
    },
    disable: function(){
      rollover.isDisabled = true;
    },
    destory: function(){
      if (!rollover.isExist){
        return;
      }

      $el.popover('dispose');
      rollover.isExist = false;
    }
  };

  var popup = {
    isExist: false,
    timeout: undefined,
    productTitle: '.popover-mini-basket_just-added .product-card__title',
    btnClose: '.popover-mini-basket_just-added .notification__close',
    create: function(){
      var $justAddedPopover = $el
      .popover({
        trigger: 'manual',
        html: true,
        placement: 'bottom',
        fallbackPlacement: 'clockwise',
        offset: '-65%',
        content: $popup.html()
      })
      .popover('show');

      if (Wick.Responsive.isTouchDevice()) {
        $justAddedPopover.on('shown.bs.popover', hideMiniBasketLink);
      }

      popup.timeout = setTimeout(function() {
        popup.destory();
      }, 6000);

      $(popup.productTitle).each(function (index, value) {
        $clamp(value, {clamp: 3});
      });

      $('html, body').animate({ scrollTop: 0 }, 300);

      popup.isExist = true;
    },
    bindEvents: function(){
      $(document).on('click', popup.btnClose, function(){
        popup.destory();
      });
    },
    destory: function(){
      if (!popup.isExist){
        return;
      }

      $el.popover('dispose');
      popup.isExist = false;
      clearTimeout(popup.timeout);
    }
  };

  var empty = {
    create: function(){
      var $tooltip = $el.tooltip({
        title: 'Your basket is currently empty',
        placement: 'bottom',
        offset: '-15%',
        template: '<div class="tooltip popover-mini-basket__tooltip" role="tooltip"><div class="arrow"></div><div class="tooltip-inner"></div></div>'
      });

      if (Wick.Responsive.isTouchDevice()) {
        $tooltip.on('hidden.bs.tooltip', hideMiniBasketLink).on('shown.bs.tooltip', showMiniBasketLink);
      }
    },
    show: function(){
      $el.tooltip('show');
    },
    destroy: function(){
      $el.tooltip('dispose');
    }
  };

  if (!Wick.Responsive.isTouchDevice()) {
    removeSwitcherButton();
  }

  if ($rollover.length){
    rollover.bindEvents();
    rollover.create();
  } else {
    empty.create();
  }

  if ($popup.length){
    popup.bindEvents();
  }

  return {
    showJustAdded: function(){
      rollover.destory();
      rollover.enable();
      popup.create();
      empty.destroy();
    },
    disableRollover: function(){
      rollover.disable();
      empty.create();
    }
  };
})();

var Wick = Wick || {};

Wick.ProjectListMultiple = {
    el: {
      actionBlockBtn: '.action-block_btn',
      formListName: '.form-list-name',
      formRowValidationErrorClass: 'form-row_validation-error',
      formListNameTbx: '.form-list-name_tbx',
      formListNameInfo: '.form-list-name_info',
      tbxErrorClass: 'tbx_error',
      formRowError: 'form-row__error',
      errorText: 'Invalid character(s), please remove any instances of @%£/\|[]{}.-'
    },
    bindAll() {
        Wick.ProjectListMultiple.bindButtons();
    },
    showValidationError() {
      $(Wick.ProjectListMultiple.el.formListNameInfo).text(Wick.ProjectListMultiple.el.errorText);
      $(Wick.ProjectListMultiple.el.formListNameInfo).removeClass('d-none');
    },
    bindButtons() {
      $(Wick.ProjectListMultiple.el.actionBlockBtn).on('click', function () {
        $(Wick.ProjectListMultiple.el.formListName).addClass(Wick.ProjectListMultiple.el.formRowValidationErrorClass);
        $(Wick.ProjectListMultiple.el.formListNameTbx).addClass(Wick.ProjectListMultiple.el.tbxErrorClass);
        $(Wick.ProjectListMultiple.el.formListNameInfo).addClass(Wick.ProjectListMultiple.el.formRowError);
        Wick.ProjectListMultiple.showValidationError();
      });
    }
};

$(document).ready(function() {
    Wick.ProjectListMultiple.bindAll();
});

function returnErrorCreatePayload() {
  return {
    message: 'Min. characters 5, max. characters 59, only use characters A-Z and 0-9'
  };
}

function returnErrorSelectPayload() {
  return {
    message: 'Something went wrong'
  };
}

function returnSuccessSelectPayload() {
  return {
    currentProjectList: {
      name: 'Loremipsumdolorsitamet,consecteturadipiscingelit,seddoeiusmodtemporincididuntutlaboreetdoloremagnaaliqua.Utenimadminimveniam',
      id: 123,
      link: '/page_my-shopping-list.html',
      isFull: true,
      products: [
        {
          name: 'BoschPSB1800LI218VLiIonCordlessCombiDrillExamplewithlongtitleintworaws',
          image: '//media.wickes.co.uk/is/image/wickes/B3182_221100_00?$largeNormal$&defaultImage=wickes/2018-Wickes-Missing-Product-650x650',
          itemTotal: '£2.00',
          quantity: 1,
        },
        {
          name: 'Bosch PSB 1800 LI-2 18V Li-Ion Cordless Combi Drill Example with long title in two raws',
          image: '//media.wickes.co.uk/is/image/wickes/B3182_224661_00?$largeNormal$&defaultImage=wickes/2018-Wickes-Missing-Product-650x650',
          itemTotal: '£1.00',
          quantity: 2,
        },
        {
          name: 'Bosch PSB 1800 LI-2 18V Li-Ion Cordless Combi Drill Example with long title in two raws',
          image: '//media.wickes.co.uk/is/image/wickes/M3549_144650_00?$largeNormal$&defaultImage=wickes/2018-Wickes-Missing-Product-650x650',
          itemTotal: '£3.00',
          quantity: 3,
        },
        {
          name: 'Bosch PSB 1800 LI-2 18V Li-Ion Cordless Combi Drill Example with long title in two raws',
          image: '//media.wickes.co.uk/is/image/wickes/R1478_131881_00?$largeNormal$&defaultImage=wickes/2018-Wickes-Missing-Product-650x650',
          itemTotal: '£3.00',
          quantity: 3,
        },
        {
          name: 'Bosch PSB 1800 LI-2 18V Li-Ion Cordless Combi Drill Example with long title in two raws',
          image: '//media.wickes.co.uk/is/image/wickes/B3182_154100_00?$largeNormal$&defaultImage=wickes/2018-Wickes-Missing-Product-650x650',
          itemTotal: '£3.00',
          quantity: 3,
        },
        {
          name: 'Bosch PSB 1800 LI-2 18V Li-Ion Cordless Combi Drill Example with long title in two raws',
          image: '//media.wickes.co.uk/is/image/wickes/R1478_131882_00?$largeNormal$&defaultImage=wickes/2018-Wickes-Missing-Product-650x650',
          itemTotal: '£3.00',
          quantity: 3,
        },
        {
          name: 'Bosch PSB 1800 LI-2 18V Li-Ion Cordless Combi Drill Example with long title in two raws',
          image: '//media.wickes.co.uk/is/image/wickes/T3274_103040_00?$largeNormal$&defaultImage=wickes/2018-Wickes-Missing-Product-650x650',
          itemTotal: '£3.00',
          quantity: 3,
        },
        {
          name: 'Bosch PSB 1800 LI-2 18V Li-Ion Cordless Combi Drill Example with long title in two raws',
          image: '//media.wickes.co.uk/is/image/wickes/T3274_103015_00?$largeNormal$&defaultImage=wickes/2018-Wickes-Missing-Product-650x650',
          itemTotal: '£3.00',
          quantity: 3,
        },
        {
          name: 'Bosch PSB 1800 LI-2 18V Li-Ion Cordless Combi Drill Example with long title in two raws',
          image: '//media.wickes.co.uk/is/image/wickes/T3274_103043_00?$largeNormal$&defaultImage=wickes/2018-Wickes-Missing-Product-650x650',
          itemTotal: '£3.00',
          quantity: 3,
        },
        {
          name: 'Bosch PSB 1800 LI-2 18V Li-Ion Cordless Combi Drill Example with long title in two raws',
          image: '//media.wickes.co.uk/is/image/wickes/O0032_109450_00?$largeNormal$&defaultImage=wickes/2018-Wickes-Missing-Product-650x650',
          itemTotal: '£3.00',
          quantity: 3,
        },
        {
          name: 'Bosch PSB 1800 LI-2 18V Li-Ion Cordless Combi Drill Example with long title in two raws',
          image: '//media.wickes.co.uk/is/image/wickes/O0032_109451_00?$largeNormal$&defaultImage=wickes/2018-Wickes-Missing-Product-650x650',
          itemTotal: '£3.00',
          quantity: 3,
        },
        {
          name: 'Bosch PSB 1800 LI-2 18V Li-Ion Cordless Combi Drill Example with long title in two raws',
          image: '//media.wickes.co.uk/is/image/wickes/GPID_5000030119_00?$largeNormal$&defaultImage=wickes/2018-Wickes-Missing-Product-650x650',
          itemTotal: '£3.00',
          quantity: 3,
        },
        {
          name: 'Bosch PSB 1800 LI-2 18V Li-Ion Cordless Combi Drill Example with long title in two raws',
          image: '//media.wickes.co.uk/is/image/wickes/X0041_165857_00?$largeNormal$&defaultImage=wickes/2018-Wickes-Missing-Product-650x650',
          itemTotal: '£3.00',
          quantity: 3,
        },
        {
          name: 'Bosch PSB 1800 LI-2 18V Li-Ion Cordless Combi Drill Example with long title in two raws',
          image: '//media.wickes.co.uk/is/image/wickes/R0486_180900_00?$largeNormal$&defaultImage=wickes/2018-Wickes-Missing-Product-650x650',
          itemTotal: '£3.00',
          quantity: 3,
        },
      ],
    },
  }
}

function returnSuccessCreatePayload() {
  return {
    currentProjectList: {
      name: 'Loremipsumdolorsitamet,consecteturadipiscingelit,seddoeiusmodtemporincididuntutlaboreetdoloremagnaaliqua.Utenimadminimveniam',
      id: 123,
      link: '/page_my-shopping-list.html',
      isFull: true,
      products: [
        {
          name: 'BoschPSB1800LI218VLiIonCordlessCombiDrillExamplewithlongtitleintworaws',
          image: '//media.wickes.co.uk/is/image/wickes/B3182_221100_00?$largeNormal$&defaultImage=wickes/2018-Wickes-Missing-Product-650x650',
          itemTotal: '£2.00',
          quantity: 1,
        },
        {
          name: 'Bosch PSB 1800 LI-2 18V Li-Ion Cordless Combi Drill Example with long title in two raws',
          image: '//media.wickes.co.uk/is/image/wickes/B3182_224661_00?$largeNormal$&defaultImage=wickes/2018-Wickes-Missing-Product-650x650',
          itemTotal: '£1.00',
          quantity: 2,
        },
        {
          name: 'Bosch PSB 1800 LI-2 18V Li-Ion Cordless Combi Drill Example with long title in two raws',
          image: '//media.wickes.co.uk/is/image/wickes/M3549_144650_00?$largeNormal$&defaultImage=wickes/2018-Wickes-Missing-Product-650x650',
          itemTotal: '£3.00',
          quantity: 3,
        },
        {
          name: 'Bosch PSB 1800 LI-2 18V Li-Ion Cordless Combi Drill Example with long title in two raws',
          image: '//media.wickes.co.uk/is/image/wickes/R1478_131881_00?$largeNormal$&defaultImage=wickes/2018-Wickes-Missing-Product-650x650',
          itemTotal: '£3.00',
          quantity: 3,
        },
        {
          name: 'Bosch PSB 1800 LI-2 18V Li-Ion Cordless Combi Drill Example with long title in two raws',
          image: '//media.wickes.co.uk/is/image/wickes/B3182_154100_00?$largeNormal$&defaultImage=wickes/2018-Wickes-Missing-Product-650x650',
          itemTotal: '£3.00',
          quantity: 3,
        },
        {
          name: 'Bosch PSB 1800 LI-2 18V Li-Ion Cordless Combi Drill Example with long title in two raws',
          image: '//media.wickes.co.uk/is/image/wickes/R1478_131882_00?$largeNormal$&defaultImage=wickes/2018-Wickes-Missing-Product-650x650',
          itemTotal: '£3.00',
          quantity: 3,
        },
        {
          name: 'Bosch PSB 1800 LI-2 18V Li-Ion Cordless Combi Drill Example with long title in two raws',
          image: '//media.wickes.co.uk/is/image/wickes/T3274_103040_00?$largeNormal$&defaultImage=wickes/2018-Wickes-Missing-Product-650x650',
          itemTotal: '£3.00',
          quantity: 3,
        },
        {
          name: 'Bosch PSB 1800 LI-2 18V Li-Ion Cordless Combi Drill Example with long title in two raws',
          image: '//media.wickes.co.uk/is/image/wickes/T3274_103015_00?$largeNormal$&defaultImage=wickes/2018-Wickes-Missing-Product-650x650',
          itemTotal: '£3.00',
          quantity: 3,
        },
        {
          name: 'Bosch PSB 1800 LI-2 18V Li-Ion Cordless Combi Drill Example with long title in two raws',
          image: '//media.wickes.co.uk/is/image/wickes/T3274_103043_00?$largeNormal$&defaultImage=wickes/2018-Wickes-Missing-Product-650x650',
          itemTotal: '£3.00',
          quantity: 3,
        },
        {
          name: 'Bosch PSB 1800 LI-2 18V Li-Ion Cordless Combi Drill Example with long title in two raws',
          image: '//media.wickes.co.uk/is/image/wickes/O0032_109450_00?$largeNormal$&defaultImage=wickes/2018-Wickes-Missing-Product-650x650',
          itemTotal: '£3.00',
          quantity: 3,
        },
        {
          name: 'Bosch PSB 1800 LI-2 18V Li-Ion Cordless Combi Drill Example with long title in two raws',
          image: '//media.wickes.co.uk/is/image/wickes/O0032_109451_00?$largeNormal$&defaultImage=wickes/2018-Wickes-Missing-Product-650x650',
          itemTotal: '£3.00',
          quantity: 3,
        },
        {
          name: 'Bosch PSB 1800 LI-2 18V Li-Ion Cordless Combi Drill Example with long title in two raws',
          image: '//media.wickes.co.uk/is/image/wickes/GPID_5000030119_00?$largeNormal$&defaultImage=wickes/2018-Wickes-Missing-Product-650x650',
          itemTotal: '£3.00',
          quantity: 3,
        },
        {
          name: 'Bosch PSB 1800 LI-2 18V Li-Ion Cordless Combi Drill Example with long title in two raws',
          image: '//media.wickes.co.uk/is/image/wickes/X0041_165857_00?$largeNormal$&defaultImage=wickes/2018-Wickes-Missing-Product-650x650',
          itemTotal: '£3.00',
          quantity: 3,
        },
        {
          name: 'Bosch PSB 1800 LI-2 18V Li-Ion Cordless Combi Drill Example with long title in two raws',
          image: '//media.wickes.co.uk/is/image/wickes/R0486_180900_00?$largeNormal$&defaultImage=wickes/2018-Wickes-Missing-Product-650x650',
          itemTotal: '£3.00',
          quantity: 3,
        },
      ],
    },
    projectListLength: 10,
    maxAmountOfProjects: 2,
  }
}

function returnSuccessGetPayload(currentPage) {
  return {
    currentPage: currentPage,
    pagesLength: 101,
    projectLists: [
      {
        name: `Bathroom ${currentPage}`,
        id: "bathroom",
        isFull: true,
      },
      {
        name: `Dining room ${currentPage}`,
        id: "dining-room",
        isFull: false
      }, {
        name: `Driveway ${currentPage}`,
        id: "driveway",
        isFull: false
      },
      {
        name: `Floors ${currentPage}`,
        id: "floors",
        isFull: false
      },
      {
        name: `Garage ${currentPage}`,
        id: "garage",
        isFull: true,
      },
      {
        name: `Garden ${currentPage}`,
        id: "garden",
        isFull: false
      },
      {
        name: `Garden shed ${currentPage}`,
        id: "garden-shed",
        isFull: false
      },
      {
        name: `Gym ${currentPage}`,
        id: "gym",
        isFull: false
      },
      {
        name: `Kids room ${currentPage}`,
        id: "kids-room",
        isFull: false
      },
      {
        name: `Kitchen update ${currentPage}`,
        id: "kitchen-update",
        isFull: false
      },
      {
        name: `Living room ${currentPage}`,
        id: "living-room",
        isFull: false
      },
      {
        name: `Paint ${currentPage}`,
        id: "paint",
        isFull: true,
      }
    ],
  }
}

$(document).ready(function () {
  function init() {
    if (!$('.shop-list-modal').length) {
      return;
    }

    $(Wick.SavingShoppingList.el.modalSavingToShopList).on('show.bs.modal', Wick.SavingShoppingList.init);
    $(window).on(Wick.SavingShoppingList.CREATE_PROJECT_LIST_EVENT, function (e) {
      setTimeout(() => {
        e.detail.payload.projectListName.length >= 5
          ? e.detail.resolve(returnSuccessCreatePayload())
          : e.detail.reject(returnErrorCreatePayload());
      }, 1000);

    });
    $(window).on(Wick.SavingShoppingList.SELECT_PROJECT_LIST_EVENT, function (e) {
      setTimeout(() => {
        e.detail.payload.projectListId === "dining-room"
          ? e.detail.reject(returnErrorSelectPayload())
          : e.detail.resolve(returnSuccessSelectPayload())
      }, 1000);
    });
    $(window).on(Wick.SavingShoppingList.GET_PROJECT_LISTS_EVENT, function (e) {
      setTimeout(() => {
        e.detail.payload.page === 4
          ? e.detail.reject(returnErrorSelectPayload())
          : e.detail.resolve(returnSuccessGetPayload(e.detail.payload.page))
      }, 1000);
    });
  }

  init();
});

function initProjectShadowList() {
  $('.download-pdf').on('click', emulateDownloadAction);
}

function emulateDownloadAction(e) {
  e.preventDefault();

  let currentUrl = window.location.href;
  let baseUrl = currentUrl.substring(0, currentUrl.lastIndexOf('/') + 1);
  let pageShoppingListPDF = baseUrl + 'page_my-shopping-list-pdf.html';

  $.ajax({
      type: 'get',
      url: pageShoppingListPDF,
    })
    .done(function (data) {
      const opt = {
        margin: 1,
        filename: 'test',
        image: { type: 'jpeg', quality: 0.98 },
        pagebreak: { avoid: '.order-line-shop-list' },
        html2canvas: { scale: 2, useCORS: true },
        jsPDF: { unit: 'mm', precision: 2 },
      };

      html2pdf().from(data).set(opt).save();
    });
}

function loadScriptWithJQuery(url, attrs) {
  const script = $('<script>');
  script.attr('src', url);

  if (attrs) {
    for (let key in attrs) {
      if (attrs.hasOwnProperty(key)) {
        script.attr(key, attrs[key]);
      }
    }
  }

  $('body').append(script);
}

const html2PdfScriptAttributes = {
  'integrity': 'sha512-1qLXyA3x0VSWeM+8vOotn6+KIRGdcQ8QMzsNeDXmdJsUAnoDGjzlxzqAuUGJGrGkGrtOrq4buDoAHxR89D9PWA==',
  'crossorigin': 'anonymous',
  'referrerpolicy': 'no-referrer',
};

$(document).ready(function () {
  if (!$('.download-pdf').length) {
    return;
  }
  loadScriptWithJQuery('https://cdnjs.cloudflare.com/ajax/libs/html2pdf.js/0.9.3/html2pdf.bundle.min.js', html2PdfScriptAttributes);
  initProjectShadowList();
});

var Wick = Wick || {};
Wick.ReferenceField = (function () {
    var refVar = {
        $ref: $('.ref'),
        $checkbox: $('#ref-add'),
        $checkboxLabel: $('.ref__add-label'),
        $inputLabel: $('.ref__add-text'),
        $info: $('.ref__info'),
        $input: $('.ref__input'),
        $link: $('.ref__link'),
        $count: $('.ref__count'),
        $remove: $('.ref__remove'),
        $countValue: $('.ref__count-val'),
        $refField: $('.ref__field'),
        infoHide: 'ref__info_hide',
        countHide: 'ref__count_hide',
        removeHide: 'ref__remove_hide',
        countMax: 'ref__count_max',
        checkboxLabelHide: 'ref__add-label_hide',
        refFieldError: 'ref__field_error',
        refWide: 'ref_wide',
        maxInputLength: 50,
    };

    function init() {
        var inputValue;

        refVar.$countValue.text(refVar.maxInputLength);

        refVar.$checkbox.on('click', function () {
            if (refVar.$checkbox.attr('checked') === 'checked') {
                refVar.$checkbox.attr('checked', false);
                refVar.$info.addClass(refVar.infoHide);
            } else {
                refVar.$checkbox.attr('checked', 'checked');
                refVar.$info.removeClass(refVar.infoHide);
                refVar.$refField.removeClass(refVar.refFieldError);
                refVar.$countValue.text(refVar.maxInputLength);
                refVar.$input.val('');
            }
        });

        refVar.$input.on('input', function () {
            var currentLength = $(this).val().length,
                left = refVar.maxInputLength - currentLength;

            refVar.$refField.removeClass(refVar.refFieldError);

            if (currentLength < refVar.maxInputLength) {
                refVar.$count.removeClass(refVar.countMax);
            } else {
                refVar.$count.addClass(refVar.countMax);
            }

            inputValue = $(this).val();
            refVar.$countValue.text(left);
        });

        refVar.$link.on('click', function (e) {
            e.preventDefault();
            var linkText = $(this).text().toLowerCase().trim();

            refVar.$refField.removeClass(refVar.refFieldError);

            if (refVar.$input.val().length > 0) {
                refVar.$count.addClass(refVar.countHide);
                refVar.$input.attr('disabled', 'disabled');

                if (linkText === 'save') {
                    $(this).text('edit');
                    refVar.$remove.removeClass(refVar.removeHide);
                    refVar.$checkboxLabel.addClass(refVar.checkboxLabelHide);
                    refVar.$inputLabel.text('Project Reference');

                    if ($(window).width() < 767) {
                        refVar.$ref.addClass(refVar.refWide);
                    }
                }

                else if (linkText === 'edit') {
                    refVar.$count.removeClass(refVar.countHide);
                    refVar.$input.removeAttr('disabled').focus();
                    $(this).text('save');
                    refVar.$inputLabel.text('Add Project Reference');
                }
            }
            else {
                refVar.$refField.addClass(refVar.refFieldError);
            }
        });

        refVar.$remove.click('click', function (e) {
            e.preventDefault();
            refVar.$link.text('save');
            refVar.$input.val('');
            inputValue = '';
            refVar.$remove.addClass(refVar.removeHide);
            refVar.$refField.removeClass(refVar.refFieldError);
            refVar.$checkboxLabel.removeClass(refVar.checkboxLabelHide);
            refVar.$countValue.text(refVar.maxInputLength);
            refVar.$checkbox.trigger('click');
            refVar.$ref.removeClass(refVar.refWide);
            refVar.$count.removeClass(refVar.countHide);
            refVar.$input.removeAttr('disabled').focus();
            refVar.$inputLabel.text('Add Project Reference');
        });
    }

    if (!refVar.$ref.length) {
        return;
    }

    init();
})();

var Wick = Wick || {};
Wick.Selectable = (function(){
  $selectable = $('.js-selectable'),
    selected = 'js-selectable_selected';

  function bindEvents() {
    $selectable.on('click', function(e){
      var $action = $(e.target).closest('a, button, input, .rbn');

      if ($action.length || $(this).hasClass(selected)){
        return;
      }

      $selectable.removeClass(selected);
      $(this).addClass(selected);

      $('.user-address__wrapper .btn-delivery-details').insertAfter('.js-selectable_selected');
    });
  }

  if (!$selectable.length){
    return;
  }

  bindEvents();
})();

var Wick = Wick || {};

Wick.ShoppingList = {
    bindAll : function () {
        Wick.ShoppingList.bindButtons();
    },

    bindButtons : function () {
        $('.btn-share-confirmation .btn-primary').on('click', function (e) {
            e.preventDefault();
            $('#share-via-email').prop('required', false);
            Wick.ShoppingList.submitSharingShoppingList();
        });
    },

    submitSharingShoppingList : function () {
        var forms = Wick.ShoppingList.getRecipientEmailsForms();

        if (Wick.ShoppingList.isFormsValid(forms)) {
            Wick.ShoppingList.onSuccessSharingShoppingList();
        }
    },

    onSuccessSharingShoppingList : function () {
        Wick.ShoppingList.resetFormErrors();
    },

    getRecipientEmailsForms : function () {
        var forms = new Array();

        forms.push($('#share-via-email'));
        $('.share-via-email-box').each(function () {
            forms.push($(this).find('[type="email"]'));
        });

        return forms;
    },

    isFormsValid : function (forms) {
        var oneFieldFilledIn = false;

        forms.forEach(function(form) {
            if ($(form).val() !== '') {
                oneFieldFilledIn = true;
            }
        });

        if (!oneFieldFilledIn) {
            Wick.ShoppingList.showEmptyFormsWarning(forms[0]);
            return false;
        }

        var isFormsValid = true;

        forms.forEach(function(form) {
            console.log(form[0]);
            if (!form[0].checkValidity()) {
                Wick.ShoppingList.showInvalidEmailWarning(form);
                isFormsValid = false;
            }
        });

        return isFormsValid;
    },

    showEmptyFormsWarning : function (form) {
        form.prop('required', true);

        try {
            form.get(0).reportValidity();
        } catch (e) {
            Wick.ShoppingList.resetFormErrors();

            form.closest('.form-row').addClass('form-row_validation-error');
            form.closest('.form-row__field').append('<div class="form-row__error">Please fill in the field</div>');
        }
    },

    showInvalidEmailWarning : function (form) {
        try {
            form.get(0).reportValidity();
        } catch (e) {
            Wick.ShoppingList.resetFormErrors();

            form.closest('.form-row').addClass('form-row_validation-error');
            form.closest('.form-row__field').append('<div class="form-row__error">Please fill in the field</div>');
        }
    },

    resetFormErrors: function () {
        $('#share-list-form .form-row').each(function() {
            $(this).removeClass('form-row_validation-error');
            $(this).find('.form-row__error').remove();
        });
    }
};



$(document).ready(function() {
    Wick.ShoppingList.bindAll();
});

var Wick = Wick || {};
Wick.SignUp = (function () {
  var $signUpForm = $('#sign-up-form'),
    $signUpWrap = $('#sign-up-wrapper');

  function validateEmail (argElementValue) {
    var emailPattern = /^[a-zA-Z0-9._-]+@[a-zA-Z0-9.-]+\.[a-zA-Z]{2,4}$/;
    return emailPattern.test(argElementValue);
  }

  function showValidMessage () {
    if ($signUpWrap.hasClass('sign-up_invalid')) {
      $signUpWrap.removeClass('sign-up_invalid');
    }
    $signUpWrap.addClass('sign-up_valid')
  }

  $signUpForm.on('submit', function (e) {
    e.preventDefault();

    var inputValue = $('#sign-up-email').val();

    validateEmail(inputValue)
      ? showValidMessage()
      : $signUpWrap.addClass('sign-up_invalid');

    return false;
  });
})();



//TODO: needs refactoring in future, gather tother with range-type.js for common script
var Wick = Wick || {};

Wick.StoreLocator = (function () {
  var $button = $('.store-locator__load-button'),
    cardsListOpenClass = 'cards-store-list_open',
    $cardsList = $('.cards-store-wrapper'),
    $buttons = $cardsList.find($button);

  $buttons.on('click', function () {
    if ($cardsList.hasClass(cardsListOpenClass)) {
      $('html, body').scrollTop($cardsList.parents('.cards-store-holder').offset().top + 20);
    }
    $cardsList.toggleClass(cardsListOpenClass);
    $buttons.toggle();
  });
})();



var Wick = window.Wick || {};
Wick.Calendar = {
    el: {
        switchBtn: '.calendar__switch',
        switchBtnLatest: 'calendar__switch-latest',
        switchBtnEarlier: 'calendar__switch-earlier',
        componentDateSection: '.component-date-selection',
        dateSection: '.date-selection',
        dateSectionHidden: 'date-selection-hidden',
    },
    SwitchCalendar: function () {
        let $currentCalendar = $(this).closest(Wick.Calendar.el.dateSection);

        $currentCalendar.addClass(Wick.Calendar.el.dateSectionHidden);

        if ($(this).hasClass(Wick.Calendar.el.switchBtnEarlier)) {
            $currentCalendar = $currentCalendar.prev();
            $currentCalendar.removeClass(Wick.Calendar.el.dateSectionHidden);

        } else if ($(this).hasClass(Wick.Calendar.el.switchBtnLatest)) {
            $currentCalendar = $currentCalendar.next(Wick.Calendar.el.dateSection);
            $currentCalendar.removeClass(Wick.Calendar.el.dateSectionHidden);
        }
    },

};

$(document).ready(function () {
    function init() {

        if (Wick.checkLocalEnv) {
            $(Wick.Calendar.el.componentDateSection).on('click', Wick.Calendar.el.switchBtn, Wick.Calendar.SwitchCalendar);
        }
    }

    function unbind() {
        $(Wick.Calendar.el.componentDateSection).unbind('click');
    }

    init();

    $(window).on('resize', _.debounce(function () {
        unbind();
        init();
    }, 250));
});

var Wick = Wick || {};

Wick.addListToBasket = {
  el: {
    addProjectList: $('#addAllToCartForm'),
  },
  loader: new Wick.Loader('.total-amount__item-submit'),
  addAllProjectList() {
    Wick.addListToBasket.el.addProjectList.on('click', function () {
      Wick.addListToBasket.loader.showLoader();

      setTimeout(() => Wick.addListToBasket.loader.hideLoader(),1000)
    });
  },
}

$(document).ready(() => {
  Wick.addListToBasket.addAllProjectList();
})

var Wick = Wick || {};
Wick.User = (function(){
  function isLoggedIn() {
    return localStorage.isLoggedin === 'true';
  }

  function login() {
    localStorage.isLoggedin = true;
  }

  function logout() {
    localStorage.isLoggedin = false;
  }

  function bindEvents() {
    $('.link-logout').on('click', logout);
  }

  function setLoginState() {
    $('body').attr('data-is-logged-in', isLoggedIn());
  }

  var init = function () {
    bindEvents();
    setLoginState();
  };

  init();

  return {
    login: function(){
      login();
      setLoginState();
    },
    logout: function(){
      logout();
      setLoginState();
    },
    isLoggedIn: isLoggedIn
  };
})();

var Wick = Wick || {};

Wick.Wismo = (function () {
    Wick.SnackBar.init();
    var $buyBtn = $('.wismo-order__action').find('.btn');

    $buyBtn.on('click', function () {
        Wick.SnackBar.show(
            {
                text: 'Notification success message for Delivery with Autoclose',
                type: Wick.SnackBar.types.SUCCESS,
                withCloseButton: false,
                autoClose: true,
                delayBeforeClose: 3000
            }
        );
        Wick.SnackBar.show(
            {
                text: 'Notification warning message for Delivery with Close Btn',
                type: Wick.SnackBar.types.WARNING,
                withCloseButton: false,
                autoClose: true,
                delayBeforeClose: 1500
            }
        );
        Wick.SnackBar.show(
            {
                text: 'Notification error message for Delivery with Close Btn',
                type: Wick.SnackBar.types.ERROR,
                withCloseButton: false,
                autoClose: true,
                delayBeforeClose: 1500
            }
        );
    })
})();


